#!/bin/bash
###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################

# Subroutines

use_ssl_origin() {

	#retval="Stop by Debug."
	#return 1

	# Checking config files...

	local chg_ssl='1'
	local chg_ssl_wc='1'

	if [ ! -f "$SSL_CONF_DIR/ssl.conf.bak" ]; then
		if [ ! -f "$SSL_CONF_DIR/ssl.conf" ]; then
			retval="Both ssl.conf.bak and ssl.conf are not exsist."
			return 1
		else
			chg_ssl='0'
		fi
	fi
	if [ ! -f "$SSL_CONF_DIR/ssl_wc.conf" ]; then
		if [ ! -f "$SSL_CONF_DIR/ssl_wc.conf.bak" ]; then
			$retval="Both ssl_wc.conf and ssl_wc.conf.bak are not exsist."
			return 1
		else
			chg_ssl_wc='0'
		fi
	fi
	if [ $chg_ssl -eq 1 ]; then
		# Updating config file...(ssl.conf.bak -> ssl.conf)
		mv $SSL_CONF_DIR/ssl.conf.bak $SSL_CONF_DIR/ssl.conf || { retval="Rename failed.(ssl.conf.bak -> ssl.conf)"; return 1; }
	fi
	if [ $chg_ssl_wc -eq 1 ]; then
		# Updating config file...(ssl_wc.conf -> ssl_wc.conf.bak)
		mv $SSL_CONF_DIR/ssl_wc.conf $SSL_CONF_DIR/ssl_wc.conf.bak || { retval="Rename failed.(ssl_wc.conf -> ssl_wc.conf.bak)"; return 1; }
	fi

	# On bash, Success statsu -> 0
	return 0
}

use_ssl_wc() {

	#retval="Stop by Debug!."
	#return 1

	# Checking config files...

	local chg_ssl='1'
	local chg_ssl_wc='1'

	if [ ! -f "$SSL_CONF_DIR/ssl.conf" ]; then
		if [ ! -f "$SSL_CONF_DIR/ssl.conf.bak" ]; then
			retval="Both ssl.conf and ssl.conf.bak are not exsists"
			return 1
		else
			chg_ssl='0'
		fi
	fi
	if [ ! -f "$SSL_CONF_DIR/ssl_wc.conf.bak" ]; then
		if [ ! -f "$SSL_CONF_DIR/ssl_wc.conf" ]; then
			retval="Both ssl_wc.conf.bak and ssl_wc.conf are not exsist."
			return 1
		else
			chg_ssl_wc='0'
		fi
	fi
	if [ $chg_ssl -eq 1 ]; then
		# Updating config files...(ssl.conf -> ssl.conf.bak)
		mv $SSL_CONF_DIR/ssl.conf $SSL_CONF_DIR/ssl.conf.bak || { retval="Rename failed.(ssl.conf -> ssl.conf.bak)"; return 1; }
	fi
	if [ $chg_ssl_wc -eq 1 ]; then
		# Updating config files...(ssl_wc.conf.bak -> ssl_wc.conf)
		mv $SSL_CONF_DIR/ssl_wc.conf.bak $SSL_CONF_DIR/ssl_wc.conf || { retval="Rename failed.(ssl.conf.bak -> ssl.conf)"; return 1; }
	fi

	# On bash, Success statsu -> 0
	return 0
}

httpd_reload() {

	/etc/rc.d/init.d/httpd reload

}

# Define values
SSL_CONF_DIR='/etc/httpd/conf.d'

# Main
retval="0"
if   [ "$1" = "use_ssl_origin"  ]; then
	use_ssl_origin || { echo $retval; exit 1; }
elif [ "$1" = "use_ssl_wc" ];      then
	use_ssl_wc     || { echo $retval; exit 1; }
elif [ "$1" = "httpd_reload" ];     then
	httpd_reload
fi

exit


