#!/usr/bin/perl
###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package main;

use strict;
use lib qw(./ext_lib ./asp_opt);
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use CGI::Cookie;
use DBI;
use Mail::POP3Client;
use Unicode::Japanese;
use HTML::Template;
require './config.cgi';
require './lib/ver.pl';
require './lib/db.pl';
require './lib/get.pl';
require './lib/show.pl';
require './lib/check.pl';
require './lib/save.pl';
require './lib/proc.pl';
require './lib/cp.pl';
require './lib/asp.pl';
require './lib/item.pl';
require './lib/switch.pl';
require './lib/auto.pl';
require './lib/start.pl';
require './lib/default.pl';
require './lib/tbl.pl';
require './lib/ajax.pl';

$| = 1;
my $F = CGI->new();
# Save new variable exefiles
if($F->param('save_new_file_name')){
	&save::new_file_name();
	&show::start_page();
	exit;
}
&check::new_exe_file();
&db::open();
our ($auth,$login_id) = &proc::session();	# 1.86 PH OK
###### State
if(
	$F->param('mode') eq "show_state" ||
	$F->param('show_state') ne ""
){
	&show::state();
}
###### Base setting
elsif($F->param('mode') eq 'show_setting' || $F->param('show_setting')){
	&show::setting();
}
elsif($F->param('save_setting')){
	&check::setting();
	&save::setting();
	&show::state();
}
##### Return mail setting
elsif($F->param('mode') eq "show_return_list"){
	&show::return_list();
}
elsif($F->param('mode') eq "show_regi_msg_cont"){
	&show::regi_msg_cont();
}
elsif($F->param('save_regi_msg_cont') ne ""){
	&check::msg_cont();
	&save::regi_msg_cont();
	&show::return_list();
}
elsif($F->param('mode') eq "show_ulk_msg_cont"){
	&show::ulk_msg_cont();
}
elsif($F->param('save_ulk_msg_cont') ne ""){
	&check::msg_cont();
	&save::ulk_msg_cont();
	&show::return_list();
}
elsif($F->param('mode') eq "show_mdf_msg_cont"){
	&show::mdf_msg_cont();
}
elsif($F->param('save_mdf_msg_cont') ne ""){
	&check::msg_cont();
	&save::mdf_msg_cont();
	&show::return_list();
}
elsif($F->param('mode') eq "show_doi_msg_cont"){
	&show::doi_msg_cont();
}
elsif($F->param('save_doi_msg_cont') ne ""){
	&check::msg_cont();
	&save::doi_msg_cont();
	&show::return_list();
}
elsif($F->param('mode') eq "show_doi2_msg_cont"){
	&show::doi2_msg_cont();
}
elsif($F->param('save_doi2_msg_cont') ne ""){
	&check::msg_cont();
	&save::doi2_msg_cont();
	&show::return_list();
}
###### Import user
elsif($F->param('mode') eq 'show_import' || $F->param('show_import')){
	&check::essen_setting();
	&show::import();
}
elsif($F->param('import_users') ne ""){
	&proc::import_users();
}
###### Account setting
elsif(	$F->param('show_accounts')	||
		$F->param('mode') eq 'show_accounts'	){
	&check::demo();	# 1.81
	&show::accounts();
}
elsif($F->param('save_accounts') ne ""){
	&check::demo();	# 1.81
	&check::accounts2();
	&save::accounts();
	&show::state();
}
###### Attris
elsif($F->param('mode') eq "show_attri_list" ||
		$F->param('show_attri_list') ne ""){
	&show::attri_list();
}
elsif($F->param('mode') eq "show_attri"){
	my @d = &get::attri_data();
	&show::attri(@d);
}
elsif($F->param('new_attri') ne ""){
	&check::demo_limit('attri',10);	# 1.81
	&show::attri($F->param('new_attri_num'),"","");
}
elsif($F->param('save_attri') ne ""){
	&save::attri();
	&show::attri_list();
}
elsif($F->param('show_del_attri') ne ""){
	&check::attri();
	&show::del_attri();
}
elsif($F->param('save_del_attri') ne ""){
	&save::del_attri();
	&show::attri_list();
}

####### User's information
elsif($F->param('show_users') ne "" || $F->param('mode') eq "show_users"){
	&check::essen_setting();
	&check::refine_params();
	&show::users();
}
elsif($F->param('mode') eq "show_users_more"){
	&show::users_more();
}
elsif($F->param('mode') eq "show_users_clicked"){
	&show::users_clicked();
}
elsif($F->param('show_users_edit')){
	&show::users_edit();
}
elsif($F->param('save_users_edit')){
	&check::users_edit();
	&save::users_edit();
	&show::users();
}
elsif($F->param('show_operate_users') ne ""){
	&show::operate_users();
}
elsif($F->param('mode') eq 'new_user'){	# 1.76
	&check::demo_limit('user',5);
	&check::new_user();
	&show::users_edit();
}
######## User's edit in bulk
elsif($F->param('drop_and_black_users') ne ""){
	&proc::drop_and_black_users();
	&show::users();
}
elsif($F->param('drop_users') ne ""){
	&proc::drop_users();
	&show::users();
}
elsif($F->param('active_off_users') ne ""){
	&proc::active_off_users();
	&show::users();
}
elsif($F->param('active_on_users') ne ""){
	&proc::active_on_users();
	&show::users();
}
elsif($F->param('operate_points_users') ne ""){
	&proc::operate_points_users();
	&show::users();
}
elsif($F->param('operate_attri_users') ne ""){
	&proc::operate_attri_users();
	&show::users();
}
elsif($F->param('reset_err_users') ne ""){
	&proc::reset_err_users();
	&show::users();
}
elsif($F->param('operate_send_mail_users')){
	&proc::operate_send_mail_users();
}
######## CSV
elsif($F->param('show_csv') ne ""){
	&show::csv();
}
#elsif($F->param('print_csv') ne ""){
#	&get::csvdata();
#	&show::csvdata();
#}
elsif($F->param('show_csv_tpl') ne ""){
	&show::csv_tpl();
}
####### Regist form
elsif($F->param('mode') eq 'show_generator' || $F->param('show_generator')){
	&check::essen_setting();
	&show::generator();
}
elsif($F->param('show_form_setting')){
	&show::form_setting(0);
}
elsif($F->param('show_modify_form_setting')){
	&show::form_setting(1);
}
elsif($F->param('show_t_r_form_setting')){
	&show::form_setting(2);
}
elsif($F->param('save_form_setting') ne ""){
	&check::form_setting();
	&save::form_setting();
	&show::generator();
}
elsif($F->param('show_new_free_form')){
	&check::demo_limit('free_form',5);
	my %d = (
		'no' => $F->param('new_free_form_num'),
		'id' => $F->param('id')
	);
	&show::free_form_setting(\%d);
}
elsif($F->param('mode') eq 'show_free_form_setting'){
	my $d = &get::free_form_setting($F->param('no'));
	&show::free_form_setting($d);
}
elsif($F->param('save_free_form_setting')){
	&check::free_form_setting();
	&save::free_form_setting();
	&show::form_setting($F->param('modify'));
}
elsif($F->param('show_ready_del_free_form')){
	&check::del_free_form();
	&show::ready_del_free_form();
}
elsif($F->param('save_del_free_form')){
	&save::del_free_form();
	&show::form_setting($F->param('modify'));
}
####### Karame setting
elsif($F->param('mode') eq 'show_karame_setting' || $F->param('show_karame_setting')){
	&check::essen_setting();
	&show::karame_setting();
}
elsif($F->param('save_karame_setting')){
	&check::karame_setting();
	&save::karame_setting();
	&show::karame_setting();
}
####### Backnumber setting
elsif($F->param('mode') eq 'show_bcn_setting' || $F->param('show_bcn_setting')){
	&check::essen_setting();
	&check::bcn_path();
	&show::bcn_setting();
}
elsif($F->param('mode') eq 'show_bcn_prev'){
	&show::bcn_prev();
}
elsif($F->param('save_bcn_setting')){
	&save::bcn_setting();
	&show::bcn_setting();
}
####### Default view setting
elsif($F->param('mode') eq 'show_default_list' || $F->param('show_default_list')){
	&check::essen_setting();
	&show::default_list();
}
elsif($F->param('mode') eq 'show_default'){
	&show::default();
}
elsif($F->param('save_default')){
	&check::default();	# 1.80
	&save::default();
	&show::default();
}
####### Create & delete magazines
elsif($F->param('make_new_mag') ne ""){
	&check::demo_limit('mag',5);	# 1.81
	&show::new_mag();
}
elsif($F->param('del_mags') ne "" || $F->param('mode') eq 'del_mags'){
	&show::del_mags();
}
elsif($F->param('ready_del_mags') ne ""){
	&show::ready_del_mags();
}
elsif($F->param('not_del_mags') ne ""){
	&show::start_page();
}
elsif($F->param('save_del_mags') ne ""){
	&save::del_mags();
	&show::start_page();
}
elsif($F->param('save_new_mag') ne ""){
	&check::demo_limit('mag',5);	# 1.81
	#&check::mag_id();
	&check::new_mag();	# 1.85
	&save::new_mag();
	&show::start_page();
}
######### Story setting
elsif($F->param('show_operate_story')){	# 1.74
	&show::operate_story();
}
elsif($F->param('save_operate_story')){	# 1.74
	&check::agree_operate_story();
	&save::operate_story();
	&show::state();
}
elsif($F->param('new_story')){
	&check::demo_limit('story',5);	# 1.81
	&check::essen_setting();
	my %sd = (
		no			=> $F->param('new_sto_num'),
		sort_no	=> "（新規）",
		operating	=> 1	# 1.81
	);
	&show::story(\%sd);
}
elsif($F->param('show_confirm_story')){
	&check::story();
	&show::confirm_story();
}
elsif($F->param('save_story')){
	&check::agree_story();	# 1.78
	&check::story();
	&save::story();
	&show::state();
}
elsif($F->param('mode') eq "show_story"){
	my $sd = &get::story_data();
	&show::story($sd);
}
elsif($F->param('mode') eq 'copy_story'){
	&check::demo_limit('story',5);	# 1.81
	my $sd = &get::story_data();
	$$sd{no}        = $F->param('new_sto_num');
	$$sd{sort_no}   = "（新規）";
	$$sd{operate}   = 0;
	$$sd{operating} = 1;	# 1.81
	&show::story($sd);
}
elsif($F->param('show_del_story') ne ""){
	&show::del_story();
}
elsif($F->param('save_del_story') ne ""){
	&save::del_story();
	&show::state();
}
elsif($F->param('show_demo_story') ne ""){
	&check::story();
	&show::demo_story();
}
########## Extrta setting
elsif($F->param('show_operate_extra')){	# 1.74
	&show::operate_extra();
}
elsif($F->param('save_operate_extra')){	# 1.74
	&save::operate_extra();
	&show::state();
}
elsif($F->param('new_extra') ne ""){
	&check::demo_limit('extra',5);	# 1.81
	&check::essen_setting();
	my %ed = (
		'no' => $F->param('new_ext_num'),
		'sort_no' => "（新規）"	
	);
	&show::extra(\%ed);
}
elsif($F->param('show_reserve_extra') ne ""){
	&check::extra();
	&show::reserve_extra();
}
elsif($F->param('save_extra') ne ""){
	&check::agree_extra();	# 1.78
	# 1.76 ###################
	&check::session_token();
	&save::del_session_token();
	##########################
	&check::extra();	# 1.76
	&save::extra();
	&show::state();
}
elsif($F->param('mode') eq "show_extra"){
	my $ed = &get::extra_data();
	&show::extra($ed);
}
elsif($F->param('mode') eq "copy_extra"){
	&check::demo_limit('extra',5);	# 1.81
	my $ed = &get::extra_data();
	$$ed{no}      = $F->param('new_ext_num');
	$$ed{sort_no} = "（新規）";
	&show::extra($ed);
}
elsif($F->param('mode') eq "copy_his"){
	my $hd = &get::his_data(
		$F->param('id'),
		$F->param('his_no')
	);
	$$hd{no}      = $F->param('new_ext_num');
	$$hd{sort_no} = "（新規）";
	$$hd{body}    = $$hd{o_body};
	&show::extra($hd);
}
elsif($F->param('show_del_extra')){
	&show::del_extra();
}
elsif($F->param('save_del_extra')){
	# 1.76 ###################
	&check::session_token();
	&save::del_session_token();
	##########################
	&save::del_extra();
	&show::state();
}
elsif($F->param('show_demo_extra')){
	&check::extra();
	&show::demo_extra();
}
elsif($F->param('show_imme')){
	&check::extra();
	&show::imme_extra();
}
elsif($F->param('save_draft_extra')){
	&save::draft_extra();
	&show::state();
}
elsif($F->param('mode') eq 'show_filtered_users'){
	&show::filtered_users();
}
######### Individual setting
elsif($F->param('show_operate_indiv')){	# 1.74
	&show::operate_indiv();
}
elsif($F->param('save_operate_indiv')){	# 1.74
	&save::operate_indiv();
	&show::state();
}
elsif($F->param('new_indiv')){
	&check::demo_limit('indiv',5);	# 1.81
	&check::essen_setting();
	&show::new_indiv($F->param('new_ind_num'));
}
elsif($F->param('show_demo_new_indiv')){
	&check::indiv();
	&show::demo_new_indiv();
}
elsif($F->param('save_indiv')){
	&save::indiv();
	&show::save_indiv_done();
}
elsif($F->param('mode') eq 'show_indiv'){
	&show::indiv();
}
elsif($F->param('save_indiv_users')){
	&check::indiv_users();
	&save::indiv_users();
	&show::indiv();
}
elsif($F->param('show_mailtext')){
	&show::mailtext();
}
elsif($F->param('show_del_indiv')){
	&show::del_indiv();
}
elsif($F->param('save_del_indiv')){
	&save::del_indiv();
	&show::state();
}
######### Start delivery
elsif($F->param('start_imme')){
	&check::agree_extra();	# 1.78
	# 1.75 ###################
	&check::session_token();
	&save::del_session_token();
	##########################
	&start::imme();
}
elsif($F->param('start_test')){
	# 1.80 ###################
	#&check::test_add();
	&check::test();
	##########################
	&start::test();
}
######### History
elsif($F->param('mode') eq "show_his_list"){
	&show::his_list();
}
elsif($F->param('mode') eq "show_his_list_gbs"){
	&show::his_list_gbs();
}
elsif($F->param('mode') eq "show_his_more"){
	&show::his_more();
}
elsif($F->param('mode') eq "show_his_more_gbs"){
	&show::his_more_gbs();
}
elsif($F->param('mode') eq "show_err_users"){
	&show::err_users();
}
elsif($F->param('mode') eq "show_his_delivered"){
	&show::his_delivered();
}
elsif($F->param('mode') eq "show_his_clicked"){
	&show::his_clicked();
}
elsif($F->param('mode') eq "show_his_clicked_eu"){
	&show::his_clicked_eu();
}
elsif($F->param('mode') eq "show_his_opened"){
	&show::his_opened();
}
elsif($F->param('mode') eq "show_his_log"){
	&show::his_log();
}
elsif($F->param('show_operate_his') ne ""){
	&show::operate_his();
}
elsif($F->param('save_del_his') ne ""){
	&save::del_his();
	&show::his_list();
}
elsif($F->param('mode') eq 'show_operate_his_delivery'){	# 1.77
	&check::operate_his_delivery();
	&show::operate_his_delivery();
}
elsif($F->param('save_operate_his_delivery')){	# 1.77
	&check::session_token();
	&save::del_session_token();
	&check::operate_his_delivery();
	require './lib/idms.pl';
	&save::operate_his_delivery();
	&show::his_list();
}
######### Change type etc
elsif($F->param('mode') eq "ch_type"){
	&show::start_page();
}
elsif($F->param('mode') eq "login"){
	&proc::login();	# 1.86 PH OK
	&show::start_page();
}
elsif($F->param('mode') eq "logout"){
	&proc::logout();	# 1.86 PH OK
	&show::login_page("ログアウトしました	");
}
######### Sort magazine list
elsif($F->param('list_sort')){
	&save::list_sort_cookie();
	&show::start_page();
}
######### Original tag
elsif($F->param('mode') eq "show_original_tag_list" || $F->param('show_original_tag_list') ne ""){
	&show::original_tag_list();
}
elsif($F->param('mode') eq "show_original_tag"){
	my @d = &get::original_tag();
	&show::original_tag(@d);
}
elsif($F->param('show_new_original_tag') ne ""){
	&check::demo_limit('original_tag',10);	# 1.81
	my $no = &get::original_tag_maxno() + 1;
	&show::original_tag($no,"","");
}
elsif($F->param('save_original_tag') ne ""){
	&check::original_tag1();
	&save::original_tag();
	&show::original_tag_list();
}
elsif($F->param('show_del_original_tag') ne ""){
	&check::original_tag2();
	&show::del_original_tag();
}
elsif($F->param('save_del_original_tag') ne ""){
	&save::del_original_tag();
	&show::original_tag_list();
}
######### Action log
elsif($F->param('mode') eq "show_action_log"){
	&show::action_log();
}
######### Unkown bounce
elsif($F->param('mode') eq "show_unknown_list"){
	&show::unknown_list();
}
elsif($F->param('mode') eq "show_unknown"){
	&show::unknown();
}
######### Body template 
elsif($F->param('mode') eq "show_bodytpl_list"){
	&show::bodytpl_list();
}
elsif($F->param('show_new_bodytpl')){
	&check::demo_limit('bodytpl',10);	# 1.81
	&show::bodytpl({
		no => &get::bodytpl_maxno() + 1
	});
}
elsif($F->param('save_bodytpl')){
	&check::define();
	&save::bodytpl();
	&show::bodytpl_list();
}
elsif($F->param('mode') eq "show_bodytpl"){
	&show::bodytpl(&get::bodytpl($F->param('no')));
}
elsif($F->param('show_ready_del_bodytpl')){
	&show::ready_del_bodytpl();
}
elsif($F->param('save_del_bodytpl') ne ""){
	&save::del_bodytpl();
	&show::bodytpl_list();
}
######### Define header&footer
elsif($F->param('mode') eq "show_define_list"){
	&show::define_list();
}
elsif($F->param('mode') eq "show_define_header"){
	&show::define_header(&get::define_header($F->param('no')));
}
elsif($F->param('mode') eq "show_define_footer"){
	&show::define_footer(&get::define_footer($F->param('no')));
}
elsif($F->param('new_header')){
	&check::demo_limit('header',10);	# 1.81
	&show::define_header({
		no => $F->param('new_header_num')
	});
}
elsif($F->param('new_footer')){
	&check::demo_limit('footer',10);	# 1.81
	&show::define_footer({
		no => $F->param('new_footer_num')
	});
}
elsif($F->param('save_define_header') ne ""){
	&check::define();
	&save::define_header();
	&show::define_list();
}
elsif($F->param('save_define_footer') ne ""){
	&check::define();
	&save::define_footer();
	&show::define_list();
}
elsif($F->param('ready_del_define_header') ne ""){
	&check::del_define_header();
	&show::ready_del_define_header();
}
elsif($F->param('ready_del_define_footer') ne ""){
	&check::del_define_footer();
	&show::ready_del_define_footer();
}
elsif($F->param('save_del_define_header') ne ""){
	&save::del_define_header();
	&show::define_list();
}
elsif($F->param('save_del_define_footer') ne ""){
	&save::del_define_footer();
	&show::define_list();
}
elsif($F->param('not_del_define') ne ""){
	&show::define_list();
}
####### Author setting
elsif($F->param('mode') eq "show_author_list"){
	&show::author_list();
}
elsif($F->param('mode') eq "show_author"){
	my $d = &get::author();
	&show::author($d,$auth,$login_id);
}
elsif($F->param('show_new_author') ne ""){
	my $no = &get::author_maxno();
	$no++;
	my %d = ('no' => $no);
	&show::author(\%d,$auth,$login_id);
}
elsif($F->param('save_author')){
	&check::demo();
	&check::author();
	&save::author();
	&show::author_list();
}
elsif($F->param('show_del_author')){
	my $d = &get::author();						# 1.83
	&check::del_author($d,$auth,$login_id);	# 1.83
	&show::del_author($d,$auth,$login_id);
}
elsif($F->param('save_del_author') ne ""){
	my $d = &get::author();						# 1.83
	&check::del_author($d,$auth,$login_id);	# 1.83
	&save::del_author();
	&show::author_list();
}
######### SMTP setting  1.64～
elsif($F->param('mode') eq "show_smtp_list"){
	&show::smtp_list();
}
elsif($F->param('show_new_smtp')){
	&check::demo_limit('smtp',10);	# 1.81
	&show::smtp({
		no => &get::smtp_maxno() + 1
	});
}
elsif($F->param('save_smtp')){
	&check::smtp();
	&save::smtp();
	&show::smtp_list();
}
elsif($F->param('mode') eq "show_smtp"){
	&show::smtp(&get::smtp($F->param('no')));
}
elsif($F->param('show_ready_del_smtp')){
	&show::ready_del_smtp();
}
elsif($F->param('save_del_smtp') ne ""){
	&save::del_smtp();
	&show::smtp_list();
}
####### Image setting
elsif(	$F->param('mode') eq "show_image_list"	||
		$F->param('show_image_list')){
	&show::image_list();
}
elsif($F->param('show_image_upload')){
	&check::demo_limit('img',10);	# 1.81
	&show::image_upload();
}
elsif($F->param('image_upload')){
	&check::demo_limit('img',10);	# 1.81
	&check::upload();
	&proc::upload();
	&show::image_list();
}
elsif($F->param('show_ready_del_image')){
	&check::del_image();
	&show::ready_del_image();
}
elsif($F->param('save_del_image')){
	&save::del_image();
	&show::image_list();
}
####### Backup
elsif($F->param('mode') eq "show_backup"){
	&show::backup();
}
elsif($F->param('proc_backup')){
	&check::demo();	# 1.81
	&proc::backup();
}
###### Restore
elsif($F->param('mode') eq "show_restore"){
	&show::restore();
}
elsif($F->param('upload') ne ""){
	&check::demo();	# 1.81
	&check::upload();
	&proc::upload();
	&show::ready_restore();
}
elsif($F->param('proc_restore')){
	&proc::restore();
	&show::done_restore();
}
elsif($F->param('cancel_restore')){
	&proc::cancel_restore();
	&show::restore();
}
###### Rebuild DB
elsif(	$F->param('mode') eq 'show_rebuild_db'	||
		$F->param('show_rebuild_db')){
	&show::rebuild_db();
}
elsif($F->param('proc_rebuild_db')){
	&proc::version_up_db();
}
###### Version up
elsif(	$F->param('mode') eq "show_version" ||
		$F->param('show_version')
){
	&show::version();
}
elsif($F->param('mode') eq 'show_ready_vup'){
	&check::demo();	# 1.81
	&check::active_proc();
	&show::ready_vup();
}
elsif($F->param('proc_version_up_sys')){
#	&save::keys_cookie();
	&proc::version_up_sys();
}
elsif($F->param('proc_version_up_opt')){
#	&save::keys_cookie();
	&proc::version_up_opt();
}
###### Mail delivery setting
elsif($F->param('mode') eq 'show_delivery' || $F->param('show_delivery')){
	&show::delivery();
}
#elsif($F->param('show_set_delivery') ne ""){
#	&show::set_delivery();
#}
elsif($F->param('save_delivery') ne ""){
	&check::delivery();
	&save::delivery();
	&show::state();
}
###### System info
elsif($F->param('mode') eq 'show_sys_info'){
	&show::sys_info();
}
elsif($F->param('show_set_sys_info')){
	&check::demo();	# 1.81
	&show::set_sys_info();
}
elsif($F->param('save_sys_info')){
	&check::demo();	# 1.81
	&check::sys_info();
	&save::sys_info();
	&show::sys_info();
}
###### CP operating info
elsif($F->param('mode') eq 'show_cphis_list'){
	&show::cphis_list();
}
###### SSL option setting
elsif($F->param('mode') eq 'show_option_ssl' || $F->param('show_option_ssl')){
	&show::option_ssl();
}
elsif($F->param('show_set_option_ssl')){
	&show::set_option_ssl();
}
elsif($F->param('save_option_ssl')){
	&save::option_ssl();
}
###### Benefits
elsif($F->param('mode') eq 'show_benefits_list' || $F->param('show_benefits_list')){
	&check::essen_setting();
	&show::benefits_list();
}
elsif($F->param('new_benefits')){
	&check::demo_limit('benefits',5);
	my $no = &get::benefits_maxno();
	$no++;
	my %bd = ('no' => $no);
	&show::benefits(\%bd);
}
elsif($F->param('mode') eq 'show_benefits'){
	my $bd = &get::benefits_data();
	&show::benefits($bd);
}
elsif($F->param('save_benefits')){
	&check::benefits();
	&save::benefits();
	&show::benefits_list();
}
elsif($F->param('show_ready_del_benefits')){
	&show::ready_del_benefits();
}
elsif($F->param('save_del_benefits')){
	&save::del_benefits();
	&show::benefits_list();
}
elsif($F->param('mode') eq 'proc_dl_benefits'){
	&proc::dl_benefits();
}
=pod
elsif($F->param('save_setting_benefits')){
	&check::setting_benefits();
	&save::setting_benefits();
	&show::benefits_list();
}
=cut
elsif($F->param('show_generator_benefits')){
	&check::essen_setting();
	&show::generator_benefits();
}
##### Limited pages
elsif($F->param('mode') eq 'show_lmtd_list' || $F->param('show_lmtd_list')){
	&check::essen_setting();
	&check::lmtd_path();
	&show::lmtd_list();
}
elsif($F->param('show_new_lmtd')){
	&check::demo_limit('lmtd',5);	# 1.81
	my %d = ('no' => $F->param('new_lmtd_num'));
	&show::lmtd_setting(\%d);
}
elsif($F->param('save_lmtd_setting')){
	&check::lmtd_setting();
	&save::lmtd_setting();
	&show::lmtd_list();
}
elsif($F->param('mode') eq 'show_lmtd_setting'){
	my $d = &get::lmtd_setting($F->param('no'));
	&show::lmtd_setting($d);
}
elsif($F->param('show_ready_del_lmtd')){
	&check::del_lmtd();
	&show::ready_del_lmtd();
}
elsif($F->param('save_del_lmtd')){
	&save::del_lmtd();
	&show::lmtd_list();
}
##### User migration
elsif($F->param('mode') eq 'show_user_migration'){
	&check::essen_setting();
	&show::user_migration();
}
elsif($F->param('save_user_migration')){
	&check::user_migration();
	&save::user_migration();
	&show::state();
}
##### Reissue password
elsif($F->param('mode') eq "show_reissue"){
	&check::reissue();
	&show::reissue();
}
elsif($F->param('proc_reissue')){
	&proc::reissue();	# 1.86 PH OK
	&show::reissue_done();
}
##### Case GET RSS feed
elsif($F->param('mode') eq 'get_topics'){
	&get::topics();
}
elsif($F->param('mode') eq 'get_community_comment'){
	&get::community_comment();
}
elsif($F->param('mode') eq 'get_community_thread'){
	&get::community_thread();
}
elsif($F->param('mode') eq 'get_latest_ver_for_ajax'){
	&get::latest_ver_for_ajax();
}
##### Case Ajax
elsif($F->param('ajax_call_define')){
	&ajax::call_define();
}
elsif($F->param('ajax_call_bodytpl')){
	&ajax::call_bodytpl();
}
#elsif($F->param('ajax_call_default_preview')){
elsif($F->param('mode') eq 'ajax_call_default_preview'){
	&ajax::call_default_preview();
}
##### Case no parameter
else{
	&proc::logout();
	&show::login_page("不正なページ遷移のためログアウトしました");
}
#&db::close();
exit;
