/****************************************************
 * jQuery RSS Plugin by fieeeld
 * version: 0.04 (2008/12/01)
 * @requires jQuery v1.2.6 or later
 *
 * Demo at: http://tpfields.xrea.jp/demo/js/sitefeeds/
 *
 ****************************************************/
$(function(){
	$('#feedList_topics').append("<div id='topics' class='loading'></div>");
	$.ajax({
		url: "./index.cgi?mode=get_topics",// RSS file name
		async: true,
		cache: false,
		dataType:"xml",
		timeout: 20000,
		success: function(xml){
			$(xml).find('item').each(function(i){
              if ( i > 4 ) {
                    return false;
                }
				var title = $(this).find('title').text();
 				var url = $(this).find('link').text();
				var date = dateParse($(this).find('pubDate').text());
				var desc = $(this).find('[nodeName="content:encoded"]').text();
				if(!desc){
					desc = $(this).find('description').text();
				}
				$('div#feedList_topics').append(
					"<ul>" +
						"<li class='title'><a href='" + url + "' target='blank' class='link_topics'>" + title + "</a></li>" +
						"<li class='" + date[1] + "'>" + date[0] + "（" + date[2] + "）</li>" +
						"<li class='description'>" + desc + "</li>" +
					"</ul>"
				).hide();
    		});
			$('#feedList_topics').animate(
				{
					height: "show",
					opacity: "show"
				},
				{duration: 500}
			);
			$('div#topics.loading').remove();
		},
		error: function(){
			$('div#feedList_topics').append(
				"<ul class='error'>" +
					"<li>情報が取得できませんでした</li>" +
				"</ul>"
			).hide();
 			$('#feedList_topics').animate(
				{
					height: "show",
					opacity: "show"
				},
				{duration: 500}
			);
			$('div#topics.loading').remove();
		}

	});
});

//dateParse:
function dateParse(str){
    var objDate = new Date(str);
    var nowDate = new Date();
    myDay = Math.floor((nowDate.getTime()-objDate.getTime()) / (1000*60*60*24)) + 1;
    //if in 7days "new!"
    if (myDay <= 7 ){
        var newMsg = "date_new";
	}
	else {
        var newMsg = "date";
    }
    var year = objDate.getFullYear();
    var month = objDate.getMonth() + 1;
    var date = objDate.getDate();
    var days = new Array("<span style='color:#ff0000;'>日</span>","月","火","水","木","金","<span style='color:#0000ff;'>土</span>");
    var day = days[objDate.getDay()];
    if ( month < 10 ) { month = "0" + month; }
    if ( date < 10 ) { date = "0" + date; }
    str = year + '-' + month + '-' + date;
    rtnValue = new Array(3);
    rtnValue[0] = str;
    rtnValue[1] = newMsg;
    rtnValue[2] = day;
    return rtnValue;
}

