###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package db;

use strict;

sub open{
	# 1.86 ########
	# mysql_server_prepare=1 にするとマイナスの数値の扱いに支障がでる
	# DBD::mysql.pm 4.030_01で修正？
	# https://allmychanges.com/p/perl/DBD::mysql/#4.030_01
	my $dbs = "DBI:mysql:$config::dbname:$config::dbhost";
	#my $dbs = "DBI:mysql:$config::dbname:$config::dbhost:mysql_server_prepare=1";
	###############
	our $dbh = DBI->connect($dbs,$config::dbuser,$config::dbpass);
	if(!$dbh){
		&show::error("データベースに接続できません");
	}
	&db::query("SET NAMES utf8");
}

sub query{
	# 1.86 #########
	#my ($sql) = @_;
	my ($sql, $bind) = @_;
	################
	# 1.79 ###############
	#our $sth = $db::dbh->prepare($sql) || die $db::dbh->errstr();
	#my $exec = $sth->execute() || die $sth->errstr()."\nSQL:\n".$sql;
	our $sth; my $exec;
	foreach my $q(split(/MS_SQL_SAPARATOR/,$sql)){
		$sth = $db::dbh->prepare($q) || die $db::dbh->errstr();
		# 1.86 ###########
		if($bind){my $el = 1; map {$sth->bind_param($el,$$_{value},$$_{type}); $el++;} @$bind;}
		##################
		$exec = $sth->execute() || die $sth->errstr()."\nSQL:\n".$q;
	}
	######################
	return $exec;
}

sub close{
	$db::sth->finish() if $db::sth;
	$db::dbh->disconnect();
}

sub child_open{
	$db::dbh->{InactiveDestroy} = 1;
	$db::dbh = $db::dbh->clone();
	&db::query("SET NAMES utf8");
}

sub change_connection{
	$db::dbh->{InactiveDestroy} = 1;
	my $new_dbh = $db::dbh->clone();
	&db::close();
	$db::dbh = $new_dbh;
	&db::query("SET NAMES utf8");
}

1;

