###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################

package default;

use strict;

my $ms_url = $config::oem ? $config::oem_url : 'http://milkystep.com/';
my $product_name = $config::oem ? $config::oem_product : 'MilkyStep';

sub regi_msg_sbj{
	return "読者登録完了 - \%\%TITLE\%\%";
}
sub regi_msg_cont{
	my $txt = <<EOM;
\%\%FULLNAME\%\% 様

この度は、
「\%\%TITLE\%\%」
への読者登録申請ありがとうございます。

正常に登録処理が完了致しましたのでお知らせいたします。


\%\%NAME\%\%様にとって、有意義な内容配信に努めますので、
今後ともよろしくお願いいたします。



※このメールは、購読申請された方に自動返信されています。
※お心当たりのないかたは、お手数ですが「\%\%REPLY\%\%」までご連絡ください。

---------------------------------------------------------------------
発行責任者　　\%\%FROMNAME\%\%
お問い合わせ　\%\%REPLY\%\%
---------------------------------------------------------------------
EOM
	return $txt;
}

sub ulk_msg_sbj{
	return "配信解除完了 - \%\%TITLE\%\%";
}
sub ulk_msg_cont{
	my $txt = <<EOM;
\%\%FULLNAME\%\% 様

「\%\%TITLE\%\%」
の配信解除処理が完了致しましたのでお知らせいたします。


今までご購読いただきましてありがとうございました。



※このメールは、配信解除申請された方に自動返信されています。
※お心当たりのないかたは、お手数ですが「\%\%REPLY\%\%」までご連絡ください。

---------------------------------------------------------------------
発行責任者　　\%\%FROMNAME\%\%
お問い合わせ　\%\%REPLY\%\%
---------------------------------------------------------------------
EOM
	return $txt;
}

sub mdf_msg_sbj{
	return "情報変更完了 - \%\%TITLE\%\%";
}
sub mdf_msg_cont{
	my $txt = <<EOM;
\%\%FULLNAME\%\% 様


「\%\%TITLE\%\%」
の読者情報の変更処理が正常にが完了致しましたのでお知らせいたします。

今後ともよろしくお願いいたします。



※このメールは、情報変更された方に自動返信されています。
※お心当たりのないかたは、お手数ですが「\%\%REPLY\%\%」までご連絡ください。

---------------------------------------------------------------------
発行責任者　　\%\%FROMNAME\%\%
お問い合わせ　\%\%REPLY\%\%
---------------------------------------------------------------------
EOM
	return $txt;
}

sub doi_msg_sbj{
	return "読者仮登録完了 - \%\%TITLE\%\%";
}
sub doi_msg_cont{
	my $txt = <<EOM;
\%\%FULLNAME\%\% 様

このたび、発行者により
「\%\%TITLE\%\%」
への代理登録（仮登録）が行なわれました。

まだ正式には読者登録されていません。
ご本人の意志確認のために本メールをお送りしております。

本登録を行う場合は下記のURLをクリックしてください。
\%\%OPTINURL\%\%

本登録しない場合はこのままメールを破棄してください。

\%\%NAME\%\%様にとって、有意義な内容配信に努めますので、
今後ともよろしくお願いいたします。


※このメールは、代理登録の同意を得た方に自動配信されています。
※お心当たりのない方、およびこのメールが何度も送信される場合は、
　お手数ですが「\%\%REPLY\%\%」までご連絡ください。

---------------------------------------------------------------------
発行責任者　　\%\%FROMNAME\%\%
お問い合わせ　\%\%REPLY\%\%
---------------------------------------------------------------------
EOM
	return $txt;
}

sub doi2_msg_sbj{
	return "読者仮登録完了 - \%\%TITLE\%\%.";
}
sub doi2_msg_cont{
	my $txt = <<EOM;
\%\%FULLNAME\%\% 様

この度は、
「\%\%TITLE\%\%」
への読者登録申請ありがとうございます。

ご本人確認のために本メールをお送りしております。
現在は仮登録状態であり、まだ正式には読者登録されていません。

下記のURLをクリックして本登録を完了させてください。
\%\%WOPTINURL\%\%


\%\%NAME\%\%様にとって、有意義な内容配信に努めますので、
今後ともよろしくお願いいたします。


※このメールは、購読申請された方に自動配信されています。
※お心当たりのないかたは、お手数ですが「\%\%REPLY\%\%」までご連絡ください。

---------------------------------------------------------------------
発行責任者　　\%\%FROMNAME\%\%
お問い合わせ　\%\%REPLY\%\%
---------------------------------------------------------------------
EOM
	return $txt;
}

##############################################################

sub declaration{
	my $txt = <<EOM;
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
EOM
	return $txt;
}
=pod
sub css_form {	# 1.65 ～
	my ($id) = @_;
	my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<style type='text/css'>
<!--
.ms_form_box{
	font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
	width:670px;
	height:auto;
	padding:0px;
	margin:30px auto;
}
.ms_form_header{
	width:670px;
	height:28px;
	line-height:28px;
	font-size:14px;
	font-weight:bold;
	color:#666666;
	padding:0px;
	margin:0px;
	text-align:center;
	border:solid 1px #c0c0c0;
	background-image : url('$wwwdir/img/ms_cp_capbg0.gif');
	background-repeat: repeat-x;
	background-position: 0px 1px;
}
.ms_form_footer{
	width:670px;
	height:28px;
	line-height:28px;
	font-size:11px;
	padding:0px;
	margin:0px;
	text-align:right;
	color:#666666;
	border:solid 1px #c0c0c0;
	background-image : url('$wwwdir/img/ms_cp_capbg0.gif');
	background-repeat: repeat-x;
	background-position: 0px 0px;
}
.ms_form_footer .copy{
	float:left;
	margin:0px 0px 0px 16px;
	padding:0px;
}
.ms_form_footer .powered_by{
	float:right;
	margin:0px 16px 0px 0px;
	padding:0px;
}
.ms_form_footer a:link,
.ms_form_footer a:visited{
	color:#666666;
	text-decoration:none;
}
.ms_form_body{
	width:670px;
	height:auto;
	font-size:12px;
	text-align:center;
	padding:28px 0px 28px 0px;
	margin:0px;
	border-style:none solid none solid;
	border-width:1px;
	border-color:#c0c0c0;
	overflow:hidden;
}
.ms_form_body table.ms_form_table{
	font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
	padding:0px;
	margin:12px auto 0px auto;
	font-size:12px;
	text-align:left;
	color:#222222;
	border:0px;
	border:none;
}
.ms_form_body table.ms_form_table td.item{
	min-width:120px;
	max-width:200px;
	vertical-align:top;
	padding:10px 0px 0px 22px;
	background-image : url('$wwwdir/img/ms_cp_icon_circle_right.gif');
	background-repeat: no-repeat;
	background-position: 0px 10px;
	border:none;
}
.ms_form_body table.ms_form_table td.cont{
	min-width:260px;
	padding:8px 0px 0px 30px;
	border:none;
}
.ms_form_body table.ms_form_table td.cont .text{
	width:100%;
	height:16px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body table.ms_form_table td.cont .text80{
	width:90px;
	height:16px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body table.ms_form_table td.cont .sel{
	width:auto;
	height:24px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body table.ms_form_table .ta{
	width:100%;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body table.ms_form_table td.cont span.cont_desc{
	font-size:10px;
	color:#4f4f4f;
	margin-left:4px;
}
.ms_form_btn{
	font-size:12px;
	color:#666666;
	font-weight:bold;
	cursor:pointer;
	border:0px;
	background-image : url('$wwwdir/img/ms_cp_btn0.gif');
	background-repeat: no-repeat;
	background-position: 0px 0px;
	width:165px;
	height:30px;
}
-->
</style>
EOM
	return $txt;
}
=cut

sub css_form {	# 1.79 ～
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- FORM CSS for PC -->
<style type='text/css'>
<!--
body{
	margin:0px;
}
.ms_form_box{
	font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
	width:670px;
	height:auto;
	padding:0px;
	margin:30px auto;
}
.ms_form_header{
	width:670px;
	height:28px;
	line-height:28px;
	font-size:14px;
	font-weight:bold;
	color:#666666;
	padding:0px;
	margin:0px;
	text-align:center;
	border:solid 1px #c0c0c0;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_capbg0.gif');
	background-repeat: repeat-x;
	background-position: 0px 1px;
}
.ms_form_footer{
	width:670px;
	height:28px;
	line-height:28px;
	font-size:11px;
	padding:0px;
	margin:0px;
	text-align:left;
	color:#666666;
	border:solid 1px #c0c0c0;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_capbg0.gif');
	background-repeat: repeat-x;
	background-position: 0px 0px;
}
.ms_form_footer .copy{
	float:left;
	margin:0px 0px 0px 16px;
	padding:0px;
}
.ms_form_footer .powered_by{
	float:right;
	margin:0px 16px 0px 0px;
	padding:0px;
	text-align:right;
}
.ms_form_footer a:link,
.ms_form_footer a:visited{
	color:#666666;
	text-decoration:none;
}
.ms_form_body{
	width:670px;
	height:auto;
	font-size:12px;
	text-align:center;
	padding:28px 0px 28px 0px;
	margin:0px;
	border-style:none solid none solid;
	border-width:1px;
	border-color:#c0c0c0;
	overflow:hidden;
}
.ms_form_body ul.form_list{
	width:480px;
	list-style:none;
	clear:both;
	margin:0px auto;
	padding:0px;
	text-align:left;
}
.ms_form_body ul.form_list li.item{
	clear:both;
	width:180px;
	vertical-align:top;
	padding:10px 0px 0px 22px;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
	background-repeat: no-repeat;
	background-position: 0px 10px;
	border:none;
	float:left;
}
.ms_form_body ul.form_list li.item-nofloat{
	clear:both;
	width:100%;
	vertical-align:top;
	padding:10px 0px 0px 22px;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
	background-repeat: no-repeat;
	background-position: 0px 10px;
	border:none;
}
.ms_form_body ul.form_list li.cont{
	width:248px;
	padding:8px 0px 0px 30px;
	border:none;
	float:left;
}
.ms_form_body ul.form_list li.cont-nofloat{
	clear:both;
	width:100%;
	padding:4px 0px 4px 2px;
	border:none;
}
.ms_form_body ul.form_list li.cont .text{
	width:100%;
	height:16px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .text80{
	width:80px;
	height:16px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .sel{
	width:100%;
	height:24px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .sel_auto{
	width:auto;
	height:24px;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body .ta{
	width:100%;
	font-size:12px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont span.cont_desc,
.ms_form_body ul.form_list li.cont-nofloat span.cont_desc{
	font-size:10px;
	color:#4f4f4f;
	margin:0px;
}
.ms_form_body div.submit_btn{
	clear:both;
	text-align:center;
}
.ms_form_btn{
	font-size:12px;
	color:#666666;
	font-weight:bold;
	cursor:pointer;
	border:0px;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_btn0.gif');
	background-repeat: no-repeat;
	background-position: 0px 0px;
	width:165px;
	height:30px;
}
div.ssl_seal {
	width:100px;
	height:50px;
	margin:0px auto 20px auto;
}
.clearfix{
	zoom:1;
}
.clearfix:after{
	content:"";
	display:block;
	clear:both;
	height:0;
	visibility:hidden;
}
-->
</style>
EOM
	return $txt;
}

sub css_form_fp {	# 1.79 ～
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- FORM CSS for Feature Phone -->
<style type='text/css'>
<!--
body{
	margin:0px;
	background-color:#c0c0c0;
}
.ms_form_box{
	font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
	width:auto;
	height:auto;
	padding:0px;
	margin:0px;
}
.ms_form_header{
	width:auto;
	height:auto;
	line-height:28px;
	font-size:14px;
	font-weight:bold;
	color:#666666;
	padding:6px;
	margin:0px;
	text-align:center;
	border:0px;
	background-color:#c0c0c0;
}
.ms_form_footer{
	width:auto;
	height:auto;
	line-height:28px;
	font-size:11px;
	padding:0px;
	margin:0px;
	text-align:left;
	color:#666666;
	border:0px;
	background-color:#c0c0c0;
}
.ms_form_footer .copy{
	float:left;
	margin:0px 0px 0px 6px;
	padding:0px;
}
.ms_form_footer .powered_by{
	float:right;
	margin:0px 6px 0px 0px;
	padding:0px;
	text-align:right;
}
.ms_form_footer a:link,
.ms_form_footer a:visited{
	color:#666666;
	text-decoration:none;
}
.ms_form_body{
	width:auto;
	height:auto;
	font-size:12px;
	text-align:center;
	padding:28px 0px 28px 0px;
	margin:0px;
	border:0px;
	background-color:#ffffff;
}
.ms_form_body ul.form_list{
	width:auto;
	list-style:none;
	clear:both;
	margin:6px 6px 0px 6px;
	padding:0px;
	text-align:left;
	border-bottom:1px solid #c0c0c0;
}
.ms_form_body ul.form_list li.item,
.ms_form_body ul.form_list li.item-nofloat {
	clear:both;
	width:auto;
	vertical-align:top;
	margin:0px;
	padding:10px 0px 3px 22px;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
	background-repeat: no-repeat;
	background-position: 0px 10px;
	border-top:1px solid #c0c0c0;
}
.ms_form_body ul.form_list li.cont,
.ms_form_body ul.form_list li.cont-nofloat {
	clear:both;
	width:auto;
	margin:0px;
	padding:3px 0px 10px 22px;
	border:none;
}
.ms_form_body ul.form_list li.cont .text{
	width:90%;
	height:auto;
	font-size:12px;
	padding:0px;
	background-color:#f9f9f9;
}
.ms_form_body ul.form_list li.cont .text80{
	width:60px;
	height:auto;
	font-size:12px;
	padding:0px;
	background-color:#f9f9f9;
}
.ms_form_body ul.form_list li.cont .sel{
	width:90%;
	height:auto;
	font-size:12px;
	padding:0px;
	background-color:#f9f9f9;
}
.ms_form_body ul.form_list li.cont .sel_auto{
	width:auto;
	height:auto;
	font-size:12px;
	padding:0px;
	background-color:#f9f9f9;
}
.ms_form_body .ta{
	width:90%;
	font-size:12px;
	padding:0px;
	background-color:#f9f9f9;
}
.ms_form_body ul.form_list li.cont span.cont_desc,
.ms_form_body ul.form_list li.cont-nofloat span.cont_desc {
	font-size:10px;
	color:#4f4f4f;
	margin:0px;
}
.ms_form_body div.submit_btn{
	clear:both;
	text-align:center;
}
.ms_form_btn{
	font-size:12px;
	color:#666666;
	font-weight:bold;
	width:auto;
	height:auto;
}
.clearfix{
	zoom:1;
}
.clearfix:after{
	content:"";
	display:block;
	clear:both;
	height:0;
	visibility:hidden;
}
-->
</style>
EOM
	return $txt;
}

sub css_form_sp {	# 1.79 ～
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- FORM CSS for Smart Phone -->
<style type='text/css'>
<!--
body{
	margin:0px;
	background-color:#c0c0c0;
}
.ms_form_box{
	font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
	width:auto;
	height:auto;
	padding:0px;
	margin:0px;
}
.ms_form_header{
	width:auto;
	height:auto;
	line-height:28px;
	font-size:14px;
	font-weight:bold;
	color:#666666;
	padding:6px;
	margin:0px;
	text-align:center;
	border:0px;
	background-color:#c0c0c0;
}
.ms_form_footer{
	width:auto;
	height:auto;
	line-height:28px;
	font-size:11px;
	padding:0px;
	margin:0px;
	text-align:left;
	color:#666666;
	border:0px;
	background-color:#c0c0c0;
}
.ms_form_footer .copy{
	float:left;
	margin:0px 0px 0px 6px;
	padding:0px;
}
.ms_form_footer .powered_by{
	float:right;
	margin:0px 6px 0px 0px;
	padding:0px;
	text-align:right;
}
.ms_form_footer a:link,
.ms_form_footer a:visited{
	color:#666666;
	text-decoration:none;
}
.ms_form_body{
	width:auto;
	height:auto;
	font-size:16px;
	text-align:center;
	padding:28px 0px 28px 0px;
	margin:0px;
	border:opx;
	background-color:#ffffff;
}
.ms_form_body ul.form_list{
	width:auto;
	list-style:none;
	clear:both;
	margin:6px 6px 0px 6px;
	padding:0px;
	text-align:left;
	border-bottom:1px solid #c0c0c0;
}
.ms_form_body ul.form_list li.item,
.ms_form_body ul.form_list li.item-nofloat {
	clear:both;
	width:auto;
	vertical-align:top;
	margin:0px;
	padding:10px 0px 3px 22px;
	background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
	background-repeat: no-repeat;
	background-position: 0px 13px;
	border-top:1px solid #c0c0c0;
}
.ms_form_body ul.form_list li.cont,
.ms_form_body ul.form_list li.cont-nofloat {
	width:auto;
	margin:0px;
	padding:3px 0px 10px 22px;
	border:none;
}
.ms_form_body ul.form_list li.cont .text{
	width:90%;
	height:auto;
	font-size:16px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .text80{
	width:80px;
	height:auto;
	font-size:16px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .sel{
	width:90%;
	height:auto;
	font-size:16px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont .sel_auto{
	width:auto;
	height:auto;
	font-size:16px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body .ta{
	width:90%;
	font-size:16px;
	padding:3px;
	background-color:#f9f9f9;
	border:solid 1px #c0c0c0;
}
.ms_form_body ul.form_list li.cont span.cont_desc,
.ms_form_body ul.form_list li.cont-nofloat span.cont_desc {
	font-size:10px;
	color:#4f4f4f;
	margin:0px;
}
.ms_form_body div.submit_btn{
	clear:both;
	text-align:center;
}
.ms_form_btn{
	font-size:16px;
	color:#666666;
	font-weight:bold;
	width:auto;
	height:auto;
}
div.ssl_seal {
	width:100px;
	height:50px;
	margin:0px auto 20px auto;
}
.clearfix{
	zoom:1;
}
.clearfix:after{
	content:"";
	display:block;
	clear:both;
	height:0;
	visibility:hidden;
}
-->
</style>
EOM
	return $txt;
}

sub css{
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- CSS for PC -->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#ffffff;
				height:100%;
				font-size:12px;
			}
			#container{
				width:670px;
				height:auto;
				text-align:left;
				margin:30px auto 0px auto;
				padding:0px;
				background-color:#ffffff;
			}
			#header{
				width:670px;
				height:28px;
				line-height:28px;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:middle;
				font-size:14px;
				color:#666666;
				font-weight:bold;
				border:solid 1px #c0c0c0;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_capbg0.gif');
				background-repeat: repeat-x;
				background-position: 0px 1px;
			}
			#header p.ok{
				display:inline;
				height:28px;
				padding:0px 32px 0px 32px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_ok.gif');
				background-repeat: no-repeat;
				background-position: 0px -1px;
			}
			#header p.error{
				display:inline;
				height:28px;
				padding:0px 32px 0px 32px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_error.gif');
				background-repeat: no-repeat;
				background-position: 0px -1px;
			}
			#header a:link,#footer a:link{
				color:#666666;
				text-decoration:none;
			}
			#header a:visited,#footer a:visited{
				color:#666666;
				text-decoration:none;
			}
			#main{
				width:670px;
				height:auto;
				margin:0px;
				padding:28px 0px 28px 0px;
				text-align:center;
				vertical-align:middle;
				border-style:none solid none solid;
				border-width:1px;
				border-color:#c0c0c0;
				font-size:12px;
			}
			#main .text{
				margin:0px 36px 0px 36px;
				padding:0px;
			}
			#main .align-left{
				text-align:left;
			}
			#main ul.form_list{
				width:480px;
				list-style:none;
				clear:both;
				margin:0px auto;
				padding:0px;
				text-align:left;
			}
			#main ul.form_list li.item{
				clear:both;
				width:180px;
				vertical-align:top;
				padding:10px 0px 0px 22px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
				background-repeat: no-repeat;
				background-position: 0px 10px;
				border:none;
				float:left;
			}
			#main ul.form_list li.item-nofloat{
				clear:both;
				width:100%;
				vertical-align:top;
				padding:10px 0px 0px 22px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
				background-repeat: no-repeat;
				background-position: 0px 10px;
				border:none;
			}
			#main ul.form_list li.cont{
				width:248px;
				padding:8px 0px 0px 30px;
				border:none;
				float:left;
			}
			#main ul.form_list li.cont-nofloat{
				clear:both;
				width:100%;
				padding:4px 0px 4px 22px;
				border:none;
			}
			#footer{
				width:670px;
				height:28px;
				line-height:28px;
				margin:0px;
				padding:0px;
				text-align:left;
				vertical-align:middle;
				color:#666666;
				font-size:11px;
				border:solid 1px #c0c0c0;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_capbg0.gif');
				background-repeat: repeat-x;
				background-position: 0px 1px;
			}
			#footer .copy{
				float:left;
				margin:0px 0px 0px 16px;
				padding:0px;
			}
			#footer .powered_by{
				float:right;
				margin:0px 16px 0px 0px;
				padding:0px;
			}
			#prev{
				width:670px;
				height:50px;
				line-height:50px;
				margin:0px auto;
				padding:0px;
				text-align:center;
				vertical-align:middle;
			}
			.title{
				color:#ffffff;
				font-size:16px;
				width:710px;
				margin:15px;
				float:left;
			}
			.submit_btn{
				clear:both;
				text-align:center;
			}
			.btn{
				font-size:12px;
				color:#666666;
				font-weight:bold;
				cursor:pointer;
				border:0px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_btn0.gif');
				background-repeat: no-repeat;
				background-position: 0px 0px;
				width:165px;
				height:30px;
			}
			div.ssl_seal {
				width:100px;
				height:50px;
				margin:0px auto 20px auto;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>	
EOM
	return $txt;
}
sub css_fp{
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- CSS for Feature Phone-->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#c0c0c0;
				height:100%;
				font-size:12px;
			}
			#container{
				width:auto;
				height:auto;
				text-align:left;
				margin:0px;
				padding:0px;
				background-color:#ffffff;
			}
			#header{
				width:auto;
				height:auto;
				line-height:28px;
				margin:0px;
				padding:6px;
				text-align:center;
				vertical-align:middle;
				font-size:14px;
				color:#666666;
				font-weight:bold;
				border:0px;
				background-color:#c0c0c0;
			}
			#header p.ok{
				display:inline;
				height:28px;
				padding:0px 32px 0px 32px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_ok.gif');
				background-repeat: no-repeat;
				background-position: 0px -1px;
			}
			#header p.error{
				display:inline;
				height:28px;
				padding:0px 32px 0px 50px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_error.gif');
				background-repeat: no-repeat;
				background-position: 18px -1px;
			}
			#header a:link,#footer a:link{
				color:#666666;
				text-decoration:none;
			}
			#header a:visited,#footer a:visited{
				color:#666666;
				text-decoration:none;
			}
			#main{
				width:auto;
				height:auto;
				margin:0px;
				padding:28px 0px 28px 0px;
				text-align:center;
				vertical-align:middle;
				border:0px;
				font-size:12px;
			}
			#main .text{
				margin:0px 6px 0px 6px;
				padding:0px;
			}
			#main .align-left{
				text-align:left;
			}
			#main ul.form_list{
				width:auto;
				list-style:none;
				clear:both;
				margin:6px 6px 0px 6px;
				padding:0px;
				text-align:left;
				border-bottom:1px solid #c0c0c0;
			}
			#main ul.form_list li.item,
			#main ul.form_list li.item-nofloat {
				clear:both;
				width:auto;
				vertical-align:top;
				margin:0px;
				padding:10px 0px 3px 22px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
				background-repeat: no-repeat;
				background-position: 0px 10px;
				border-top:1px solid #c0c0c0;
			}
			#main ul.form_list li.cont,
			#main ul.form_list li.cont-nofloat {
				width:auto;
				margin:0px;
				padding:3px 0px 10px 22px;
				border:none;
			}
			#footer{
				width:auto;
				height:auto;
				line-height:28px;
				margin:0px;
				padding:0px;
				text-align:left;
				vertical-align:middle;
				color:#666666;
				font-size:11px;
				border:0px;
				background-color:#c0c0c0;
			}
			#footer .copy{
				float:left;
				margin:0px 0px 0px 6px;
				padding:0px;
			}
			#footer .powered_by{
				float:right;
				margin:0px 6px 0px 0px;
				padding:0px;
				text-align:right;
			}
			#prev{
				width:auto;
				height:50px;
				line-height:50px;
				margin:0px auto;
				padding:0px;
				text-align:center;
				vertical-align:middle;
			}
			.title{
				color:#ffffff;
				font-size:16px;
				width:710px;
				margin:15px;
				float:left;
			}
			.submit_btn{
				clear:both;
				text-align:center;
			}
			.btn{
				font-size:12px;
				color:#666666;
				font-weight:bold;
				width:auto;
				height:auto;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>	
EOM
	return $txt;
}
sub css_sp{
	my ($id) = @_;
	#my $wwwdir = &get::wwwdir($id) || &get::msdir();
	my $txt = <<EOM;
<!-- CSS for Smart Phone-->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#c0c0c0;
				height:100%;
				font-size:12px;
			}
			#container{
				width:auto;
				height:auto;
				text-align:left;
				margin:0px;
				padding:0px;
				background-color:#ffffff;
			}
			#header{
				width:auto;
				height:auto;
				line-height:28px;
				margin:0px;
				padding:6px;
				text-align:center;
				vertical-align:middle;
				font-size:14px;
				color:#666666;
				font-weight:bold;
				border:0px;
				background-color:#c0c0c0;
			}
			#header p.ok{
				display:inline;
				height:28px;
				padding:0px 32px 0px 32px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_ok.gif');
				background-repeat: no-repeat;
				background-position: 0px -1px;
			}
			#header p.error{
				display:inline;
				height:28px;
				padding:0px 32px 0px 50px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_22px_error.gif');
				background-repeat: no-repeat;
				background-position: 18px -1px;
			}
			#header a:link,#footer a:link{
				color:#666666;
				text-decoration:none;
			}
			#header a:visited,#footer a:visited{
				color:#666666;
				text-decoration:none;
			}
			#main{
				width:auto;
				height:auto;
				margin:0px;
				padding:28px 0px 28px 0px;
				text-align:center;
				vertical-align:middle;
				border:0px;
				font-size:16px;
			}
			#main .text{
				margin:0px 6px 0px 6px;
				padding:0px;
				font-size:12px;
			}
			#main .align-left{
				text-align:left;
			}
			#main ul.form_list{
				width:auto;
				list-style:none;
				clear:both;
				margin:6px 6px 0px 6px;
				padding:0px;
				text-align:left;
				border-bottom:1px solid #c0c0c0;
			}
			#main ul.form_list li.item,
			#main ul.form_list li.item-nofloat {
				clear:both;
				width:auto;
				vertical-align:top;
				margin:0px;
				padding:10px 0px 3px 22px;
				background-image : url('\[__WWWDIR__\]/img/ms_cp_icon_circle_right.gif');
				background-repeat: no-repeat;
				background-position: 0px 13px;
				border-top:1px solid #c0c0c0;
			}
			#main ul.form_list li.cont,
			#main ul.form_list li.cont-nofloat {
				width:auto;
				margin:0px;
				padding:3px 0px 10px 22px;
				border:none;
			}
			#footer{
				width:auto;
				height:auto;
				line-height:28px;
				margin:0px;
				padding:0px;
				text-align:left;
				vertical-align:middle;
				color:#666666;
				font-size:11px;
				border:0px;
				background-color:#c0c0c0;
			}
			#footer .copy{
				float:left;
				margin:0px 0px 0px 6px;
				padding:0px;
			}
			#footer .powered_by{
				float:right;
				margin:0px 6px 0px 0px;
				padding:0px;
				text-align:right;
			}
			#prev{
				width:auto;
				height:50px;
				line-height:50px;
				margin:0px auto;
				padding:0px;
				text-align:center;
				vertical-align:middle;
			}
			.title{
				color:#ffffff;
				font-size:16px;
				width:710px;
				margin:15px;
				float:left;
			}
			.submit_btn{
				clear:both;
				text-align:center;
			}
			.btn{
				font-size:16px;
				color:#666666;
				font-weight:bold;
				width:auto;
				height:auto;
			}
			div.ssl_seal {
				width:100px;
				height:50px;
				margin:0px auto 20px auto;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>	
EOM
	return $txt;
}

sub form_reg {	# 1.65 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録/解除 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>

</body>
</html>
EOM

	return $txt;
}
sub form_reg_fp {	# 1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録/解除 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</form>
	</body>
</html>
EOM

	return $txt;
}
sub form_reg_sp {	# 1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録/解除 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>
	</body>
</html>
EOM

	return $txt;
}

sub form_mdf {	# 1.65 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者情報変更 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}
sub form_mdf_fp {	# 1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者情報変更 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}
sub form_mdf_sp {	# 1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者情報変更 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}

sub error{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>システムエラー [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>システムエラー</p>
			</div>
			<div id='main'>
				<div class='text'>
					[__ERR_MSG__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub error_fp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>システムエラー [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>システムエラー</p>
			</div>
			<div id='main'>
				<div class='text'>
					[__ERR_MSG__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub error_sp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>システムエラー [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>システムエラー</p>
			</div>
			<div id='main'>
				<div class='text'>
					[__ERR_MSG__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub regi_fini{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者登録完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					「[__TITLE__]」への読者登録が完了いたしました。<br />
					<br />
					この度はお申し込みいただきましてまことにありがとうございます。<br />
					<br />
					今後配信がご不要になった場合は、メール内の配信解除用URLをクリックしていただくか、<br />
					登録フォームの「解除」にチェックを入れてメールアドレスを送信していただくことで、<br />
					簡単に配信を解除することができます。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub regi_fini_fp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者登録完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「[__TITLE__]」への読者登録が完了いたしました。<br />
					<br />
					この度はお申し込みいただきましてまことにありがとうございます。<br />
					<br />
					今後配信がご不要になった場合は、メール内の配信解除用URLをクリックしていただくか、登録フォームの「解除」にチェックを入れてメールアドレスを送信していただくことで、簡単に配信を解除することができます。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub regi_fini_sp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者登録完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「[__TITLE__]」への読者登録が完了いたしました。<br />
					<br />
					この度はお申し込みいただきましてまことにありがとうございます。<br />
					<br />
					今後配信がご不要になった場合は、メール内の配信解除用URLをクリックしていただくか、登録フォームの「解除」にチェックを入れてメールアドレスを送信していただくことで、簡単に配信を解除することができます。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub regi_alert{	# 1.62
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>読者登録の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。よろしいですか？<br /><br />
				</div>
				[__REG_INFO_LIST__]
				<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub regi_alert_fp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>読者登録の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。<br />よろしいですか？<br /><br />
				</div>
				[__REG_INFO_LIST__]
				<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub regi_alert_sp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者登録の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>読者登録の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。よろしいですか？<br /><br />
				</div>
				[__REG_INFO_LIST__]
				<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub ulk_fini{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>配信解除完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					「[__TITLE__]」の配信解除処理が完了しました。<br />
					今までご購読いただきまして誠にありがとうございました。<br />
					<br />
					万が一誤って解除してしまった場合は、以下ボタンをクリックすると再購読できます。<br />
					<br />
					[__FORM_AGAIN__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub ulk_fini_fp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>配信解除完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「[__TITLE__]」の配信解除処理が完了しました。<br />
					今までご購読いただきまして誠にありがとうございました。<br />
					<br />
					万が一誤って解除してしまった場合は、以下ボタンをクリックすると再購読できます。<br />
					<br />
				</div>
				[__FORM_AGAIN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub ulk_fini_sp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>配信解除完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「[__TITLE__]」の配信解除処理が完了しました。<br />
					今までご購読いただきまして誠にありがとうございました。<br />
					<br />
					万が一誤って解除してしまった場合は、以下ボタンをクリックすると再購読できます。<br />
					<br />
				</div>
				[__FORM_AGAIN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub ulk_alert{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>配信解除の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					<b>[__ULK_ADD__]</b> への配信を解除します。<br />
					<br />
					よろしいですか？<br />
					<br />
					[__ULK_EXE_BTN__]
					</div>
				</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub ulk_alert_fp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>配信解除の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					<b>[__ULK_ADD__]</b> への配信を解除します。<br />
					<br />
					よろしいですか？<br />
					<br />
					[__ULK_EXE_BTN__]
					</div>
				</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub ulk_alert_sp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>配信解除の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>配信解除の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					<b>[__ULK_ADD__]</b> への配信を解除します。<br />
					<br />
					よろしいですか？<br />
					<br />
					[__ULK_EXE_BTN__]
					</div>
				</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub mdf_fini{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>情報変更完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					読者情報の変更が完了しました。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub mdf_fini_fp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>情報変更完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					読者情報の変更が完了しました。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub mdf_fini_sp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>情報変更完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					読者情報の変更が完了しました。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub mdf_alert{	# 1.62
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>情報変更の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。よろしいですか？<br />
					<br />
				</div>
				[__REG_INFO_LIST__]<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub mdf_alert_fp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>情報変更の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。<br />よろしいですか？<br />
					<br />
				</div>
				[__REG_INFO_LIST__]<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub mdf_alert_sp{	# 1.79
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>情報変更の確認 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='error'>情報変更の確認</p>
			</div>
			<div id='main'>
				<div class='text'>
					下記の内容で送信します。よろしいですか？<br />
					<br />
				</div>
				[__REG_INFO_LIST__]<br />
				[__REG_EXE_BTN__]
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub p_r_fini{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者仮登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者仮登録完了</p>
			</div>
			<div id='main'>
				<div class='text'>
					「<b>[__P_R_ADD__]</b>」宛てに確認メールを送信しました。<br />
					<br />
					届いたメールの中の本登録URLをクリックして、本登録を完了させてください。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub p_r_fini_fp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者仮登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者仮登録完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「<b>[__P_R_ADD__]</b>」宛てに確認メールを送信しました。<br />
					<br />
					届いたメールの中の本登録URLをクリックして、本登録を完了させてください。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub p_r_fini_sp{
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="noindex, nofollow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者仮登録完了 [__TITLE__]</title>
	</head>
	<body>
$css
		<div id='container'>
			<div id='header'>
				<p class='ok'>読者仮登録完了</p>
			</div>
			<div id='main'>
				<div class='text align-left'>
					「<b>[__P_R_ADD__]</b>」宛てに確認メールを送信しました。<br />
					<br />
					届いたメールの中の本登録URLをクリックして、本登録を完了させてください。
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
				<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
			</div>
		</div>
		<div id='prev' class='clearfix'>
			<a href='#' onClick="history.back(); return false;">戻　る</a>
		</div>
		<div class='ssl_seal'>
			[__SEAL_GS_100_50__]
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub form_t_r {	# True reg form 1.73 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者本登録 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='color:#ff0000;'>※まだ本登録は完了していません。下記の必要事項を入力してお進みください。</span><br /><br />
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}
sub form_t_r_fp {	#  1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者本登録 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='color:#ff0000;'>※まだ本登録は完了していません。下記の必要事項を入力してお進みください。</span><br /><br />
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}
sub form_t_r_sp {	#  1.79 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="robots" content="index, follow" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>読者本登録 [__TITLE__]</title>
	</head>
	<body>
$css
<form method='post' action='\[__REGIST_PATH__\]\[__URI_PARAMS__\]'>
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			[__TITLE__]
		</div>
		<div class='ms_form_body'>
			<span style='color:#ff0000;'>※まだ本登録は完了していません。下記の必要事項を入力してお進みください。</span><br /><br />
			<span style='font-size:11px;'><span style='color:#ff0000;'>※</span>は必須項目です</span><br />
			[__PARTS_INFO_LIST__]
			<br />
			[__SUBMIT_BTN__]
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
	<div class='ssl_seal'>
		[__SEAL_GS_100_50__]
	</div>
</form>
	</body>
</html>
EOM
	return $txt;
}

sub bcn { # 1.80
	my ($stg) = @_;
	my $txt = <<EOM;
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>[__BCN_SUB__] | [__TITLE__] バックナンバー</title>
	</head>
	<body>
		<!-- CSS for PC-->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#f9f9f9;
				height:100%;
				word-break:break-all;
				word-wrap:break-word;
			}
			a{
				text-decoration:none;
			}
			img{
				border:none;
			}
			ul{
				margin:0px;
				padding-left:15px;
			}
			li{
				margin:0px;
			}
			#container{
				width:942px;
				height:100%;
				text-align:left;
				margin:18px auto;
				padding:0px;
				border:solid 1px #c0c0c0;
				background-image:url('./img/ms_bcn_bg.gif');
				background-position:top left;
			}
			#header{
				width:942px;
				height:auto;
				margin:0px;
				padding:0px;
				vertical-align:middle;
				background-color:#c0c0c0;
			}
				#header a:link,#footer a:link{
					color:#666666;
					text-decoration:none;
				}
				#header a:visited,#footer a:visited{
					color:#666666;
					text-decoration:none;
				}
			.title{
				color:#666666;
				font-size:16px;
				width:710px;
				margin:30px 15px 26px 22px;
				float:left;
			}
			.user{
				color:#666666;
				font-size:12px;
				margin:32px 15px 22px 0px;
				float:right;
				text-align:right;
			}
			#left{
				width:229px;
				height:100%;
				margin:0px;
				padding:0px;
				font-size:12px;
				vertical-align:top;
				float:left;
			}
				#left .th{
					width:70px;
					font-size:14px;
					margin:15px auto 0px 60px;
					text-align:center;
					background: url(./img/ms_cp_icon_his_list.gif) no-repeat left top;
					background-position: 0px 2px;
					position: relative;
					padding:0px 0px 0px 18px;
				}
			.bcn_list{
				margin:15px 15px 15px 8px;
			}
			.bcn_list li{
				list-style:none;
				height:auto;
				background: url(./img/ms_cp_icon_text.gif) no-repeat left top;
				background-position: 0px 0px;
				position: relative;
				margin:6px 0px 6px 0px;
				padding:0px 0px 0px 20px;
			}
			.bcn_list_ctrl{
				height:42px;
				margin:15px;
				font-size:12px;
				text-align:center;
			}
			#main{
				width:713px;
				height:100%;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				float:left;
			}
			#main_top{
				width:713px;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
			}
			.bcn_sub{
				margin:15px;
			}
				.bcn_sub div.th{
					font-size:14px;
					font-weight:bold;
				}
				.bcn_sub ul{
					float:right;
					list-style:none;
					margin:12px 0px 12px auto;
					padding:0px;
					font-size:12px;
				}
				.bcn_sub li.date{
					float:left;
					margin:0px;
					background: url(./img/ms_cp_icon_clock.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
				.bcn_sub li.circ{
					float:left;
					margin:0px 0px 0px 12px;
					background: url(./img/ms_cp_icon_mails.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
			#main_bottom{
				width:713px;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
			}
			.bcn_body{
				clear:both;
				font-size:12px;
				margin:15px;
				padding:16px 0px 0px 0px;
				border-top:solid 1px #c0c0c0;
			}
			.bcn_ctrl{
				height:42px;
				font-size:12px;
				margin:25px 15px;
			}
			#footer{
				width:942px;
				height:65px;
				margin:0px;
				padding:0px;
				vertical-align:middle;
				clear:both;
				background-color:#c0c0c0;
				color:#666666;
			}
			.bcn_copy{
				font-size:11px;
				margin:24px auto auto 20px;
				float:left;
				text-align:left;
			}
			.powered_by{
				font-size:11px;
				margin:24px 20px auto auto;
				float:right;
				text-align:right;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>
		<div id='container'>
			<div id='header' class='clearfix'>
				<div class='title'>
					<a href='[__HOME_URL__]'><strong>[__TITLE__]</strong> バックナンバー</a>
				</div>
				<div class='user'>
					現在の読者数 [__CIRC__] 名
				</div>
			</div>
			<div id='left'>
				<p class='th'>記事履歴</p>
				<div class='bcn_list'>
					[__BCN_LIST__]
				</div>
				<div class='bcn_list_ctrl'>
					[__BCN_LIST_CTRL__]
				</div>
			</div>
			<div id='main'>
				<div id='main_top'>
					<div class='bcn_sub'>
						<div class='th'>[__BCN_SUB__]</div>
						<ul class='clearfix'>
							<li class='date'>発行日 [__BCN_DAY__]</li>
							<li class='circ'>発行部数 [__BCN_USERS__] 部</li>
						</ul>
					</div>
				</div>
				<div id='main_bottom'>
					<div class='bcn_body'>
						[__BCN_BODY__]
					</div>
					<div class='bcn_ctrl'>
						[__BCN_CTRL__]
					</div>
				</div>
			</div>
			<div id='footer'>
				<div class='bcn_copy'>
					Copyright(c) [__FROM_NAME__] All Rights Reserved.
				</div>
				<div class='powered_by'>
					Powered by <a href='$ms_url' target='_blank'>$product_name</a>
				</div>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub bcn_fp { # 1.80
	my ($stg) = @_;
	my $txt = <<EOM;
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>[__BCN_SUB__] | [__TITLE__] バックナンバー</title>
	</head>
	<body>
		<!-- CSS for PC-->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#c0c0c0;
				height:auto;
				word-break:break-all;
				word-wrap:break-word;
			}
			a{
				text-decoration:none;
			}
			img{
				border:none;
			}
			ul{
				margin:0px;
				padding:0px;
			}
			li{
				margin:0px;
			}
			#container{
				width:100%;
				height:auto;
				text-align:left;
				margin:0px;
				padding:0px;
			}
			#header{
				width:100%;
				height:auto;
				margin:0px;
				padding:0px;
				vertical-align:middle;
				background-color:#c0c0c0;
			}
				#header a:link,#footer a:link{
					color:#666666;
					text-decoration:none;
				}
				#header a:visited,#footer a:visited{
					color:#666666;
					text-decoration:none;
				}
			.title{
				color:#666666;
				font-size:14px;
				width:auto;
				height:auto;
				margin:0px;
				padding:8px;
			}
			.user{
				color:#666666;
				font-size:12px;
				width:auto;
				height:auto;
				margin:0px;
				padding:6px;
				float:right;
				text-align:right;
			}
			#left{
				width:auto;
				height:auto;
				margin:0px;
				padding:10px;
				font-size:12px;
				vertical-align:top;
				/*float:left;*/
				background-color:#ffffff;
			}
				#left .th{
					width:70px;
					font-size:14px;
					margin:0px auto 0px auto;
					text-align:center;
					background: url(./img/ms_cp_icon_his_list.gif) no-repeat left top;
					background-position: 0px 2px;
					position: relative;
					padding:0px 0px 0px 18px;
				}
			.bcn_list{
				margin:15px 0px 0px 0px;
			}
				.bcn_list li{
					list-style:none;
					height:auto;
					background: url(./img/ms_cp_icon_text.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					margin:6px 0px 6px 0px;
					padding:0px 0px 0px 20px;
				}
			.bcn_list_ctrl{
				height:auto;
				margin:0px;
				font-size:12px;
				text-align:center;
			}
			#main{
				width:100%;
				height:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			#main_top{
				width:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			.bcn_sub{
				margin:0px;
			}
				.bcn_sub div.th{
					font-size:14px;
					font-weight:bold;
					padding:10px;
				}
				.bcn_sub ul{
					float:right;
					list-style:none;
					margin:0px 10px 8px 10px;
					padding:0px;
					font-size:12px;
				}
				.bcn_sub li.date{
					float:left;
					margin:0px 12px 0px 0px;
					background: url(./img/ms_cp_icon_clock.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
				.bcn_sub li.circ{
					float:left;
					margin:0px;
					background: url(./img/ms_cp_icon_mails.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
			#main_bottom{
				width:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			.bcn_body{
				clear:both;
				font-size:12px;
				margin:15px 6px 6px 6px;
				padding:16px 4px 16px 4px;
				border-top:solid 1px #c0c0c0;
				border-bottom:solid 1px #c0c0c0;
			}
			.bcn_ctrl{
				height:auto;
				width:auto;
				font-size:12px;
				margin:0px;
				padding:10px;
			}
			#footer{
				width:auto;
				height:auto;
				margin:0px;
				padding:10px;
				vertical-align:middle;
				clear:both;
				background-color:c0c0c0;
				color:#666666;
			}
			.bcn_copy{
				font-size:11px;
				margin:0px;
				float:left;
				text-align:left;
			}
			.powered_by{
				font-size:11px;
				margin:0px;
				float:right;
				text-align:right;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>
		<div id='container'>
			<div id='header'>
				<div class='title'>
					<strong>[__TITLE__]</strong> バックナンバー
					[<a href='[__HOME_URL__]'>TOP</a>]
				</div>
			</div>
			<div id='main' class='clearfix'>
				<div id='main_top'>
					<div class='bcn_sub'>
						<div class='th'>[__BCN_SUB__]</div>
						<ul class='clearfix'>
							<li class='date'>発行日 [__BCN_DAY__]</li>
							<li class='circ'>発行部数 [__BCN_USERS__] 部</li>
						</ul>
					</div>
				</div>
				<div id='main_bottom'>
					<div class='bcn_body'>
						[__BCN_BODY__]
					</div>
					<div class='bcn_ctrl clearfix'>
						[__BCN_CTRL__]
					</div>
				</div>
			</div>
			<div id='left'>
				<p class='th'>記事履歴</p>
				<div class='bcn_list'>
					[__BCN_LIST__]
				</div>
				<div class='bcn_list_ctrl clearfix''>
					[__BCN_LIST_CTRL__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<div class='bcn_copy'>
					Copyright(c) [__FROM_NAME__] All Rights Reserved.
				</div>
				<div class='powered_by'>
					Powered by <a href='$ms_url' target='_blank'>$product_name</a>
				</div>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}

sub bcn_sp { # 1.80
	my ($stg) = @_;
	my $txt = <<EOM;
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
		<title>[__BCN_SUB__] | [__TITLE__] バックナンバー</title>
	</head>
	<body>
		<!-- CSS for PC-->
		<style type="text/css">
		<!--
			body{
				font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro",Osaka,"メイリオ",Meiryo,"ＭＳ Ｐゴシック",sans-serif;
				color:#222222;
				margin:0px;
				padding:0px;
				text-align:center;
				vertical-align:top;
				background-color:#c0c0c0;
				height:auto;
				word-break:break-all;
				word-wrap:break-word;
			}
			a{
				text-decoration:none;
			}
			img{
				border:none;
			}
			ul{
				margin:0px;
				padding:0px;
			}
			li{
				margin:0px;
			}
			#container{
				width:100%;
				height:auto;
				text-align:left;
				margin:0px;
				padding:0px;
			}
			#header{
				width:100%;
				height:auto;
				margin:0px;
				padding:0px;
				vertical-align:middle;
				background-color:#c0c0c0;
			}
				#header a:link,#footer a:link{
					color:#666666;
					text-decoration:none;
				}
				#header a:visited,#footer a:visited{
					color:#666666;
					text-decoration:none;
				}
			.title{
				color:#666666;
				font-size:14px;
				width:auto;
				height:auto;
				margin:0px;
				padding:8px;
			}
			.user{
				color:#666666;
				font-size:12px;
				width:auto;
				height:auto;
				margin:0px;
				padding:6px;
				float:right;
				text-align:right;
			}
			#left{
				width:auto;
				height:auto;
				margin:0px;
				padding:10px;
				font-size:12px;
				vertical-align:top;
				/*float:left;*/
				background-color:#ffffff;
			}
				#left .th{
					width:70px;
					font-size:14px;
					margin:0px auto 0px auto;
					text-align:center;
					background: url(./img/ms_cp_icon_his_list.gif) no-repeat left top;
					background-position: 0px 2px;
					position: relative;
					padding:0px 0px 0px 18px;
				}
			.bcn_list{
				margin:15px 0px 0px 0px;
			}
				.bcn_list li{
					list-style:none;
					height:auto;
					background: url(./img/ms_cp_icon_text.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					margin:6px 0px 6px 0px;
					padding:0px 0px 0px 20px;
				}
			.bcn_list_ctrl{
				height:auto;
				margin:0px;
				font-size:12px;
				text-align:center;
			}
			#main{
				width:100%;
				height:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			#main_top{
				width:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			.bcn_sub{
				margin:0px;
			}
				.bcn_sub div.th{
					font-size:14px;
					font-weight:bold;
					padding:10px;
				}
				.bcn_sub ul{
					float:right;
					list-style:none;
					margin:0px 10px 8px 10px;
					padding:0px;
					font-size:12px;
				}
				.bcn_sub li.date{
					float:left;
					margin:0px 12px 0px 0px;
					background: url(./img/ms_cp_icon_clock.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
				.bcn_sub li.circ{
					float:left;
					margin:0px;
					background: url(./img/ms_cp_icon_mails.gif) no-repeat left top;
					background-position: 0px 0px;
					position: relative;
					padding:0px 0px 0px 20px;
				}
			#main_bottom{
				width:auto;
				margin:0px;
				padding:0px;
				vertical-align:top;
				font-size:12px;
				background-color:#ffffff;
			}
			.bcn_body{
				clear:both;
				font-size:12px;
				margin:15px 6px 6px 6px;
				padding:16px 4px 16px 4px;
				border-top:solid 1px #c0c0c0;
				border-bottom:solid 1px #c0c0c0;
			}
			.bcn_ctrl{
				height:auto;
				width:auto;
				font-size:12px;
				margin:0px;
				padding:10px;
			}
			#footer{
				width:auto;
				height:auto;
				margin:0px;
				padding:10px;
				vertical-align:middle;
				clear:both;
				background-color:c0c0c0;
				color:#666666;
			}
			.bcn_copy{
				font-size:11px;
				margin:0px;
				float:left;
				text-align:left;
			}
			.powered_by{
				font-size:11px;
				margin:0px;
				float:right;
				text-align:right;
			}
			.clearfix{
				zoom:1;
			}
			.clearfix:after{
				content:"";
				display:block;
				clear:both;
				height:0;
				visibility:hidden;
			}
		-->
		</style>
		<div id='container'>
			<div id='header'>
				<div class='title'>
					<a href='[__HOME_URL__]'><strong>[__TITLE__]</strong> バックナンバー</a>
				</div>
			</div>
			<div id='main' class='clearfix'>
				<div id='main_top'>
					<div class='bcn_sub'>
						<div class='th'>[__BCN_SUB__]</div>
						<ul class='clearfix'>
							<li class='date'>発行日 [__BCN_DAY__]</li>
							<li class='circ'>発行部数 [__BCN_USERS__] 部</li>
						</ul>
					</div>
				</div>
				<div id='main_bottom'>
					<div class='bcn_body'>
						[__BCN_BODY__]
					</div>
					<div class='bcn_ctrl clearfix'>
						[__BCN_CTRL__]
					</div>
				</div>
			</div>
			<div id='left'>
				<p class='th'>記事履歴</p>
				<div class='bcn_list'>
					[__BCN_LIST__]
				</div>
				<div class='bcn_list_ctrl clearfix'>
					[__BCN_LIST_CTRL__]
				</div>
			</div>
			<div id='footer' class='clearfix'>
				<div class='bcn_copy'>
					Copyright(c) [__FROM_NAME__] All Rights Reserved.
				</div>
				<div class='powered_by'>
					Powered by <a href='$ms_url' target='_blank'>$product_name</a>
				</div>
			</div>
		</div>
	</body>
</html>
EOM
	return $txt;
}
sub induce_kara_reg {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール登録 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール登録 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>件名にはお名前を指定することができます。</li>
				<li class='item-nofloat'>お名前を入力する場合は、姓と名はスペースで区切ってください。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p style='font-size:14px;'><a href="mailto:[__MAILTO__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM

	return $txt;
}
sub induce_kara_reg_fp {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール登録 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール登録 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>件名にはお名前を指定することができます。</li>
				<li class='item-nofloat'>お名前を入力する場合は、姓と名はスペースで区切ってください。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p><a href="mailto:[__MAILTO__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM

	return $txt;
}
sub induce_kara_reg_sp {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール登録 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール登録 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>件名にはお名前を指定することができます。</li>
				<li class='item-nofloat'>お名前を入力する場合は、姓と名はスペースで区切ってください。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p style='font-size:20px;'><a href="mailto:[__MAILTO__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM
	return $txt;
}
# induce_kara_rm
sub induce_kara_rm {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール解除 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール解除 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p style='font-size:14px;'><a href="mailto:[__MAILTO2__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM

	return $txt;
}
sub induce_kara_rm_fp {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_fp($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール解除 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール解除 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p><a href="mailto:[__MAILTO2__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM

	return $txt;
}
sub induce_kara_rm_sp {	# 1.81 ～
	my ($stg) = @_;
	my ($declaration,$css) = (&default::declaration(),&default::css_form_sp($$stg{id}));
	my $txt = <<EOM;
$declaration
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta name="robots" content="index, follow" />
	<meta name="viewport" content="width=320; minimun-scale=1.0; maximum-scale=2.0;" />
	<title>空メール解除 [__TITLE__]</title>
</head>
<body>
$css
	<div class='ms_form_box'>
		<div class='ms_form_header'>
			空メール解除 [__TITLE__]
		</div>
		<div class='ms_form_body'>
			空メール送信前に下記をご確認下さい。<br /><br />
			<ul class='form_list'>
				<li class='item-nofloat'>ドメイン指定受信を行っている方は <input type='text' value='[__FROM_DOMAIN__]' style='width:80px;' /> からの受信を許可して下さい。</li>
				<li class='item-nofloat'>宛先・本文は変更せずにそのまま送信してください。</li>
			</ul>
			<p style='font-size:20px;'><a href="mailto:[__MAILTO2__]">空メールを送信</a></p>
		</div>
		<div class='ms_form_footer clearfix'>
			<p class='copy'>Copyright(c) [__FROM_NAME__]</p>
			<p class='powered_by'>Powered by <a href='$ms_url' target='_blank'>$product_name</a></p>
		</div>
	</div>
</body>
</html>
EOM
	return $txt;
}

our $seal_gs_100_50 = <<SEAL;
<!-- ↓このシールは「*.$config::oem_domain」以外のページでは表示されません -->
		<span id="ss_gmo_img_wrapper_100-50_image_ja">
			<a href="https://jp.globalsign.com/" target="_blank" rel="nofollow"><img alt="SSL　GMOグローバルサインのサイトシール" border="0" id="ss_img" src="//seal.globalsign.com/SiteSeal/images/gs_noscript_100-50_ja.gif" /></a>
		</span>
		<script type="text/javascript" src="//seal.globalsign.com/SiteSeal/gmogs_image_100-50_ja.js" defer="defer"></script>
		<!-- ↑このシールは「*.$config::oem_domain」以外のページでは表示されません -->
SEAL

1;
