###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################

package get;
use strict;

my $F = CGI->new();
my $EC = __PACKAGE__.$ver::version.'_';
my $ms_url = $config::oem ? $config::oem_url : "http://milkystep.com/";
my $product_name = $config::oem ? $config::oem_product : "MilkyStep";

sub all_id_and_type{
	my @list = ();
	&db::query("SELECT id,type_num FROM `ms_setting` ORDER BY type_num");
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@list, {	'id'		=> $href->{'id'},
							'type_num'	=> $href->{'type_num'}	}
		);
	}
	return \@list;
}
sub auto_regi_list{
	my @list = ();
	&db::query("SELECT * FROM ms_setting WHERE 
					type_num != 4 AND 
					auto_regi = 1 AND 
					last_auto_regi < CURRENT_DATE() AND 
					auto_regi_time <= CURRENT_TIME()
					ORDER BY type_num");
	while(my $href = $db::sth->fetchrow_hashref){
		push (@list, $href);
	}
	return \@list;
}
sub list{
	my $fd = $F->Vars;
	my $type_num = $$fd{type} || $_[0];
	$type_num =~ s/\0.*$//;
	my @list = ();
	my $order_by  = '';
	my $sort_type = '';
	if($$fd{list_sort_type}){
		$sort_type = $$fd{list_sort_type};
		$order_by = &get::list_order($sort_type);
	}
	else{
		# Get cookie
		$sort_type = &get::list_sort_cookie();
		if($sort_type){
			$order_by = &get::list_order($sort_type);
		}
		else{
			($order_by,$sort_type) = ("entry ASC",1);
		}
	}

	&db::query("
		SELECT		id,mag_name
		FROM		`ms_setting`
		WHERE		type_num = $type_num
		ORDER BY	$order_by
	");
	while(my $href = $db::sth->fetchrow_hashref){
		push (@list, $href);
	}
	return (\@list,$sort_type);
}

sub list_order{
	my ($sort_type) = @_;
	my $order_by = '';
	if   ($sort_type == 1){ $order_by = "entry ASC,  no ASC";  }
	elsif($sort_type == 2){ $order_by = "entry DESC, no DESC"; }
	elsif($sort_type == 3){ $order_by = "id ASC";  }
	elsif($sort_type == 4){ $order_by = "id DESC"; }
	return $order_by;
}

sub list_sort_box{
	my $fd = $F->Vars;
	my ($sort_type) = @_;
	$sort_type = 1 if !$sort_type;
	my @options = ('古い順','新しい順','ABC昇順','ABC降順');
	my $box = <<EOM;
		<form action='' method='post'>
		<table cellpadding='0' cellspacing='0' border='0'>
			<tr>
				<td width='70%'>
					<select name='list_sort_type' class='$switch::sel_side'>
EOM
	for(my $i=1; $i<=@options; $i++){
		my $std = $i == $sort_type ? 'selected' : '';
		$box .= "<option value='$i' $std>$options[$i-1]</option>\n";
	}
	$box .= <<EOM;
					</select>
				</td>
				<td width='30%' align='right' style='padding-left:6px;'>
					<input type='submit' name='list_sort' value='並替' style='font-size:10px;' />
				</td>
			</tr>
		</table>
		<input type='hidden' name='type' value='$$fd{'type'}'  />
		</form>
EOM
	return $box;
}
sub mail_size{
	my ($md) = @_;
	my $subject = $$md{subject};
	my $body    = $$md{header}.$$md{body}.$$md{footer};
	my $mail_head = '';
	my $mail_foot = '';
	my $attach = '';
	my $name = 'Firstname Familyname';

	#if($$md{html} == 2){
	if($$md{html} >= 2){
		($body,$attach) = &proc::conv_image_for_mobile($body);
		my $mltpt_text = &get::mltpt_text($body);		# 1.71
		require './lib/mobile.pl';
		(	$mail_head,
			$mail_foot,
			$name,
			$subject,
			$body
		) = &mobile::set(
			'docomo',	# As Docomo
			#$$md{lang}, # 1.71～ Comment Out
			$name,
			$subject,
			$body,
			$attach,
			&get::wwwdir($$md{id}),	# 1.71
			$mltpt_text				# 1.71
		);
	}
	else{
		if($$md{html} == 1){
			my $mltpt_text = &get::mltpt_text($body);
			my $wwwdir = &get::wwwdir($$md{id});
			$body = &proc::conv_image($body,$wwwdir);
			$body = &proc::conv_pictgram_image(0,$body,$wwwdir);	# 0-> image
			$mail_head = <<M_HEAD;
Content-Type: multipart/mixed; boundary="nextpt00"
Content-Transfer-Encoding: 7bit

--nextpt00
Content-Type: multipart/related; boundary="nextpt01"

--nextpt01
Content-Type: multipart/alternative; boundary="nextpt02"

--nextpt02
Content-Type: text/plain; charset="ISO-2022-JP"
Content-Transfer-Encoding: 7bit

$mltpt_text

--nextpt02
Content-Type: text/html; charset="ISO-2022-JP"
Content-Transfer-Encoding: 7bit
M_HEAD

			$mail_foot = <<M_FOOT;
--nextpt02--

--nextpt01--

--nextpt00--
M_FOOT

		}
		else{
			$mail_head = <<EOM;
Content-type: text/plain; charset="ISO-2022-JP"
Content-Transfer-Encoding: 7bit
EOM
		}
		my $encode = Unicode::Japanese->new($subject,'utf8');
		$subject = $encode->jis;
		$subject = &proc::base64encode($subject,'jis');
		$encode = Unicode::Japanese->new($name,'utf8');
		$name = $encode->jis;
		$name = &proc::base64encode($name,'jis');
		$encode = Unicode::Japanese->new($body,'utf8');
		$body = $encode->jis;
	}
	my $stg = &get::setting_data($$md{id});
	my $encode = Unicode::Japanese->new($$stg{from_name},'utf8');
	my $from_name = $encode->jis;
	$from_name = &proc::base64encode($from_name,'jis');

	my $source = <<SOURCE;
From: $from_name<$$stg{from_add}>
To: $name<example\@example.co.jp>
Return-Path: $$stg{from_add}
Errors-To: $$stg{from_add}
Reply-To: $$stg{from_add}
List-Unsubscribe: <http://example.com/ms/rm.cgi?m=0000&u=abcdefghijklmnopqrstuvwxyz&exe_unlink=true>
X-List-Unsubscribe: <http://example.com/ms/rm.cgi?m=0000&u=abcdefghijklmnopqrstuvwxyz&exe_unlink=true>
Precedence: bulk
Subject: $subject
$mail_head
$body
$mail_foot
SOURCE

	my $size = int(length($source)/1000*100)/100;
	$size = $size >= 1000
		? (int($size/1000*100)/100).' MB'
		: $size.' KB';
	return "約 ".$size;
}

sub msdir{
	# 1.84 ##########
	#my $msdir = $F->url;
	#$msdir =~ s/[\/][^\/]*$//g;
	my $msdir;
	if($config::oem){
		my $ab_path = $F->url(-absolute => 1);
#die $ab_path;
		$ab_path =~ s/[^\/]*$//g;
		#my $fqdn = &get::msfqdn();
		my $si = &get::sys_info();
		#$msdir = ($$si{use_option_ssl} ? 'https://' : 'http://').$fqdn.$ab_path;
		#$msdir = ($$si{use_option_ssl} ? 'https://' : 'http://') .$config::fqdn .$ab_path;
		$msdir = ($$si{use_option_ssl} ? 'https://' : 'http://') .&get::msfqdn() .$ab_path;	# 1.84
	}
	else{
		$msdir = $F->url();
		#$msdir =~ s/[\/][^\/]*$//g;
		$msdir =~ s/[^\/]*$//g;	# 1.84
	}
	################
	return $msdir;
}

sub msfqdn{
	#my $fqdn = $F->server_name;
	#if($config::oem && $fqdn =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/){
	#	&show::error("現在IPアドレスでコントロールパネルにアクセスしているためサーバ名が取得できません。<br />一度ログアウトし、ドメイン名にて再度アクセスしてください。",$EC.__LINE__);
	#}
	#my $fqdn = eval {use Sys::Hostname; return hostname();} || `hostname` || $F->server_name() || &show::error("hostnameが取得できません。", $EC.__LINE__);	# 1.84
	#my $fqdn = eval {use Sys::Hostname; return hostname();} || `hostname` || &show::error("hostnameが取得できません。", $EC.__LINE__);	# 1.84
	#$fqdn =~ s/^www\.//;
	my $fqdn = $config::fqdn || eval {use Sys::Hostname; return hostname();} || `hostname`;	# 1.84
	return $fqdn;
}

sub cpdir {	# 1.84
	my ($arg) = @_;
	my $cpfqdn = &get::msfqdn();
	if(!$$arg{use_option_ssl} && $cpfqdn !~ /\Q$config::oem_domain\E$/){
		my $host = $cpfqdn; $host =~ s/\./-/g;
		$cpfqdn = $host.'.'.$config::oem_domain;
	}
	my $ab_path = $F->url(-absolute => 1);
	$ab_path =~ s/[^\/]*$//g;
	my $si = &get::sys_info();
	my $cpdir = 'https://' .$cpfqdn .$ab_path;	# 1.84
	return $cpdir;
}

sub reserve_list{
	my @list = ();
	&db::query("SELECT id FROM `ms_setting` WHERE type_num!=4 ORDER BY type_num,entry");
	while(my $href = $db::sth->fetchrow_hashref){
		push (@list,$href);
	}
	return \@list;
}
sub sim_entry_list{
	my @list = ();
	my $id = $F->param('id');
	# 1.86 #####
	#&db::query("
	#	SELECT	id, mag_name, from_name, double_optin
	#	FROM   `ms_setting`
	#	WHERE  id       != '$id' AND
	#	       type_num != 4     AND
	#	       mag_name != ''
	#	ORDER BY type_num
	#");
	&db::query(
		"SELECT	id, mag_name, from_name, double_optin
		 FROM   `ms\_setting`
		 WHERE  id       != ?  AND
		        type_num != 4  AND
		        mag_name != ''
		 ORDER BY type_num",
		[ {value => $id} ]
	);
	############
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@list,$href);
	}
	return @list;
}
sub type{
	my $type_num = $_[0] || $F->param('type');
	my $type = "";
	if   ($type_num == 1){$type = "ステップメール";}
	elsif($type_num == 2){$type = "自動メルマガ";  }
	elsif($type_num == 3){$type = "標準メルマガ";  }
	elsif($type_num == 4){$type = "個別メール文";  }
	return $type;
}
sub wwwdir{
	my ($id) = @_;
	my $stg = &get::setting_data($id);
	my $wwwdir = 	$$stg{del_path}		|| 
					$$stg{regist_path}	||
					$$stg{cs_path};	#die $wwwdir;
	$wwwdir =~ s/(\/|\\)[^\/]+$//g;	#die $wwwdir;
	return $wwwdir;

}

sub parsed_fqdn{	# 1.63
	my ($uri) = @_;
	$uri =~ /^(https?:\/\/)?(www\.)?([^\/]+)[\/]?/i;
	my $fqdn = $3;
	return $fqdn
}

sub bodytpl_list{		# 1.63
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_bodytpl`
		ORDER BY no DESC
		$limit
	");
	my @btl = ();
	while (my $href = $db::sth->fetchrow_hashref()){
		push (@btl,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@btl,$max);
}
sub bodytpl_maxno{
	&db::query("SELECT MAX(no) FROM `ms_bodytpl`");
	my ($maxno) = $db::sth->fetchrow_array();
	return $maxno;
}
sub bodytpl{
	my ($no) = @_;
	&db::query("SELECT * FROM `ms_bodytpl` WHERE no= $no ");
	return $db::sth->fetchrow_hashref();
}

sub smtp_list{		################# 1.63
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_smtp`
		ORDER BY no DESC
		$limit
	");
	my @sl = ();
	while (my $href = $db::sth->fetchrow_hashref()){
		push (@sl,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@sl,$max);
}
sub smtp_maxno{
	&db::query("SELECT MAX(no) FROM `ms_smtp`");
	my ($maxno) = $db::sth->fetchrow_array();
	return $maxno;
}
sub smtp{
	my ($no) = @_;
	&db::query("SELECT * FROM `ms_smtp` WHERE no= $no ");
	return $db::sth->fetchrow_hashref();
}

sub head_list{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	my @hl = ();
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_definehead`
		ORDER BY no DESC
		$limit
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@hl, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@hl,$max);
}

sub foot_list{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	my @fl = ();
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_definefoot`
		ORDER BY no DESC
		$limit
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@fl, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@fl,$max);
}

sub head_maxno{
	&db::query("
		SELECT	MAX(no)
		FROM	`ms_definehead`
	");
	return $db::sth->fetchrow_array()	;
}

sub foot_maxno{
	&db::query("
		SELECT	MAX(no)
		FROM	`ms_definefoot`
	");
	return $db::sth->fetchrow_array()	;
}

sub define_header{
	my ($no) = @_;
	&db::query("SELECT * FROM `ms_definehead` WHERE no=$no");
	my $href = $db::sth->fetchrow_hashref;
#	my $title   = $href->{'title'};
#	my $content = $href->{'content'};
#	return ($title, $content);
	return $href;
}
sub define_footer{
	my ($no) = @_;
	&db::query("SELECT * FROM `ms_definefoot` WHERE no=$no");
	my $href = $db::sth->fetchrow_hashref;
#	my $title   = $href->{'title'};
#	my $content = $href->{'content'};
#	return ($title, $content);
	return $href;
}
sub header_maxno{
	&db::query("SELECT MAX(no) FROM ms_definehead");
	my $maxno = $db::sth->fetchrow_array;
	return $maxno;
}
sub footer_maxno{
	&db::query("SELECT MAX(no) FROM ms_definefoot");
	my $maxno = $db::sth->fetchrow_array;
	return $maxno;
}
sub delivery{
	my $id = $_[0] || $F->param('id') || $F->param('m');
	# 1.86 ####
	#&db::query("SELECT * FROM ms_delivery WHERE id='$id'");
	&db::query(
		"SELECT * FROM `ms\_delivery` WHERE id = ?",
		[ {value => $id} ]
	);
	###########
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}

sub attri_list{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_attri`
		ORDER BY no DESC
		$limit
	");
	my @al = ();
	while (my $href = $db::sth->fetchrow_hashref()){
		push (@al,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@al,$max);
}

sub attri_data{
	my $no = $F->param('no');
	&db::query("SELECT * FROM `ms_attri` WHERE no=$no");
	my @data = $db::sth->fetchrow_array();
	return @data;
}
=pod
sub attri_name{
	my @attri_nos = @_;
	my $attri_nos = join(",", @attri_nos);
	my @attri_name = ();
	&db::query("SELECT name FROM ms_attri WHERE no IN ($attri_nos) ORDER BY no");
	while(my @row = $db::sth->fetchrow_array){
		push (@attri_name, $row[0]);
	}
	my $attri_name = join("<br />\n", @attri_name);
	return $attri_name;
}
=cut
sub attri_maxno{
	&db::query("SELECT MAX(no) FROM `ms_attri`");
	my ($maxno) = $db::sth->fetchrow_array();
	return $maxno;
}

sub user_count{
#	my $id = "";
#	if($_[0] ne ""){
#		$id = $_[0];
#	}
#	else{
#		$id = $F->param('id');
#	}
	my $id = $_[0] || $F->param('id');
	&db::query("SELECT COUNT(*) AS max FROM `ms_user_$id`");
	my $href = $db::sth->fetchrow_hashref;
	my $count = $href->{'max'};
	return $count;
}
sub active_user_count{
#	my $id = "";
#	if($_[0] ne ""){
#		$id = $_[0];
#	}
#	else{
#		$id = $F->param('id');
#	}
	my $id = $_[0] || $F->param('id');
	&db::query("SELECT COUNT(*) AS max FROM `ms_user_$id` WHERE active = 1");
	my $href = $db::sth->fetchrow_hashref;
	my $count = $href->{'max'};
	return $count;
}

sub max_interval{

}
#sub target_story_data1{	# Step mail
sub target_story_nos1{	# Step mail
	my ($id,$cur_time,$re_day1) = @_;
	my $query = $re_day1
		? "
			SELECT		no
			FROM		`ms_story_$id`
			WHERE		sort_no = 1		AND
						day_interval = 1
		"
		: "
			SELECT		no
			FROM		`ms_story_$id`
			WHERE		deliv_time <= '$cur_time'
			ORDER BY	sort_no
		";
	&db::query($query);
	my @sn = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@sn, $href);
	}
	return \@sn;
}
sub target_story_data1{	# Step mail

}

sub target_story_nos2{	# Auto mail magazine
	my ($id,$cur_date,$cur_time,$cur_wday) = @_;
	&db::query("
		SELECT		no
		FROM		`ms_story_$id`
		WHERE		operate = 1						AND
					last_deliv < '$cur_date'			AND
					(
						/*********************************************************/
						(
							deliv_date_y LIKE '%0%'	AND
							DATE_FORMAT(
								'$cur_date',
								'\%m-\%d'
							) = '01-01'
						) OR
						(
							deliv_date_y LIKE '%1%'	AND
							DATE_FORMAT(
								'$cur_date',
								'\%m-\%d'
							) = '12-31'
						) OR
						(
							deliv_date_y LIKE '%2%'	AND
							DATE(
								CONCAT_WS(
									'-',
									YEAR('$cur_date'),
									deliv_date_yg
								)
							) = DATE('$cur_date')
						) OR
						/*********************************************************/
						(
							deliv_date_m LIKE '%0%'	AND
							DATE(
								DATE_SUB(
									'$cur_date',
									INTERVAL DAYOFMONTH('$cur_date')-1 DAY
								)
							) = DATE('$cur_date')
						) OR
						(
							deliv_date_m LIKE '%1%'	AND
							LAST_DAY('$cur_date') = DATE('$cur_date')
						) OR
						(
							deliv_date_m LIKE '%2%' AND
							DATE(
								CONCAT_WS(
									'-',
									DATE_FORMAT(
										'$cur_date',
										'\%Y-\%m'
									),
									deliv_date_mg
								)
							) = DATE('$cur_date')
						) OR
						deliv_aday LIKE '%$cur_wday%'
						/*********************************************************/
					)	AND
					deliv_time <= '$cur_time'
		ORDER BY	sort_no
	");
	my @sn = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@sn, $href);
	}
	return \@sn;
}
sub target_story_data2{	# Auto mail magazine

}

########################################################
sub story_data{

}

sub story_nos{

}

sub story_contents{

}
sub story_max_no{

}

#########################################################
sub target_extra_nos{	# Extra delivery
	my ($id) = @_;
	&db::query("
		SELECT		no
		FROM		`ms_extra_$id`
/*		WHERE		ADDTIME(reserve_day,reserve_time) <= NOW()		*/
		WHERE		CONCAT_WS(' ',reserve_day,reserve_time) <= NOW()	AND
					(draft = 0 OR draft IS NULL)	-- 1.70
		ORDER BY	sort_no
	");
	my @en = ();
	while(my $href = $db::sth->fetchrow_hashref){
		push (@en, $href);
	}
	return \@en;
}
sub target_extra_data{	# 1.70～
	my ($id,$no) = @_;
	&db::query("
		SELECT	*
		FROM	`ms_extra_$id`
		WHERE	no = $no	AND
				CONCAT_WS(' ',reserve_day,reserve_time) <= NOW()	AND
				(draft = 0 OR draft IS NULL)	-- 1.70
	");
	return $db::sth->fetchrow_hashref();
}
sub extra_data{
	my $id = $_[0] || $F->param('id');
	my $no = $_[1] || $F->param('no');
	&db::query("SELECT * FROM `ms_extra_$id` WHERE no = $no");
	return $db::sth->fetchrow_hashref();
}
sub extra_nos{
	my $id = $_[0];
	my @en = ();
	&db::query("SELECT no,sort_no FROM ms_extra_$id ORDER BY sort_no");
	while(my $href = $db::sth->fetchrow_hashref){
		push(@en, $href);
	}
	return \@en;
}
sub extra_contents{
#	my $id = $_[0];
#	if(!$_[0]){
#		$id = $F->param('id');
#	}
	my ($id,$start,$view_count) = @_;
	$start = 1 if !$start;

	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;

	my $order = "`ms_extra_$id`.sort_no ASC";
	my $fd = $F->Vars;
	if($$fd{sort_type_ext}){
		if($$fd{sort_type_ext} == 1){
			if($$fd{sort_mode_ext} == 0){
				$order = "`ms_extra_$id`.sort_no DESC";
			}
		}
	}

	my @ec = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS *
		FROM		`ms_extra_$id`
		ORDER BY	$order
		$limit
	");
	while(my $href = $db::sth->fetchrow_hashref){
		push(@ec, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@ec,$max);
}
sub extra_max_no{
	my $id = $F->param('id');
	&db::query("SELECT MAX(no) FROM ms_extra_$id");
	my ($max_no) = $db::sth->fetchrow_array();
	return $max_no;
}
##############################################################
sub indiv_data{

}
sub indiv_sbj{

}
sub indiv_contents{

}

sub indiv_max_no{

}
##############################################################
sub setting_data{
	my $id = $_[0] || $F->param('id') || $F->param('m');
	# 1.86 #####
	#&db::query("SELECT * FROM `ms_setting` WHERE id='$id'");
	&db::query(
		"SELECT * FROM `ms_setting` WHERE id = ?",
		[{value => $id}]
	);
	############
	my $href = $db::sth->fetchrow_hashref;
	return $href;
}
sub from_add{
	my $id = $F->param('id');
	&db::query("SELECT from_add,reply_add FROM `ms_setting` WHERE id='$id'");
	my $href = $db::sth->fetchrow_hashref();
	my $from_add = $href->{reply_add} || $href->{from_add};
	return $from_add;
}
sub regi_msg_cont{
	my $id = $F->param('id') || $F->param('m') || $_[0];
#	&db::query("
#		SELECT	regi_msg_cont,
#				regi_msg_lang
#		FROM	`ms_setting`
#		WHERE	id='$id'
#	");
	&db::query("
		SELECT	regi_msg_sbj,
				regi_msg_cont,
				regi_msg_lang
		FROM	`ms_setting`
		WHERE	id='$id'
	");
	my $href = $db::sth->fetchrow_hashref();
	## 1.66 ～ #############################################################
	my $sbj  = $$href{regi_msg_sbj}		? $$href{regi_msg_sbj}
											: &default::regi_msg_sbj() ;
	########################################################################
	my $cont = $$href{regi_msg_cont}	? $$href{regi_msg_cont}
											: &default::regi_msg_cont() ;
#	return ($cont,$$href{regi_msg_lang});
	return ($sbj,$cont,$$href{regi_msg_lang});
}
sub ulk_msg_cont{
	my $id = $F->param('id') || $F->param('m') || $_[0];
#	&db::query("
#		SELECT	ulk_msg_cont,
#				ulk_msg_lang
#		FROM	`ms_setting`
#		WHERE	id='$id'
#	");
	&db::query("
		SELECT	ulk_msg_sbj,
				ulk_msg_cont,
				ulk_msg_lang
		FROM	`ms_setting`
		WHERE	id='$id'
	");
	my $href = $db::sth->fetchrow_hashref();
	## 1.66 ～ #############################################################
	my $sbj  = $$href{ulk_msg_sbj}	? $$href{ulk_msg_sbj}
										: &default::ulk_msg_sbj() ;
	########################################################################
	my $cont = $$href{ulk_msg_cont}	? $$href{ulk_msg_cont}
										: &default::ulk_msg_cont() ;
#	return ($cont,$$href{ulk_msg_lang});
	return ($sbj,$cont,$$href{ulk_msg_lang});
}
sub mdf_msg_cont{
	my $id = $F->param('id');
#	&db::query("
#		SELECT	mdf_msg_cont,
#				mdf_msg_lang
#		FROM	`ms_setting`
#		WHERE	id='$id'
#	");
	&db::query("
		SELECT	mdf_msg_sbj,
				mdf_msg_cont,
				mdf_msg_lang
		FROM	`ms_setting`
		WHERE	id='$id'
	");
	my $href = $db::sth->fetchrow_hashref();
	## 1.66 ～ #############################################################
	my $sbj  = $$href{mdf_msg_sbj}	? $$href{mdf_msg_sbj}
										: &default::mdf_msg_sbj() ;
	########################################################################
	my $cont = $$href{mdf_msg_cont}	? $$href{mdf_msg_cont}
										: &default::mdf_msg_cont() ;
#	return ($cont,$$href{mdf_msg_lang});
	return ($sbj,$cont,$$href{mdf_msg_lang});
}
sub doi_msg_cont{
	my $id = $_[0] || $F->param('id'); 
#	&db::query("
#		SELECT	doi_msg_cont,
#				doi_msg_lang
#		FROM	`ms_setting`
#		WHERE	id='$id'
#	");
	&db::query("
		SELECT	doi_msg_sbj,
				doi_msg_cont,
				doi_msg_lang
		FROM	`ms_setting`
		WHERE	id='$id'
	");
	my $href = $db::sth->fetchrow_hashref();
	## 1.66 ～ #############################################################
	my $sbj  = $$href{doi_msg_sbj}	? $$href{doi_msg_sbj}
										: &default::doi_msg_sbj() ;
	########################################################################
	my $cont = $$href{doi_msg_cont}	? $$href{doi_msg_cont}
										: &default::doi_msg_cont() ;
#	return ($cont,$$href{doi_msg_lang});
	return ($sbj,$cont,$$href{doi_msg_lang});
}
sub doi2_msg_cont{
	my $id = $F->param('id') || $_[0];
	# 1.86 ####
	#&db::query("
	#	SELECT	doi2_msg_sbj,
	#			doi2_msg_cont,
	#			doi2_msg_lang
	#	FROM	`ms_setting`
	#	WHERE	id='$id'
	#");
	&db::query(
		"SELECT doi2_msg_sbj, doi2_msg_cont, doi2_msg_lang 
		 FROM   `ms\_setting`
		 WHERE  id = ?",
		[ {value => $id} ]
	);
	###########
	my $href = $db::sth->fetchrow_hashref();
	## 1.66 ～ #############################################################
	my $sbj  = $$href{doi2_msg_sbj}		? $$href{doi2_msg_sbj}
											: &default::doi2_msg_sbj() ;
	########################################################################
	my $cont = $$href{doi2_msg_cont}	? $$href{doi2_msg_cont}
											: &default::doi2_msg_cont() ;
#	return ($cont,$$href{doi2_msg_lang});
	return ($sbj,$cont,$$href{doi2_msg_lang});
}
sub form_setting{
	my ($modify) = @_;
	my $id = $F->param('id') || $F->param('m');
	# 1.86 #####
	#&db::query("
	#	SELECT * FROM `ms_regform`
	#	WHERE
	#		id			= '$id'		AND
	#		modify		= $modify
	#");
	&db::query(
		"SELECT * FROM `ms\_regform`
		 WHERE id = ? AND modify = ?",
		[ {value => $id}, {value => $modify} ]
	);
	############
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}
sub free_form_list{

}
sub free_form_list_by_no{	# 1.74
	my ($id) = @_;
	&db::query("
		SELECT * FROM `ms_freeform`
		WHERE	id = '$id'
	");
	my %list = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		$list{$$href{no}} = $href if $$href{no};
	}
	return \%list;
}
sub free_form_list_active{

}
sub free_form_list_active_by_no{
	my ($id,$modify) = @_;
	# 1.73 ###########
	my $active;
	if   ($modify == 1){$active = "active_m"; }	# modify form
	elsif($modify == 2){$active = "active_tr";}	# true reg form
	else               {$active = "active";   }	# reg form
	#################
	# 1.86 ######
	#&db::query("
	#	SELECT * FROM `ms_freeform`
	#	WHERE
	#		id     	= '$id'	AND
	#		$active	= 1
	#	ORDER BY no
	#");
	&db::query(
		"SELECT * FROM `ms\_freeform`
		 WHERE id      = ? AND
		       $active = 1
		 ORDER BY no",
		[ {value => $id} ]
	);
	#############
	my %list = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		$list{$$href{no}} = $href if $$href{no};
#die $$href{no};
	}
#die $list{16};
	return \%list;
}
sub free_form_maxno{

}
sub free_form_setting{

}
sub free_parts_maxno{

}
sub free_parts_list{

}
sub free_parts_setting{

}
sub form_order{	# 1.74
	my ($id,$modify) = @_;
	$modify ||= 0;
	# 1.86 ######
	#&db::query("
	#	SELECT		*
	#	FROM		`ms_formorder`
	#	WHERE		id = '$id'	AND modify = $modify
	#	ORDER BY	disp_order ASC
	#");
	&db::query(
		"SELECT * FROM `ms\_formorder`
		 WHERE id = ? AND modify = ?
		 ORDER BY disp_order ASC",
		[ {value => $id}, {value => $modify} ]
	);
	#############
	my @order = ();
	my %exists_fixed = ();
	my %exists_free  = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@order, $href);
		if($$href{type} == 0){		# fixed form
			$exists_fixed{$$href{fixed_form_name}} = 1;
		}
		elsif($$href{type} == 1){	# free form
			$exists_free{$$href{free_form_no}} = 1;
		}
	}
#print "Content-type: text/html\n\n";
#map {print "$_";} keys %exists_free;
#die ;
	return (\@order, \%exists_fixed, \%exists_free);
}
sub user_free_parts{

}

sub free_parts_hash_active_filter{

}

sub form {
	my ($modify) = @_;
	my $id = $F->param('id') || $F->param('m');
	my $type_num = $F->param('type');
	# 1.86 #####
	#&db::query("SELECT mag_name,regist_path FROM `ms_setting` WHERE id='$id'");
	&db::query(
		"SELECT mag_name, regist_path FROM `ms\_setting`
		 WHERE id = ?",
		[ {value => $id } ]
	);
	my ($mag_name,$regist_path) = $db::sth->fetchrow_array();
	############
	# 1.78 #############
	if(!$mag_name){
		&show::err_msg("
			<p>メールマガジンが存在しないか、すでに廃刊されています。</p>
			<p>詳しくは発行者までお問い合わせください。</p>
		");
	}
	####################
	# fixed form
	# Check modify record in ms_regform ------------------------
	if($modify == 1){
		# 1.86 ######
		#&db::query("
		#	SELECT * FROM `ms_regform`
		#	WHERE id = '$id' AND modify = 1
		#");
		&db::query(
			"SELECT * FROM `ms\_regform`
			 WHERE id = ? AND modify = 1",
			[ {value => $id} ]
		);
		#############
		if(!$db::sth->fetchrow_hashref()){
			# 1.86 ####
			#&db::query("
			#	INSERT IGNORE INTO `ms_regform`
			#		(id, modify, email_new,email_new_e, name,name_e, udevice,udevice_e)
			#	VALUES
			#		('$id', 1, 1,1, 0,0, 1,0)
			#");
			&db::query(
				"INSERT IGNORE INTO `ms\_regform`
				  (id, modify, email_new,email_new_e, name,name_e, udevice,udevice_e)
				VALUES
				  (?,  1, 1,1, 0,0, 1,0)",
				[ {value => $id} ]
			);
			##########
		}
	}
	if($modify == 2){	# True Reg from
		# 1.86 #####
		#&db::query("
		#	SELECT * FROM `ms_regform`
		#	WHERE id = '$id' AND modify = 2
		#");
		&db::query(
			"SELECT * FROM `ms\_regform`
			 WHERE id = ? AND modify = 2",
			[ {value => $id} ]	 
		);
		############
		if(!$db::sth->fetchrow_hashref()){
			# 1.86 #########
			#&db::query("
			#	INSERT IGNORE INTO `ms_regform`
			#		(id, modify, email_new,email_new_e, name,name_e, sex,sex_e, birth,birth_e, udevice,udevice_e)
			#	VALUES
			#		('$id', 2, 0,0, 1,1, 1,1, 1,1, 1,0)
			#");
			&db::query(
				"INSERT IGNORE INTO `ms\_regform`
				   (id, modify, email_new,email_new_e, name,name_e, sex,sex_e, birth,birth_e, udevice,udevice_e)
				VALUES
				   (?, 2, 0,0, 1,1, 1,1, 1,1, 1,0)",
				[ {value => $id} ]
			);
			################
		}
	}
	# ------------------------ Check modify record in ms_regform
	my $fs = &get::form_setting($modify);	# 1.86 PH OK
	# 1.74 #########################################
	$$fs{email} = $$fs{email_e} = 1;
	#my @reg_item = &item::reg_item();
	my ($fixed_form, $def_order) = &item::form_item_by_name($modify);
	my $free_form  = &get::free_form_list_active_by_no($id,$modify);	# 1.86 PH WEEK
	my ($form_order, $exists_fixed, $exists_free) = &get::form_order($id,$modify);	# 1.86 PH OK
	if(!$form_order || @$form_order == 0){
		map { push(@$form_order,{type => 0, fixed_form_name	=> $_});} @$def_order;
		map { push(@$form_order,{type => 1, free_form_no 	=> $_});} (sort {$a <=> $b} keys %$free_form  ); 
	}
	else{
		map { push(@$form_order, {type => 0, fixed_form_name	=> $_}) if !$$exists_fixed{$_}} keys %$fixed_form;
		map { push(@$form_order, {type => 1, free_form_no 	=> $_}) if !$$exists_free{$_} } keys %$free_form; 
	}
	###############################################
	# 1.79 #################################
	#my $item = "<table class='ms_form_table' cellpadding='5' cellspacing='1' border='0'>\n";	# 1.65 ～
	#my $item = "<ul class='form_list clearfix'>";
	my $item = {
		type_table => "<table class='ms_form_table' cellpadding='5' cellspacing='1' border='0'>\n",
		type_list  => "<ul class='form_list clearfix'>\n"
	};
	########################################
	# 1.74 ############
	foreach my $odr(@$form_order){
		if($$odr{type} == 0){	# fixed item
	###################
		# 1.74 ############
		#if($$fs{$reg_item[$i][3]}){
		if($$fs{$$odr{fixed_form_name}}){	# If this form is active
			#my $es = $$fs{"$reg_item[$i][3]_e"} == 1 ? "<span style='color:#ff0000;'>※</span>" : undef;
			my $es = $$fs{$$odr{fixed_form_name}.'_e'} == 1 ? "<span style='color:#ff0000;'>※</span>" : undef;
			my $input;
			#if($reg_item[$i][4]){
			if($$fixed_form{$$odr{fixed_form_name}}[4]){	# Select Box
				if($$fixed_form{$$odr{fixed_form_name}}[4] == 1){	# Alternative select(Select Box)
					$input = "<select name='$$odr{fixed_form_name}' class='sel'>\n";
					for(my $j=0; $j<@{ $$fixed_form{$$odr{fixed_form_name}}[5] }; $j++){
						my $slctd = $$odr{fixed_form_name} eq 'udevice' ? '[__SLCTD_UDEVICE_'.$j.'__]' : undef;	# 1.81
						$input .= "<option value='$j' $slctd>$$fixed_form{$$odr{fixed_form_name}}[5][$j]</option>\n";
					}
					$input .= "</select>\n";
				}
				#elsif($reg_item[$i][4] == 2){
				elsif($$fixed_form{$$odr{fixed_form_name}}[4] == 2){	# Multiple choice(checkbox)
					#for(my $j=1; $j<@{ $reg_item[$i][5] }; $j++){
					#	$input .= "<label><input type='checkbox' name='$reg_item[$i][3]' value='$j' /> $reg_item[$i][5][$j]</label><br />\n";
					#}
					for(my $j=1; $j<@{ $$fixed_form{$$odr{fixed_form_name}}[5] }; $j++){
						$input .= "<label><input type='checkbox' name='$$odr{fixed_form_name}' value='$j' /> $$fixed_form{$$odr{fixed_form_name}}[5][$j]</label><br />\n";
					}
				}
				# 1.74 ######################
				elsif($$fixed_form{$$odr{fixed_form_name}}[4] == 3){	# textarea
					$input = "<textarea name='user_comment' class='ta' rows='15'></textarea>\n";
				}
				#############################
			}
			else{
				if($$odr{fixed_form_name} eq 'birth'){
					$input = &get::birth_sel_box();
				}
				# 1.74 ##########################
				elsif($$odr{fixed_form_name} eq 'email'){
					if($modify == 2){	# true reg form
						$input = "[__REG_ADD__]<input type='hidden' name='$$odr{fixed_form_name}' value='[__REG_ADD__]' />";
					}
					else{	# reg,rm form, modify form
						$input = "<input type='text' name='$$odr{fixed_form_name}' value='[__REG_ADD__]' class='text' />";
					}
				}
				elsif($$odr{fixed_form_name} eq 'name'){
					if($modify == 2){	# true reg form
						if($$fs{name_splt} == 1){
							$input = "姓&nbsp;<input type='text' name='$$odr{fixed_form_name}_1' value='[__P_R_FAMNAME__]' class='text80' />&nbsp;&nbsp;名&nbsp;<input type='text' name='$$odr{fixed_form_name}_2' value='[__P_R_FIRNAME__]' class='text80' />";
						}
						else{
							$input = "<input type='text' name='name' value='[__P_R_NAME__]'  class='text' />";
						}
					}
					else{
						if($$fs{name_splt} == 1){
							$input = "姓&nbsp;<input type='text' name='$$odr{fixed_form_name}_1' value='' class='text80' />&nbsp;&nbsp;名&nbsp;<input type='text' name='$$odr{fixed_form_name}_2' value='' class='text80' />";
						}
						else{
							$input = "<input type='text' name='$$odr{fixed_form_name}' value='' class='text' />";
						}
					}
				}
				#################################
				else{
					$input = "<input type='text' name='$$odr{fixed_form_name}' value='' class='text' />";
				}
			}
			#$item .= <<ITEM;
			#			<tr>
			#				<td class='item'>$es$reg_item[$i][1]</td>
			#				<td class='cont'>
#ITEM
			if($$fixed_form{$$odr{fixed_form_name}}[4] == 3){	# textarea
				if($$fs{$$odr{fixed_form_name}.'_exp'}){
					$$fs{$$odr{fixed_form_name}.'_exp'} =~ s/\r\n|\r|\n/<br \/>\n/g;
				}
				else{
					$$fs{$$odr{fixed_form_name}.'_exp'} = $$fixed_form{$$odr{fixed_form_name}}[1];
				}
=pod
				$item .= <<ITEM;
						<tr>
							<td class='item' colspan='2'>
ITEM
				$item .= $$fs{$$odr{fixed_form_name}.'_exp'};
				$item .= <<ITEM;
						$es</td>
						</tr>
						<tr>
							<td colspan='2'>
ITEM
=cut
				$$item{type_table} .= <<ITEM;
						<tr>
							<td class='item' colspan='2'>
ITEM
				$$item{type_table} .= $$fs{$$odr{fixed_form_name}.'_exp'};
				$$item{type_table} .= <<ITEM;
						$es</td>
						</tr>
						<tr>
							<td colspan='2'>
ITEM


#				$item .= <<ITEM;
#							<li class='item-nofloat'>
#ITEM
#				$item .= $$fs{$$odr{fixed_form_name}.'_exp'};
#				$item .= <<ITEM;
#						$es</li>
#							<li class='cont-nofloat'>
#ITEM
				$$item{type_list} .= <<ITEM;
							<li class='item-nofloat'>
ITEM
				$$item{type_list} .= $$fs{$$odr{fixed_form_name}.'_exp'};
				$$item{type_list} .= <<ITEM;
						$es</li>
							<li class='cont-nofloat'>
ITEM
			}
			else{
#				$item .= <<ITEM;
#						<tr>
#							<td class='item'>$$fixed_form{$$odr{fixed_form_name}}[1]$es</td>
#							<td class='cont'>
#ITEM
				$$item{type_table} .= <<ITEM;
						<tr>
							<td class='item'>$$fixed_form{$$odr{fixed_form_name}}[1]$es</td>
							<td class='cont'>
ITEM
#				$item .= <<ITEM;
#							<li class='item'>$$fixed_form{$$odr{fixed_form_name}}[1]$es</li>
#							<li class='cont'>
#ITEM
				$$item{type_list} .= <<ITEM;
							<li class='item'>$$fixed_form{$$odr{fixed_form_name}}[1]$es</li>
							<li class='cont'>
ITEM
			}
			# 1.74 ##################
			#if($reg_item[$i][6]){
			if($$fixed_form{$$odr{fixed_form_name}}[6]){	# Description
				#if($reg_item[$i][3] ne 'name' || ($reg_item[$i][3] eq 'name' && !$$fs{name_splt})){
				#	$item .= <<ITEM;
				#		<span class='cont_desc'>$reg_item[$i][6]</span><br />

#ITEM
				#}
				if($$odr{fixed_form_name} ne 'name' || ($$odr{fixed_form_name} eq 'name' && !$$fs{name_splt})){
					#$item .= <<ITEM;
					my $temp = <<ITEM;
						<span class='cont_desc'>$$fixed_form{$$odr{fixed_form_name}}[6]</span><br />
ITEM
					$$item{type_table} .= $temp;
					$$item{type_list}  .= $temp;
				}
			}
			#########################
=pod
			$item .= <<ITEM;
							$input</td>
						</tr>
ITEM
=cut
			$$item{type_table} .= <<ITEM;
							$input</td>
						</tr>
ITEM
#			$item .= <<ITEM;
#							$input</li>
#ITEM
			$$item{type_list} .= <<ITEM;
							$input</li>
ITEM
#			if($reg_item[$i][6]){
#				if($reg_item[$i][3] ne 'name' || ($reg_item[$i][3] eq 'name' && !$$fs{name_splt})){
#					$item .= <<ITEM;
#						<tr>
#							<td colspan='2' align='center' style='font-size:10px;'>$reg_item[$i][6]</td>
#						</tr>
#
#ITEM
#				}
#			}
		}
#	}	# for

	# 1.74 #######################
		} # if
	elsif($$odr{type} == 1 && $$free_form{$$odr{free_form_no}}){	# free form
#die $$odr{free_form_no};
	##############################
	
	# free form
	#my $free_list = &get::free_form_list_active($id,$modify);	# $modify: 0-> reg_del form, 1-> modify form
	# 1.73 ################
	my $essen;
	if   ($modify == 1){$essen = 'essen_m'; }	# modify form
	elsif($modify == 2){$essen = 'essen_tr';}	# true reg form
	else               {$essen = 'essen';   }	# reg,rm form
	######################
#	foreach my $free_stg(@$free_list){
		#my $es = $$free_stg{$essen} ? "<span style='color:#ff0000;'>※</span>" : '';
		my $es = $$free_form{$$odr{free_form_no}}{$essen} ? "<span style='color:#ff0000;'>※</span>" : '';
		if($$free_form{$$odr{free_form_no}}{form_type} == 5){	# 1.79
#			$item .= <<ITEM;
#							<tr>
#								<td class='item' colspan='2'>$$free_form{$$odr{free_form_no}}{form_name}$es</td>
#							</tr>
#							<tr>
#								<td class='cont' colspan='2'>
#ITEM
			$$item{type_table} .= <<ITEM;
							<tr>
								<td class='item' colspan='2'>$$free_form{$$odr{free_form_no}}{form_name}$es</td>
							</tr>
							<tr>
								<td colspan='2'>
ITEM
#			$item .= <<ITEM;
#								<li class='item-nofloat'>$$free_form{$$odr{free_form_no}}{form_name}$es</li>
#								<li class='cont-nofloat'>
#ITEM
			$$item{type_list} .= <<ITEM;
								<li class='item-nofloat'>$$free_form{$$odr{free_form_no}}{form_name}$es</li>
								<li class='cont-nofloat'>
ITEM
		}
		else{
			#$item .= <<ITEM;
			#				<tr>
			#					<td class='item'>$es$$free_stg{form_name}</td>
			#					<td class='cont'>
#ITEM
			#$item .= <<ITEM;
			#				<tr>
			#					<td class='item'>$$free_form{$$odr{free_form_no}}{form_name}$es</td>
			#					<td class='cont'>
#ITEM
			$$item{type_table} .= <<ITEM;
							<tr>
								<td class='item'>$$free_form{$$odr{free_form_no}}{form_name}$es</td>
								<td class='cont'>
ITEM
#			$item .= <<ITEM;
#								<li class='item'>$$free_form{$$odr{free_form_no}}{form_name}$es</li>
#								<li class='cont'>
#ITEM
			$$item{type_list} .= <<ITEM;
								<li class='item'>$$free_form{$$odr{free_form_no}}{form_name}$es</li>
								<li class='cont'>
ITEM
		}
		# 1.74 #########################
		#if($$free_stg{description}){
		#	$item .= <<ITEM;
		#					<span class='cont_desc'>$$free_stg{description}</span><br />
#ITEM
		#}
		if($$free_form{$$odr{free_form_no}}{description}){
#			$item .= <<ITEM;
			my $temp = <<ITEM;
							<span class='cont_desc'>$$free_form{$$odr{free_form_no}}{description}</span><br />
ITEM
			$$item{type_table} .= $temp;
			$$item{type_list}  .= $temp;
		}
		################################
		#if($$free_stg{form_type} == 4){
		#	$item .= <<ITEM;
		#						<select name='free_$$free_stg{no}_4' class='sel'>
		#						<option value=''>未設定</option>
#ITEM
		#}
		if($$free_form{$$odr{free_form_no}}{form_type} == 4){
			#$item .= <<ITEM;
			my $temp = <<ITEM;
								<select name='free_$$odr{free_form_no}_4' class='sel'>
								<option value=''>未設定</option>
ITEM
			$$item{type_table} .= $temp;
			$$item{type_list}  .= $temp;
		}
		my @parts_list = ();
		#&db::query("
		#	SELECT * FROM `ms_freeparts`
		#	WHERE form_no = $$free_stg{no} AND form_type = $$free_stg{form_type}
		#	ORDER BY no
		#");
		# 1.86 ######
		#&db::query("
		#	SELECT		*
		#	FROM		`ms_freeparts`
		#	WHERE		form_no = $$odr{free_form_no}	AND
		#				form_type = $$free_form{$$odr{free_form_no}}{form_type}
		#	ORDER BY	no
		#");
		&db::query(
			"SELECT * FROM `ms\_freeparts`
			 WHERE form_no   = ? AND
			       form_type = ?
			 ORDER BY no",
			[
				{value => $$odr{free_form_no}},
				{value => $$free_form{$$odr{free_form_no}}{form_type}}
			]
		);
		#############
		while(my $href = $db::sth->fetchrow_hashref()){
			push(@parts_list, $href);
		}
		foreach(@parts_list){
			$$_{def_value} = &proc::conv_html_ref_2($$_{def_value});
			if($$_{form_type} == 0){
				#$item .= <<ITEM;
				#				<input type='text' name='free_$$free_stg{no}_$$_{form_type}' value='$$_{def_value}' maxlength='$$_{maxlength}' class='text' />
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<input type='text' name='free_$$odr{free_form_no}_$$_{form_type}' value='$$_{def_value}' maxlength='$$_{maxlength}' class='text' />
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 1){
				#$item .= <<ITEM;
				#				<input type='password' name='free_$$free_stg{no}_$$_{form_type}' value='$$_{def_value}' maxlength='$$_{maxlength}' class='text' />
#ITEM
				my $temp = <<ITEM;
								<input type='password' name='free_$$odr{free_form_no}_$$_{form_type}' value='$$_{def_value}' maxlength='$$_{maxlength}' class='text' />
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 2){
				my $checked = $$_{default_on} ? 'checked' : '';
				#$item .= <<ITEM;
				#				<label><input type='radio' name='free_$$free_stg{no}_$$_{form_type}' value='$$_{no}' $checked /> $$_{parts_name}</label><br />
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<label><input type='radio' name='free_$$odr{free_form_no}_$$_{form_type}' value='$$_{no}' $checked /> $$_{parts_name}</label><br />
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 3){
				my $checked = $$_{default_on} ? 'checked' : '';
				#$item .= <<ITEM;
				#				<label><input type='checkbox' name='free_$$free_stg{no}_$$_{form_type}' value='$$_{no}' $checked /> $$_{parts_name}</label><br />
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<label><input type='checkbox' name='free_$$odr{free_form_no}_$$_{form_type}' value='$$_{no}' $checked /> $$_{parts_name}</label><br />
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 4){
				my $selected = $$_{default_on} ? 'selected' : '';
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<option value='$$_{no}' $selected>$$_{parts_name}</option>
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 5){
				#$item .= <<ITEM;
				#				<textarea name='free_$$free_stg{no}_$$_{form_type}' rows='$$_{ta_rows}' cols='$$_{ta_cols}' maxlength='$$_{maxlength}' class='ta'>$$_{def_value}</textarea>
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<textarea name='free_$$odr{free_form_no}_$$_{form_type}' rows='$$_{ta_rows}' cols='$$_{ta_cols}' maxlength='$$_{maxlength}' class='ta'>$$_{def_value}</textarea>
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
			elsif($$_{form_type} == 6){
				# DATE
				&db::query("
					SELECT	YEAR(CURRENT_DATE())						AS cur_year,
							MONTH(CURRENT_DATE())					AS cur_month,
							DAY(CURRENT_DATE())						AS cur_day,
							YEAR(CURRENT_DATE()) + $$_{y_start}	AS y_start,
							YEAR(CURRENT_DATE()) + $$_{y_end}	 	AS y_end
				");
				my $date = $db::sth->fetchrow_hashref();
				my %def_date = ();
				if($$_{def_date_type} == 1){
					# today
					$def_date{year}  = $$date{cur_year};
					$def_date{month} = $$date{cur_month};
					$def_date{day}   = $$date{cur_day};
				}
				elsif($$_{def_date_type} == 2){
					(	$def_date{year},
						$def_date{month},
						$def_date{day}
					) = split(/\-/,$$_{def_date});
				}
				$def_date{month}	=~ s/^0//;
				$def_date{day}	=~ s/^0//;
				# year
				#$item .= <<ITEM;
				#				<select name='free_$$free_stg{no}_$$_{form_type}' class='sel'>
				#					<option value=''></option>
#ITEM
				#$item .= <<ITEM;
				# class=sel -> 下位互換
				my $temp = <<ITEM;
								<select name='free_$$odr{free_form_no}_$$_{form_type}' class='sel sel_auto'>
									<option value=''></option>
ITEM
				for(my $i = $$date{y_start}; $i <= $$date{y_end}; $i++){
					my $s = ($i == $def_date{year}) ? 'selected': undef;
					#$item .= "<option value='year_$i' $s>$i</option>\n";
					$temp .= "<option value='year_$i' $s>$i</option>\n";
				}
				#$item .= <<ITEM;
				$temp .= <<ITEM;
								</select> 年
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
				# month
				#$item .= <<ITEM;
				#				<select name='free_$$free_stg{no}_$$_{form_type}' class='sel'>
				#					<option value=''></option>
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<select name='free_$$odr{free_form_no}_$$_{form_type}' class='sel sel_auto'>
									<option value=''></option>
ITEM
				for(my $i=1; $i<=12; $i++){
					my $s = ($i == $def_date{month}) ? 'selected': undef;
					#$item .= "<option value='month_$i' $s>$i</option>\n";
					$temp .= "<option value='month_$i' $s>$i</option>\n";
				}
				#$item .= <<ITEM;
				$temp .= <<ITEM;
								</select> 月
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
				# day
				#$item .= <<ITEM;
				#				<select name='free_$$free_stg{no}_$$_{form_type}' class='sel'>
				#					<option value=''></option>
#ITEM
				#$item .= <<ITEM;
				my $temp = <<ITEM;
								<select name='free_$$odr{free_form_no}_$$_{form_type}' class='sel sel_auto'>
									<option value=''></option>
ITEM
				for(my $i=1; $i<=31; $i++){
					my $s = ($i == $def_date{day}) ? 'selected': undef;
					#$item .= "<option value='day_$i' $s>$i</option>\n";
					$temp .= "<option value='day_$i' $s>$i</option>\n";
				}
				#$item .= <<ITEM;
				$temp .= <<ITEM;
								</select> 日
ITEM
				$$item{type_table} .= $temp;
				$$item{type_list}  .= $temp;
			}
		}
		#if($$free_stg{form_type} == 4){
		if($$free_form{$$odr{free_form_no}}{form_type} == 4){
			#$item .= <<ITEM;
			my $temp = <<ITEM;
								</select>
ITEM
			$$item{type_table} .= $temp;
			$$item{type_list}  .= $temp;
		}
		#$item .= <<ITEM;
		#					</td>
		#				</tr>
#ITEM
		$$item{type_table} .= <<ITEM;
							</td>
						</tr>
ITEM
		#$item .= <<ITEM;
		$$item{type_list} .= <<ITEM;
							</li>
ITEM

#	}

	# 1.74 ########################
		} # elsif 
	}	# foreach
	###############################

	#$item .= "</table>\n";
	$$item{type_table} .= "</table>\n";
	#$item .= "</ul>\n";
	$$item{type_list} .= "</ul>\n";

	#my $submit_btn;	# 1.65 ～
	my $submit_btn = "<div class='submit_btn'>\n";	# 1.79 ～
	if($modify == 1){	# Modify form 1.73
		$submit_btn .= <<EOM;
								<input type='hidden' name='mode' value='3' />
EOM
	}
	# 1.73 #################
	elsif($modify == 2){	# True reg form (after clicks doi or oi ULR)
		$submit_btn .= <<EOM;
								<input type='hidden' name='mode' value='4' />
EOM
	}
	########################
	else{	# reg,rm form
		$submit_btn .= <<EOM;
								<label><input type='radio' name='mode' value='1' checked />登録</label>&nbsp;&nbsp;
								<label><input type='radio' name='mode' value='2' />解除</label>&nbsp;&nbsp;&nbsp;
EOM
	}
	$submit_btn .= <<EOM;
								<input type='submit' name='regist' class='ms_form_btn' value='　送　信　' />
								<input type='hidden' name='id' value='$id' />
								<input type='hidden' name='type' value='$type_num' />
								<input type='hidden' name='charset' value='$$fs{charset}' />
							</div>
EOM

	my $stg = &get::setting_data($id);
	# 1.73 #######
	my $kind; 
	if   ($modify == 1){$kind = 'form_mdf'}
	elsif($modify == 2){$kind = 'form_t_r'}	# True reg form
	else {$kind = 'form_reg'};					# reg,rm form
	my $email;
	if($F->param('ac')){
		$email = &cp::dec_pass($F->param('ac'));
	}
	elsif($F->param('u')){
		# 1.86 ####
		#&db::query("SELECT *	FROM `ms_user_$id` WHERE no_crypt='".$F->param('u')."'");
		&db::query(
			"SELECT * FROM `ms\_user\_$id`
			 WHERE no_crypt = ?",
			 [ {value => $F->param('u')} ]
		);
		###########
		my $ud = $db::sth->fetchrow_hashref();
		$email = $$ud{email};
	}
	my $u_name = &cp::dec_pass($F->param('nc')) if $F->param('nc');
	my ($u_famname,$u_fullname,$u_firname) = &get::parsed_name($u_name);
	#die $u_name.' '.$u_famname.' '.$u_firname;
	##############
	my $defd = &proc::conv_default_tags(
				$stg,			# setting data
				$kind,			# kind of default (=column name)
				$item,			# parts info 1.65 ～
				$submit_btn,	# submit btn 1.65 ～
				undef,			# error message
				$email,		# mail address registed
				undef,			# mail address to unlink
				undef,			# re entry form
				undef,			# unlink exe button
				$u_name,		# user name (pre) registed
				undef,			# regist alert list			1.62
				undef,			# regist exe button			1.62
				$u_famname,	# user family name (pre) registed		1.73
				$u_firname,	# user first name  (pre) registed		1.73
				undef			# backnumber data 1.80
	);
#die $defd;
#print "Content-type: text/html\n\n";
#print $defd;
#exit;
	# 1.78 ##############
	#return $defd;
	return ($defd,$fs);
	#####################
}

sub form_iframe{
	my ($modify) = @_;
	my $id = $F->param('id');
	my $type_num = $F->param('type');
	#my $if_path = &get::msdir()."/form_if.cgi";
	my $if_path = &get::msdir()."form_if.cgi";	# 1.84
	#$modify = $modify	? '&modify=1'
	$modify = $modify	? '&modify='.$modify : '';
	my $iframe = <<IFRAME;
<div align='center'>
	<iframe src='$if_path?type=$type_num&id=$id$modify' frameborder='0' height='100%' width='100%'>
		フレーム対応のブラウザでご覧ください
	</iframe>
</div>
IFRAME
	return $iframe;
}

sub form_if_path{
	my ($modify) = @_;
	my $id = $F->param('id');
	my $type_num = $F->param('type');
	#my $if_path = &get::msdir()."/form_if.cgi";
	my $if_path = &get::msdir()."form_if.cgi";
	#$modify = $modify	? '&modify=1'
	$modify = $modify ? '&modify='.$modify : '';
	return $if_path.'?type='.$type_num.'&id='.$id.$modify;
}

sub form_if_path_alt {	# 1.84
	my ($modify) = @_;
	my $fd = $F->Vars;
	#my $if_path = &get::msdir()."/form_if.cgi";
	$modify = $modify ? '&modify='.$modify : '';
	return './form_if.cgi'.'?type='.$$fd{type}.'&id='.$$fd{id}.$modify;
}

sub induce {	# 1.81
	my ($induce) = @_;
	# Check params
	my $id = $F->param('id') || $F->param('m');
	&show::err_msg("<p>パラメータ情報に不備があります。</p>\n<p>WEB管理者までお問い合わせください。</p>") if !$id;
	# 1.86 ######
	#&db::query("SELECT mag_name FROM `ms_setting` WHERE id = '$id'");
	&db::query(
		"SELECT mag_name FROM `ms\_setting`
		 WHERE id = ?",
		[ {value => $id} ]
	);
	#############
	my ($mag_name) = $db::sth->fetchrow_array();
	&show::err_msg("<p>メールマガジンが存在しないか、すでに廃刊されています。</p>\n<p>詳しくは発行者までお問い合わせください。</p>") if !$mag_name;

	my $stg  = &get::setting_data($id);
	my $defd = &proc::conv_default_tags(
		$stg,	# setting data
		'induce_'.$induce,	# kind of default (=column name)
		undef,	# parts info 1.65 ～
		undef,	# submit btn 1.65 ～
		undef,	# error message
		undef,	# mail address registed
		undef,	# mail address to unlink
		undef,	# re entry form
		undef,	# unlink exe button
		undef,	# user name (pre) registed
		undef,	# regist alert list			1.62
		undef,	# regist exe button			1.62
		undef,	# user family name (pre) registed		1.73
		undef,	# user first name  (pre) registed		1.73
		undef	# backnumber data 1.80
	);
	return $defd;
}

sub device {	# 1.79
	my $grep_ua_fp = join('|',(
		'^DoCoMo',					# docomo
		'^KDDI\-','^UP\.Browser',	# au
		'^SoftBank','^Semulator','^Vodafone','^Vemulator','^MOT\-','^MOTEMULATOR','^J\-PHONE','^J\-EMULATOR',	# softbank
		'"^Mozilla\/3\.0\((?:DDIPOCKET|WILLCOM);'	# willcom
	));
	my $grep_ua_sp = join('|',(
		'iPhone',				# Apple iPhone
		'iPod',				# Apple iPod touch
		'Android',				# 1.5+ Android
		'dream',				# Pre 1.5 Android
		'CUPCAKE',				# 1.5+ Android
		#'blackberry9500',	# Storm
		#'blackberry9530',	# Storm
		#'blackberry9520',	# Storm v2
		#'blackberry9550',	# Storm v2
		#'blackberry9800',	# Torch
		'blackberry',
		'webOS',				# Palm Pre Experimental
		'incognito',			# Other iPhone browser
		'webmate',				# Other iPhone browser
		'Windows Phone OS'	# Windows Phone
	));
	if($ENV{HTTP_USER_AGENT} =~ /$grep_ua_fp/i){	# Featuture Phone
		return 2;
	}
	elsif($ENV{HTTP_USER_AGENT} =~ /$grep_ua_sp/i){	# Smart Phone
		return 3;
	}
	else{	# PC
		return 1;
	}
}

sub given_days_from_today{
	my ($cur,$num,$p_or_f) = @_;
	my $cur_date = $$cur[5].'-'.$$cur[4].'-'.$$cur[3];
	$num = $p_or_f eq 'AGO' ? '-'.$num : $num;
	&db::query("SELECT DATE_ADD('$cur_date', INTERVAL $num DAY) AS given_days");
	my $href = $db::sth->fetchrow_hashref();
	$$href{given_days} =~ s/(\d{4})\-(\d{1,2})\-(\d{1,2})/$1年$2月$3日/;
	return $$href{given_days};
}
sub given_days_from_entrydate{
	my ($ud,$num,$p_or_f) = @_;
	$num = $p_or_f eq 'AGO' ? '-'.$num : $num;
	&db::query("SELECT DATE_ADD('$$ud{entry}', INTERVAL $num DAY) AS given_days");
	my $href = $db::sth->fetchrow_hashref();
	$$href{given_days} =~ s/(\d{4})\-(\d{1,2})\-(\d{1,2})/$1年$2月$3日/;
	return $$href{given_days};
}
sub rem_days{
	my ($cur,$date) = @_;
	my $cur_date = $$cur[5].'-'.$$cur[4].'-'.$$cur[3];
	&db::query("SELECT TO_DAYS('$date') - TO_DAYS('$cur_date') AS rem_days");
	my $href = $db::sth->fetchrow_hashref();
	return $$href{rem_days};
}

sub lmtd_list{

}

sub lmtd_maxno{

}
sub lmtd_setting{

}

sub migration_setting{
	my ($id) = @_;
	&db::query("SELECT * FROM `ms_migration` WHERE id = '$id'");
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}
sub destination_list{
	my ($id) = @_;
	&db::query("
		SELECT		id,mag_name
		FROM		`ms_setting`
		WHERE		id != '$id'		AND
					type_num != 4		AND
					mag_name != ''	AND
					mag_name IS NOT NULL
		ORDER BY	no ASC
	");
	my @dl = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@dl,$href);
	}
	return \@dl;
}

sub accounts{

}
sub site_accounts{

}
sub user_points{
	my ($add) = @_;
	my $id = $F->param('id');
	&db::query("SELECT points FROM ms_user_$id WHERE email='$add'");
	my $href = $db::sth->fetchrow_hashref;
	my $points = $href->{'points'};
	return $points;
}
sub user_attri{
	my ($add) = @_;
	my $id = $F->param('id');
	&db::query("
		SELECT 
			attri_1,
			attri_2,
			attri_3,
			attri_4,
			attri_5,
			attri_6,
			attri_7,
			attri_8,
			attri_9 
		FROM ms_user_$id WHERE email='$add'");
	my $href = $db::sth->fetchrow_hashref;
	my @attris = (
		$href->{'attri_1'},
		$href->{'attri_2'},
		$href->{'attri_3'},
		$href->{'attri_4'},
		$href->{'attri_5'},
		$href->{'attri_6'},
		$href->{'attri_7'},
		$href->{'attri_8'},
		$href->{'attri_9'}
	);
	return @attris;
}

sub user_refine_menu{
	my $pd = $F->Vars;
	my $id = $$pd{id};
	undef $pd if $F->param("save_users_edit");
	# Case show,copy story & extra & his
	if(
		$$pd{mode} eq "show_story"	||
		$$pd{mode} eq "copy_story"	||
		$$pd{mode} eq "show_extra"	||
		$$pd{mode} eq "copy_extra"	||
		$$pd{mode} eq "copy_his"		||
		$$pd{operate_send_mail_users}
	){
		($$pd{filter_cont}) = @_;
		foreach(split(/&/,$$pd{filter_cont})){
			$_ =~ /(.+)=(.*)/;
			if($2 ne ''){
				$$pd{$1} = $2;
			}
		}
	}

	my $regist_mode = &item::regist_mode();
	my $regist_select;
	for(my $i=1; $i<@$regist_mode; $i++){
		my $c;
		map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{regist_mode});
		$regist_select .= "<label><input type='checkbox' name='regist_mode' value='$i' $c />$$regist_mode[$i]</label>　";
	}

	my $regist_from = &item::regist_from();
	my $r_f_select;
	foreach my $key(sort keys %$regist_from){
		my $c;
		map{ if($_ eq $key){$c = 'checked';} } split(/\0|,/,$$pd{regist_from});
		$r_f_select .= "<label><input type='checkbox' name='regist_from' value='$key' $c />$$regist_from{$key}</label>　\n";
	}

	$$pd{kw} =~ s/''/'/;
	my $refine_kw = "<input type='text' name='kw' value='".&proc::conv_html_ref_2($$pd{kw})."' class='$switch::txt' style='width:188px;'>\n";

	my $sex  = &item::sex();
	my $sex_select;
	for(my $i=0; $i<@$sex; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{sex});
		$sex_select .= "<label><input type='checkbox' name='sex' value='$i' $c />$$sex[$i]</label>　";
	}
#die $$pd{sex};

	my $refine_age = "
		<input type='text' name='under_age' value='$$pd{under_age}' class='$switch::ss_txt' style='ime-mode:disabled;' /> ～
		<input type='text' name='over_age'  value='$$pd{over_age}'  class='$switch::ss_txt' style='ime-mode:disabled;' />
	";

	$$pd{postal} =~ s/''/'/;
	my $refine_postal = "<input type='text' name='postal' value='".&proc::conv_html_ref_2($$pd{postal})."' class='$switch::txt' style='width:91px;ime-mode:disabled;'>\n";

	my $live_1 = &item::pref();
	my $live_1_select;
	for(my $i=0; $i<@$live_1; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{live_1});
		$live_1_select .= "<label><input type='checkbox' name='live_1' value='$i' $c />$$live_1[$i]</label>　";
	}

	$$pd{live_2} =~ s/''/'/;
	my $refine_live_2 = "<input type='text' name='live_2' value='".&proc::conv_html_ref_2($$pd{live_2})."' class='$switch::txt' style='width:91px;' />\n";

	$$pd{phone} =~ s/''/'/;
	my $refine_phone = "<input type='text' name='phone' value='".&proc::conv_html_ref_2($$pd{phone})."' class='$switch::txt' style='width:92px;ime-mode:disabled;' />\n";

	my $job = &item::job();
	my $job_select;
	for(my $i=0; $i<@$job; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{job});
		$job_select .= "<label><input type='checkbox' name='job' value='$i' $c>$$job[$i]</label>　";
	}

	my $marr = &item::marr();
	my $marr_select;
	for(my $i=0; $i<@$marr; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{marr});
		$marr_select .= "<label><input type='checkbox' name='marr' value='$i' $c />$$marr[$i]</label>　";
	}

	my $child = &item::child();
	my $child_select;
	for(my $i=0; $i<@$child; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{child});
		$child_select .= "<label><input type='checkbox' name='child' value='$i' $c />$$child[$i]</label>　";
	}

	my $house = &item::house();
	my $house_select;
	for(my $i=0; $i<@$house; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{house});
		$house_select .= "<label><input type='checkbox' name='house' value='$i' $c />$$house[$i]</label>　";
	}

	my $pet = &item::pet();
	my $pet_select;
	for(my $i=0; $i<@$pet; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{pet});
		$pet_select .= "<label><input type='checkbox' name='pet' value='$i' $c />$$pet[$i]</label>　";
	}

	my $pet_kind = &item::pet_kind();
	my $pet_kind_select;
	for(my $i=0; $i<@$pet_kind; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{pet_kind});
		$pet_kind_select .= "<label><input type='checkbox' name='pet_kind' value='$i' $c />$$pet_kind[$i]</label>　";
	}

	my $interest = &item::interest();
	my $interest_select;
	for(my $i=0; $i<@$interest; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{interest});
		$interest_select .= "<label><input type='checkbox' name='interest' value='$i' $c />$$interest[$i]</label>　";
	}

	my $sports = &item::sports();
	my $sports_select;
	for(my $i=0; $i<@$sports; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{sports});
		$sports_select .= "<label><input type='checkbox' name='sports' value='$i' $c />$$sports[$i]</label>　";
	}

	my $trouble = &item::trouble();
	my $trouble_select;
	for(my $i=0; $i<@$trouble; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{trouble});
		$trouble_select .= "<label><input type='checkbox' name='trouble' value='$i' $c />$$trouble[$i]</label>　";
	}
	# 1.81 ############################
	my $udevice = &item::udevice();
	my $udevice_select;
	for(my $i=0; $i<@$udevice; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{udevice});
		$udevice_select .= "<label><input type='checkbox' name='udevice' value='$i' $c />$$udevice[$i]</label>　";
	}
	##################################
	my $refine_clicks = "
		<input type='text' name='under_clicks' value='$$pd{'under_clicks'}' class='$switch::ss_txt' style='ime-mode:disabled;' /> ～
		<input type='text' name='over_clicks'  value='$$pd{'over_clicks'}'  class='$switch::ss_txt' style='ime-mode:disabled;' />
	";

	my $refine_points = "
		<input type='text' name='under_points' value='$$pd{'under_points'}' class='$switch::ss_txt' style='ime-mode:disabled;' /> ～
		<input type='text' name='over_points'  value='$$pd{'over_points'}'  class='$switch::ss_txt' style='ime-mode:disabled;' />
	";

	my $domain = &item::domain();
	my $domain_select;
	for(my $i=1; $i<@$domain; $i++){
		my $c;	map{ if($_ == $i){$c = 'checked';} } split(/\0|,/,$$pd{domain});
		$domain_select .= "<label><input type='checkbox' name='domain' value='$i' $c />$$domain[$i]</label>　";
	}

	my $entry_select = &get::entry_sel_box();

	my($al,$max) = &get::attri_list();
	my $attri_select;
	if($max){
		unshift(@$al, {no => 0, name => '未設定'});
		foreach my $attri (@$al){
			my $c;	map{ if($_ == $$attri{no}){$c = 'checked';} } split(/\0|,/,$$pd{attri});
			$attri_select .= "<label><input type='checkbox' name='attri' value='$$attri{no}' $c />$$attri{name}</label>　";
		}
	}
	else{
		$attri_select = "属性が設定されていません";
	}
	##########################
	my $is_birthday = &item::is_birthday();
	my $is_birthday_select = "<select name='is_birthday' class='$switch::sel_main' style='width:60px;'>\n";
	for(my $i=0; $i<@$is_birthday; $i++){
		my $s = '';
		if($i == $$pd{is_birthday}){
			$s = 'selected';
		}
		$is_birthday_select .= "<option value='$i' $s>$$is_birthday[$i]</option>\n";
	}
	$is_birthday_select .= "</select>";
	$$pd{is_birthday_g} = '' if $$pd{is_birthday_g} == 0;
	$is_birthday_select .= " / <input type='text' class='$switch::ss_txt' name='is_birthday_g' value='$$pd{is_birthday_g}' style='ime-mode:disabled;' /> 日後";
	##########################
	# free info
	$$pd{id} = $id if !$$pd{id};
	my $free_list = &get::free_form_list($$pd{id});
	my ($free_refine_box, $free_date_box);
	if($free_list && @$free_list != 0){
		my @free_refine_box = ();
		my @free_date_box   = ();
		my @sub_box = ();	# 1.61
		foreach my $free_stg (@$free_list){
			if($$free_stg{form_type} == 6){
				# DATE-type
				my $date_select = &item::date_select();
				my $box = "<select name='is_free_$$free_stg{no}_$$free_stg{form_type}' class='$switch::sel_main'>\n";
				for(my $i=0; $i<@$date_select; $i++){
					my $s = $i == $$pd{"is_free_$$free_stg{no}_$$free_stg{form_type}"}
						? 'selected' : undef;
					my $val = $i == 0 ? undef : $i;
					$box .= "<option value='$val' $s>$$date_select[$i]</option>\n";
				}
				$box .= "</select>";
				$$pd{"is_free_$$free_stg{no}_$$free_stg{form_type}_g"} = '' if $$pd{"is_free_$$free_stg{no}_$$free_stg{form_type}_g"} == 0;

				push (@free_date_box, "
						<td class='free_name'>$$free_stg{form_name}</td>
						<td class='free_cont_date'>
							<input type='text' class='$switch::m_txt' name='free_$$free_stg{no}_$$free_stg{form_type}_from'
								value='".$$pd{"free_$$free_stg{no}_$$free_stg{form_type}_from"}."' 
							 style='ime-mode:disabled;' /> ～
							<input type='text' class='$switch::m_txt' name='free_$$free_stg{no}_$$free_stg{form_type}_to'
								value='".$$pd{"free_$$free_stg{no}_$$free_stg{form_type}_to"}."' 
							 style='ime-mode:disabled;' /> &amp;
							$box &amp;
							<input type='text' class='$switch::s_txt' name='is_free_$$free_stg{no}_$$free_stg{form_type}_g' 
								value='".$$pd{"is_free_$$free_stg{no}_$$free_stg{form_type}_g"}."' style='ime-mode:disabled;' /> 日後
						</td>
				");
			}
			else{
				my $parts_list = &get::free_parts_list($$free_stg{no});
				my $box_cont;
				my $sub_box_cont;
				if($$free_stg{form_type} >= 2 && $$free_stg{form_type} <= 4){
					# radio,checkbox,selectbox
					# 1.61 ##################################
					$box_cont = "<td class='free_cont'><span id='free_$$free_stg{no}_$$free_stg{form_type}' class='box_heading_sub'>候補</span></td>\n";

					$sub_box_cont .= "<div id='free_$$free_stg{no}_$$free_stg{form_type}' class='refinebox_sub'>";
					unshift(
						@$parts_list , {
							no				=> 0,
							parts_name		=> '未設定'
					});
					foreach my $parts_stg (@$parts_list){
						my $c;
						map { if($_ == $$parts_stg{no}){$c = 'checked';} } split(/\0|,/,$$pd{"free_$$free_stg{no}_$$free_stg{form_type}"});
						$sub_box_cont .= "<label><input type='checkbox' name='free_$$free_stg{no}_$$free_stg{form_type}' value='$$parts_stg{no}' $c />$$parts_stg{parts_name}</label>　";
					}
					$sub_box_cont .= "</div>\n";
					#########################################
				}
				else{
					# text,password,textarea
				 	my $val = $$pd{"free_$$free_stg{no}_$$free_stg{form_type}"};
				 	$val =~ s/''/'/g;
				 	$val = &proc::conv_html_ref_2($val);
					$box_cont .= "
						<td class='free_cont'>
							<input type='text' class='$switch::txt' name='free_$$free_stg{no}_$$free_stg{form_type}' value='$val' />
						</td>
					";
				}
				push (@free_refine_box,"
							<td class='free_name'>$$free_stg{form_name}</td>
							$box_cont
				");
				push (@sub_box,$sub_box_cont);	# 1.61
			} # else
		} # foreach

		my $i = 0;
		my $num = @free_refine_box;
		push (@free_refine_box, "<td class='free_name'>&nbsp;</td><td class='free_cont'>&nbsp;</td>\n") if $num % 2 == 1;
		foreach(@free_refine_box){
			$free_refine_box .= "<table class='nor'><tr>\n" if $i % 2 == 0;
			$free_refine_box .= $_."\n";
			if($i % 2 == 1){
				$free_refine_box .= "</tr></table>\n";
				$free_refine_box .= "<div class='$switch::tr'>\n$sub_box[$i-1]\n$sub_box[$i]\n</div>\n" if ($sub_box[$i-1] || $sub_box[$i]);
			}
			$i++;
		}
		foreach(@free_date_box){
			$free_date_box .= "<table class='nor'><tr>\n$_\n</tr></table>\n";
			$i++;
		}
		$free_refine_box .= $free_date_box;
	}
	else{
		$free_refine_box .= "<table class='nor'><tr><td>&nbsp;&nbsp;自由項目は設定されていません。</td></tr></table>\n";
	}
#	$free_refine_box .= "</table>\n";
	
	# Error diags box 1.75
	my @error_diags = &item::error_diags();
	my $diag_num = @error_diags;
	my $i = 0;
	my $diag_refine_box = "<table class='nor'>\n";
	foreach(@error_diags){
		if($config::oem && $$_[0] eq 'Auto_return'){$diag_num--; next;} 
		$diag_refine_box .= "<tr>" if $i % 2 == 0;
		$diag_refine_box .= "<td class='diag_name'>$$_[1]</td><td class='diag_cont'><input type='text' class='$switch::s_txt' name='under_diag_$$_[0]' value='".$$pd{'under_diag_'.$$_[0]}."' style='ime-mode:disabled;' /> ～ <input type='text' class='$switch::s_txt' name='over_diag_$$_[0]' value='".$$pd{'over_diag_'.$$_[0]}."' style='ime-mode:disabled;' /></td>";
		$diag_refine_box .= "<td>&nbsp;</td><td>&nbsp;</td>" if ($i+1 == $diag_num && $i % 2 == 0);
		$diag_refine_box .= "</tr>\n" if $i % 2 == 1;
		$i++;
	}
	$diag_refine_box .= "</table>\n";

	my $menu = <<MENU;
				<table>
					<tr>
					<td class='fixed_name_span'>名前 / メールアドレス</td><td class='fixed_cont_span'>$refine_kw</td>
					<td class='fixed_name'>登録</td><td class='fixed_cont'><span id='regist_mode' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>獲得元</td><td class='fixed_cont'><span id='regist_from' class='box_heading_sub'>候補</span></td>
					</tr>
				</table>
				<div class='$switch::tr'>
					<div id='regist_mode' class='refinebox_sub'>$regist_select</div>
					<div id='regist_from' class='refinebox_sub'>$r_f_select</div>
				</div>
				<table>
					<tr>
					<td class='fixed_name'>性別</td><td class='fixed_cont'><span id='sex' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>郵便</td><td class='fixed_cont'>$refine_postal</td>
					<td class='fixed_name'>住所1</td><td class='fixed_cont'><span id='live_1' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>住所2</td><td class='fixed_cont'>$refine_live_2</td>
					</tr>
				</table>
				<div class='$switch::tr'>
					<div id='sex' class='refinebox_sub'>$sex_select</div>
					<div id='live_1' class='refinebox_sub'>$live_1_select</div>
				</div>
				<table>
					<tr>
					<td class='fixed_name'>電話</td><td class='fixed_cont'>$refine_phone</td>
					<td class='fixed_name'>年齢</td><td class='fixed_cont'>$refine_age</td>
					<td class='fixed_name'>職業</td><td class='fixed_cont'><span id='job' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>結婚</td><td class='fixed_cont'><span id='marr' class='box_heading_sub'>候補</span></td>
					</tr>
				</table>
				<div class='$switch::tr'>
					<div id='job' class='refinebox_sub'>$job_select</div>
					<div id='marr' class='refinebox_sub'>$marr_select</div>
				</div>
				<table>
					<tr>
					<td class='fixed_name'>子供</td><td class='fixed_cont'><span id='child' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>住居</td><td class='fixed_cont'><span id='house' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>ペット</td><td class='fixed_cont'><span id='pet' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>種類</td><td class='fixed_cont'><span id='pet_kind' class='box_heading_sub'>候補</span></td>
					</tr>
				</table>
				<div class='$switch::tr'>
					<div id='child' class='refinebox_sub'>$child_select</div>
					<div id='house' class='refinebox_sub'>$house_select</div>
					<div id='pet' class='refinebox_sub'>$pet_select</div>
					<div id='pet_kind' class='refinebox_sub'>$pet_kind_select</div>
				</div>
				<table>
					<tr>
					<td class='fixed_name'>興味</td><td class='fixed_cont'><span id='interest' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>スポーツ</td><td class='fixed_cont'><span id='sports' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>悩み</td><td class='fixed_cont'><span id='trouble' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>携帯/PC</td><td class='fixed_cont'><span id='domain' class='box_heading_sub'>候補</span></td>
					</tr>
				</table>

				<div class='$switch::tr'>
					<div id='interest' class='refinebox_sub'>$interest_select</div>
					<div id='sports' class='refinebox_sub'>$sports_select</div>
					<div id='trouble' class='refinebox_sub'>$trouble_select</div>
					<div id='domain' class='refinebox_sub'>$domain_select</div>
				</div>

				<table>
					<tr>
					<td class='fixed_name'>受信端末</td><td class='fixed_cont'><span id='udevice' class='box_heading_sub'>候補</span></td>
					<td class='fixed_name'>クリック</td><td class='fixed_cont'>$refine_clicks</td>
					<td class='fixed_name'>ポイント</td><td class='fixed_cont'>$refine_points</td>
					<td class='fixed_name'>属性</td><td class='fixed_cont'><span id='attri' class='box_heading_sub'>候補</span></td>
					</tr>
				</table>

				<div class='$switch::tr'>
					<div id='udevice' class='refinebox_sub'>$udevice_select</div>
					<div id='attri' class='refinebox_sub'>$attri_select</div>
				</div>

				<table>
					<tr>
					<td class='fixed_name_span2'>登録日</td>
					<td class='fixed_cont_span2' colspan='7'>$entry_select&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;誕生日&nbsp;$is_birthday_select</td>
					</tr>
				</table>
MENU

#die $free_refine_box;

	return (
		$menu,
		$regist_mode,
		$regist_from,
		$free_refine_box,
		$diag_refine_box	# 1.75
	);
}

sub user_data{ # Case user list contorol
#	my %pd = ();
#	my $pd = \%pd;
	### Case delivery ########
#	if(@_){
#		($$pd{id},$$pd{filter},$$pd{filter_cont}) = @_;
#		$$pd{active} = 1;
#		if($$pd{filter}){
#			foreach(split(/&/,$$pd{filter_cont})){
#				$_ =~ /(.+)=(.*)/;
#				if($2){
#					$$pd{$1} = $2;
#				}
#			}
#		}
#	}
#	### Case user list contorol ###
#	else{
	my $pd = $F->Vars;
#	}
	####################################
	my $id = $$pd{id};
	undef $pd if $F->param("save_users_edit");
	my $sql = &get::filtering_sql(
		$pd,
		$id,
		undef,	# WHERE
		undef	# Given select columun
	);
	####################################
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? " LIMIT ".($start-1).",". $view_count
		: undef;
	$sql .= $limit;
	####################################
#die $sql;
	&db::query($sql);
	my @ul = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@ul,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@ul,$max);
}

sub user_nos{	# Case delivery
	my %pd = (
		id				=> $_[0],
		filter			=> $_[1],
		filter_cont	=> $_[2],
		active			=> 1
	);
	if($pd{filter}){
		foreach(split(/&/,$pd{filter_cont})){
			$_ =~ /(.+)=(.*)/;
			#if($2){
			if($2 ne ''){
				$pd{$1} = $2;
			}
		}
	}
	my $sql = &get::filtering_sql(
		\%pd,
		$pd{id},
		undef,	# Given WHERE
		'no'	# Given select columun
	);
#die $sql;
	my @un = ();
	&db::query($sql);
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@un, $href);
	}
	return \@un;
}
sub filtering_sql{
	my (
		$pd,
		$id,
		$where,
		$slct_clm
	) = @_;
	$$pd{id} = $id if !$$pd{id};

	my @in = (); my $in = '';

	if($$pd{active} ne ''){
		push(@in, "`ms_user_$$pd{id}`.active=$$pd{active}");
	}	
	if($$pd{kw}){
		$$pd{kw} =~ s/'/''/g;
		$$pd{kw} =~ s/\\/\\\\/g;
		#push(@in, '('.
		#	join(
		#		' OR ',
		#		map {
		#			"(`ms_user_$$pd{id}`.name LIKE '%$_%' OR `ms_user_$$pd{id}`.email LIKE '%$_%')"
		#		} split(/,/, $$pd{kw})
		#	).
		#')');
		my @tmp = ();
		foreach(split(/,/, $$pd{kw})){
			push(@tmp, "(`ms_user_$$pd{id}`.name LIKE '%$_%' OR `ms_user_$$pd{id}`.email LIKE '%$_%')")
			if($_ && $_ !~ /^[\s　]+$/);
		}
		push(@in, '('.join(' OR ',@tmp).')') if(@tmp != 0);
	}
	if($$pd{regist_mode}){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{regist_mode})){	# 1.61
			push(@tmp, "`ms_user_$$pd{id}`.regist_mode=$_");
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}	
	if($$pd{regist_from} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{regist_from})){	# 1.61
			if($_ eq '0'){
				push(@tmp,"(
						`ms_user_$$pd{id}`.regist_from = '0'		OR
						`ms_user_$$pd{id}`.regist_from = ''		OR
						`ms_user_$$pd{id}`.regist_from IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.regist_from = '$_'");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Sex
	if($$pd{sex} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{sex})){		# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.sex = 0		OR
						`ms_user_$$pd{id}`.sex = ''		OR
						`ms_user_$$pd{id}`.sex IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.sex = $_");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Postal
	if($$pd{postal}){
		$$pd{postal} =~ s/'/''/g;
		push(@in, "`ms_user_$$pd{id}`.postal LIKE '%$$pd{postal}%'");
	}
	###### Live_1
	if($$pd{live_1} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{live_1})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.live_1 = 0		OR
						`ms_user_$$pd{id}`.live_1 = ''		OR
						`ms_user_$$pd{id}`.live_1 IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.live_1=$_");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Live_2
	if($$pd{live_2}){
		$$pd{live_2} =~ s/'/''/g;
		push(@in, "`ms_user_$$pd{id}`.live_2 LIKE '%$$pd{live_2}%'");
	}
	###### phone
	if($$pd{phone}){
		$$pd{phone} =~ s/'/''/g;
		push(@in, "`ms_user_$$pd{id}`.phone LIKE '%$$pd{phone}%'");
	}
	###### Age
	#if($$pd{under_age}){
	if($$pd{under_age} ne ''){
		push(@in, "`ms_user_$$pd{id}`.birth!='0000-00-00' AND (YEAR(CURRENT_DATE())-YEAR(birth)) - (RIGHT(CURRENT_DATE(),5) < RIGHT(`ms_user_$$pd{id}`.birth,5)) >= $$pd{under_age}");
	}
	#if($$pd{over_age}){
	if($$pd{over_age} ne ''){
		push(@in, "`ms_user_$$pd{id}`.birth!='0000-00-00' AND (YEAR(CURRENT_DATE())-YEAR(birth)) - (RIGHT(CURRENT_DATE(),5) < RIGHT(`ms_user_$$pd{id}`.birth,5)) <= $$pd{over_age}");
	}
	###### Job
	if($$pd{job} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{job})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.job = 0		OR
						`ms_user_$$pd{id}`.job = ''		OR
						`ms_user_$$pd{id}`.job IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.job = $_");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	####### Clicks
	#if($$pd{under_clicks}){
	if($$pd{under_clicks} ne ''){
		push(@in, "`ms_user_$$pd{id}`.clicks >= $$pd{under_clicks}");
	}	
	#if($$pd{over_clicks}){
	if($$pd{over_clicks} ne ''){
		push(@in, "`ms_user_$$pd{id}`.clicks <= $$pd{over_clicks}");
	}
	######## Points
	#if($$pd{under_points}){
	if($$pd{under_points} ne ''){
		push(@in, "`ms_user_$$pd{id}`.points >= $$pd{under_points}");
	}	
	#if($$pd{over_points}){
	if($$pd{over_points} ne ''){
		push(@in, "`ms_user_$$pd{id}`.points <= $$pd{over_points}");
	}
	###### Marr
	if($$pd{marr} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{marr})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.marr = 0			OR
						`ms_user_$$pd{id}`.marr = ''		OR
						`ms_user_$$pd{id}`.marr IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.marr = $_");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Child
	if($$pd{child} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{child})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.child = 0		OR
						`ms_user_$$pd{id}`.child = ''		OR
						`ms_user_$$pd{id}`.child IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.child= $_ ");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### House
	if($$pd{house} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{house})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.house = 0		OR
						`ms_user_$$pd{id}`.house = ''		OR
						`ms_user_$$pd{id}`.house IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.house= $_ ");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Pet
	if($$pd{pet} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{pet})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.pet = 0		OR
						`ms_user_$$pd{id}`.pet = ''		OR
						`ms_user_$$pd{id}`.pet IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.pet = $_ ");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Pet kind
	if($$pd{pet_kind} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{pet_kind})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.pet_kind = 0			OR
						`ms_user_$$pd{id}`.pet_kind = ''		OR
						`ms_user_$$pd{id}`.pet_kind IS NULL
					)"
				);
			}
			else{
				push(@tmp, "FIND_IN_SET('$_', `ms_user_$$pd{id}`.pet_kind) > 0");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Id
	if($$pd{uid}){
		$$pd{uid} =~ s/'/''/g;
		push(@in, "`ms_user_$$pd{id}`.uid LIKE '%$$pd{uid}%'");
	}
	###### Interest
	if($$pd{interest} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{interest})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.interest = 0			OR
						`ms_user_$$pd{id}`.interest = ''		OR
						`ms_user_$$pd{id}`.interest IS NULL
					)"
				);
			}
			else{
				push(@tmp, "FIND_IN_SET('$_', `ms_user_$$pd{id}`.interest) > 0");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Sports
	if($$pd{sports} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{sports})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.sports = 0			OR
						`ms_user_$$pd{id}`.sports = ''		OR
						`ms_user_$$pd{id}`.sports IS NULL
					)"
				);
			}
			else{
				push(@tmp, "FIND_IN_SET('$_', `ms_user_$$pd{id}`.sports) > 0");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	###### Trouble
	if($$pd{trouble} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{trouble})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.trouble = 0			OR
						`ms_user_$$pd{id}`.trouble = ''			OR
						`ms_user_$$pd{id}`.trouble IS NULL
					)"
				);
			}
			else{
				push(@tmp, "FIND_IN_SET('$_', `ms_user_$$pd{id}`.trouble) > 0");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	# User Device 1.81
	if($$pd{udevice} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{udevice})){
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.udevice = 0		OR
						`ms_user_$$pd{id}`.udevice = ''		OR
						`ms_user_$$pd{id}`.udevice IS NULL
					)"
				);
			}
			else{
				push(@tmp, "`ms_user_$$pd{id}`.udevice = $_");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	####### Entry
	if($$pd{entry_year_from} && $$pd{entry_mon_from} && $$pd{entry_day_from}){
		push(@in, "`ms_user_$$pd{id}`.entry >= '$$pd{entry_year_from}-$$pd{entry_mon_from}-$$pd{entry_day_from}'");
	}
	if($$pd{entry_year_to} && $$pd{entry_mon_to} && $$pd{entry_day_to}){
		push(@in, "`ms_user_$$pd{id}`.entry <= '$$pd{entry_year_to}-$$pd{entry_mon_to}-$$pd{entry_day_to}'");
	}	
	####### Attri	
#die $$pd{attri};
	if($$pd{attri} ne ''){
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{attri})){	# 1.61
			if($_ == 0){
				push(@tmp,"(
						`ms_user_$$pd{id}`.attri_1 = 0 AND 
						`ms_user_$$pd{id}`.attri_2 = 0 AND
						`ms_user_$$pd{id}`.attri_3 = 0 AND 
						`ms_user_$$pd{id}`.attri_4 = 0 AND 
						`ms_user_$$pd{id}`.attri_5 = 0 AND 
						`ms_user_$$pd{id}`.attri_6 = 0 AND
						`ms_user_$$pd{id}`.attri_7 = 0 AND
						`ms_user_$$pd{id}`.attri_8 = 0 AND
						`ms_user_$$pd{id}`.attri_9 = 0
					)"
				);
			}
			else{
				push(@tmp, "(
						`ms_user_$$pd{id}`.attri_1 = $_ OR 
						`ms_user_$$pd{id}`.attri_2 = $_ OR 
						`ms_user_$$pd{id}`.attri_3 = $_ OR 
						`ms_user_$$pd{id}`.attri_4 = $_ OR 
						`ms_user_$$pd{id}`.attri_5 = $_ OR 
						`ms_user_$$pd{id}`.attri_6 = $_ OR 
						`ms_user_$$pd{id}`.attri_7 = $_ OR 
						`ms_user_$$pd{id}`.attri_8 = $_ OR 
						`ms_user_$$pd{id}`.attri_9 = $_
					)");
			}
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}
	####### PC or mobile
	if($$pd{domain}){
		my $mob_doms = &get::mobile_domain();
		my @grep = ();
		foreach my $key (keys %$mob_doms){
			foreach my $dom (@{$$mob_doms{$key}}){
				push(@grep,$dom);
			}
		}
		my @tmp = ();
		foreach(split(/\0|,/, $$pd{domain})){	# 1.61
			if($_ == 1){	# mobile address
				push(@tmp, "`ms_user_$$pd{id}`.email REGEXP '@(".join("|",@grep).")\$'");
			}	
			elsif($_ == 2){	# PC address
				push(@tmp, "`ms_user_$$pd{id}`.email NOT REGEXP '@(".join("|",@grep).")\$'");
			}	
		}
		push(@in, '('.join(' OR ',@tmp).')');
	}	
	####### Is_birthday
	if($$pd{is_birthday}){
		if($$pd{is_birthday} == 1){	# Today
			push(@in, "DATE_FORMAT(
							CURRENT_DATE(),
							'\%m-\%d'
						) =
						DATE_FORMAT(
							`ms_user_$$pd{id}`.birth,
							'\%m-\%d'
						)
			");
		}
		elsif($$pd{is_birthday} == 2){	# Tomorrow
			push(@in, "DATE_FORMAT(
							DATE_ADD(
								CURRENT_DATE(),
								INTERVAL 1 DAY
							),'\%m-\%d'
						) =
						DATE_FORMAT(
							`ms_user_$$pd{id}`.birth,
							'\%m-\%d'
						)
			");
    	}	
		elsif($$pd{is_birthday} == 3){	# ToWeek
			push(@in, "WEEK(
							CURRENT_DATE(),
							0
						) = WEEK(
							CONCAT_WS(
								'-',
								YEAR(CURRENT_DATE()),
								DATE_FORMAT(
									`ms_user_$$pd{id}`.birth,
									'\%m-\%d'
								)
							),
							0
						)
			");
    	}	
		elsif($$pd{is_birthday} == 4){	# Next Week
			push(@in, "WEEK(
							CURRENT_DATE(),
							0
						) - WEEK(
							CONCAT_WS(
								'-',
								YEAR(CURRENT_DATE()),
								DATE_FORMAT(
									`ms_user_$$pd{id}`.birth,
									'\%m-\%d'
								)
							),
							0
						) = -1
			");
    	}	
		elsif($$pd{is_birthday} == 5){	# ToMonth
			push(@in, "MONTH(CURRENT_DATE()) = MONTH(`ms_user_$$pd{id}`.birth)");
    	}	
		elsif($$pd{is_birthday} == 6){	# NextMonth
			push(@in, "(
				MONTH(CURRENT_DATE()) - MONTH(`ms_user_$$pd{id}`.birth) = -1	OR
				MONTH(CURRENT_DATE()) - MONTH(`ms_user_$$pd{id}`.birth) = 11
			)");
    	}	
	}
	if($$pd{is_birthday_g} && $$pd{is_birthday_g} =~ /^\-?\d+$/){
			push(@in,	"DATE_FORMAT(
							DATE_ADD(
								CURRENT_DATE(),
								INTERVAL $$pd{is_birthday_g} DAY
							),'\%m-\%d'
						) =
						DATE_FORMAT(
							`ms_user_$$pd{id}`.birth,
							'\%m-\%d'
						)"
			);
	}	

#	if(@in != 0){
#		$in = join(" AND ", @in);
#	}
	
	# Set free info
	my @free_in = ();
	my @free_num = ();
	foreach(keys %$pd){
		if($_ =~ /^(is_)?free_(\d+)_(\d+)(_\w+)?$/ && $$pd{$_} ne ''){
			my($is,$form_no,$form_type,$from_to_g) = ($1,$2,$3,$4);
			my $unpush = 0;	# 1.70
			foreach my $cont (split(/\0|,/,$$pd{$_})){	# 1.61
				if($cont eq '0'){
					# 1.79 ～ #########################
					#push(@free_in,	"(
					#			SELECT	`ms_user_$$pd{id}`.no	AS user_no,
					#					'$form_no'					AS form_no
					#			FROM	`ms_user_$$pd{id}`
					#			LEFT JOIN (
					#				SELECT `ms_freeusersinfo`.user_no
					#				FROM	`ms_freeusersinfo`
					#				WHERE
					#					`ms_freeusersinfo`.id      = '$$pd{id}' AND
					#					`ms_freeusersinfo`.form_no = $form_no
					#			) AS uc_$form_no
					#			ON		`ms_user_$$pd{id}`.no = `uc_$form_no`.user_no
					#			WHERE	`uc_$form_no`.user_no IS NULL
					#)");
					# ※LEFTJOINの中でSELECTを使うと、検索数増えたときに極端に遅くなるのでSELECTせずにON句で条件指定する
					push(@free_in,	"(
								SELECT	   `ms_user_$$pd{id}`.no AS user_no,
										   '$form_no'            AS form_no
								FROM	   `ms_user_$$pd{id}`
								LEFT JOIN `ms_freeusersinfo`    AS uc_$form_no
								ON        `ms_user_$$pd{id}`.no = `uc_$form_no`.user_no AND
								          `uc_$form_no`.id      = '$$pd{id}'            AND
								          `uc_$form_no`.form_no = $form_no
								WHERE     `uc_$form_no`.user_no IS NULL
					)");
					###################################
				}
				else{
					my $union = "(
						SELECT `ms_freeusersinfo`.user_no	AS user_no,
								`ms_freeusersinfo`.form_no	AS form_no
						FROM	`ms_freeusersinfo`
						WHERE
							`ms_freeusersinfo`.id      = '$$pd{id}' AND
							`ms_freeusersinfo`.form_no = $form_no   AND
					";
					if($form_type >= 2 && $form_type <= 4){
						$union .= "
							`ms_freeusersinfo`.parts_cont = '$cont'
						";
					}
					elsif($form_type == 6){
						# DATE-type
						if($from_to_g eq '_from'){
							$union .= "
								DATE(`ms_freeusersinfo`.parts_cont) >= '$cont'
							";
							if($$pd{'free_'.$form_no.'_'.$form_type.'_to'}){
								$union .= "
									AND DATE(`ms_freeusersinfo`.parts_cont) <= '".$$pd{'free_'.$form_no.'_'.$form_type.'_to'}."'
								";
							}
						}
						elsif($from_to_g eq '_to'){
							if($$pd{'free_'.$form_no.'_'.$form_type.'_from'}){
								$unpush = 1;
								next;
							}
							else{
								$union .= "
									DATE(`ms_freeusersinfo`.parts_cont) <= '$cont'
								";
							}
						}
						elsif($is eq 'is_'){		
							if($from_to_g eq '_g'){
								# given
								$union .= "
									DATE_ADD(
										CURRENT_DATE(),
										INTERVAL $cont DAY
									) =
									DATE_FORMAT(
										`ms_freeusersinfo`.parts_cont,
										'\%Y-\%m-\%d'
									)
								";
							}
							else{
								if($cont == 1){	# Today
									$union .= "
										CURRENT_DATE() =
										DATE_FORMAT(
											`ms_freeusersinfo`.parts_cont,
											'\%Y-\%m-\%d'
										)
									";
								}
								elsif($cont == 2){	# Tomorrow
									$union .= "
										DATE_ADD(
											CURRENT_DATE(),
											INTERVAL 1 DAY
										) =
										DATE_FORMAT(
											`ms_freeusersinfo`.parts_cont,
											'\%Y-\%m-\%d'
										)
									";
    							}
								elsif($cont == 3){	# ToWeek
									$union .= "(
										YEARWEEK(CURRENT_DATE(),0) = 
										YEARWEEK(
											DATE_FORMAT(
												`ms_freeusersinfo`.parts_cont,
												'\%Y-\%m-\%d'
											),
											0
										)
									)";
					    		}
								elsif($cont == 4){	# Next Week
									$union .= "(
										YEARWEEK(CURRENT_DATE(),0) - 
										YEARWEEK(
											DATE_FORMAT(
												`ms_freeusersinfo`.parts_cont,
												'\%Y-\%m-\%d'
											),
											0
										) = -1
									)";
	   							}
								elsif($cont == 5){	# ToMonth
									$union .= "
										DATE_FORMAT(
											CURRENT_DATE(),
											'\%Y-\%m'
										) = 
										DATE_FORMAT(
											`ms_freeusersinfo`.parts_cont,
											'\%Y-\%m'
										)
									";
					    		}
								elsif($cont == 6){	# NextMonth
									$union .= "
										DATE_FORMAT(
											ADDDATE(
												CURRENT_DATE(),
												interval 1 month
											),
											'\%Y-\%m'
										) =  
										DATE_FORMAT(
											`ms_freeusersinfo`.parts_cont,
											'\%Y-\%m'
										)
									";
					    		}
					    	}	
						}
					} # end DATE type 
					else{
						# text,password,textarea
						$cont =~ s/'/''/g;
						$union .= "
							`ms_freeusersinfo`.parts_cont LIKE '%$cont%'
						";
					}

					$union .= "\n)\n";
					push(@free_in,$union);

				} # else

			} # foreach(free sub) # 1.61		

			push(@free_num,$form_no) if !$unpush;	# 1.70

		} # if
		# 1.75 ####################
		elsif($_ =~ /^under_diag_(\w+)?$/ && $$pd{$_} ne ''){
			push(@in, "`ms_user_$$pd{id}`.$1 >= $$pd{$_}");
		}
		elsif($_ =~ /^over_diag_(\w+)?$/ && $$pd{$_} ne ''){
			push(@in, "`ms_user_$$pd{id}`.$1 <= $$pd{$_}");
		}
		###########################
	} # foreach(free form, error diags)
	# 1.75 #################
	if(@in != 0){
		$in = join(" AND ", @in);
	}
	########################

	my $free_in;
	if(@free_in != 0){
		$free_in = join(" UNION ALL ", @free_in);
	}

	$slct_clm = $slct_clm ? $slct_clm : '*';
	my 	$slct_clm_2 = $slct_clm;	# 1.79
	$slct_clm .= ", COUNT(DISTINCT `uni`.form_no) AS free_num" if $free_in;
	
	# 1.79 ############################
	#my $sql = "
	#	SELECT	SQL_CALC_FOUND_ROWS
	#			`ms_user_$$pd{id}`.$slct_clm
	#	FROM	`ms_user_$$pd{id}`
	#";
	# INNER JOINの結果が多いとORDER BYで遅くなるので、一度テンポラリテーブルにセット
	# テーブル名はfork時に名前が重複（already exists）しないようランダムで命名
	# SQL_CALC_FOUND_ROWSは最後のSELECTで取得するのでここでは不要
	my $temp_tbl = 'temp_'.&get::rand_str(16,'0-9');
	my $sql = "
	CREATE TEMPORARY TABLE `$temp_tbl`
		SELECT `ms_user_$$pd{id}`.$slct_clm
		FROM	`ms_user_$$pd{id}`
	";
	###################################
	if($free_in){
		$sql .= "
			INNER JOIN (".$free_in.") AS uni
			ON `ms_user_$$pd{id}`.no = `uni`.user_no
		";
	}

	$sql .= " WHERE " .$in    if $in;
	$sql .= " AND "   .$where if $where;

#	if($free_in || $free_uc_in){
	if($free_in){
		# 1.79 #################
		#$sql .= "
		#	GROUP BY	`ms_user_$$pd{id}`.no
		#	HAVING		free_num >= " .@free_num;
		#	「GROUP BY `ms_user_$$pd{id}`.no」だとデータ量多いときに遅くなるのでINNER JOIN時のINDEXカラム（no）をキーに使用
		$sql .= "
			GROUP BY	`uni`.user_no
			HAVING		free_num >= " .@free_num;
		#######################
	}
	# 1.79～ テンポラリテーブル作るために一旦SQLの区切り
	$sql .= "\nMS_SQL_SAPARATOR\n";

	my $order;
	# 1.79 #################
=pod
	if($$pd{order} eq "new"){
		$order = " ORDER BY `ms_user_$$pd{id}`.no DESC";
	}
	elsif($$pd{order} eq "entry"){
		$order = " ORDER BY `ms_user_$$pd{id}`.no ASC";
	}
	elsif($$pd{order} eq "email"){
		$order = " ORDER BY `ms_user_$$pd{id}`.email ASC, `ms_user_$$pd{id}`.no DESC";
	}
	elsif($$pd{order} eq "clicks" || $$pd{order} eq "points"){ 
		$order = " ORDER BY `ms_user_$$pd{id}`.$$pd{order} DESC, `ms_user_$$pd{id}`.no DESC";
	}
	elsif($$pd{order} eq 'clicks_asc'){ 
		$order = " ORDER BY `ms_user_$$pd{id}`.clicks ASC, `ms_user_$$pd{id}`.no DESC";
	}
	else{
		$order = " ORDER BY `ms_user_$$pd{id}`.no DESC";
	}
=cut
	if($$pd{order} eq "new"){
		$order = " ORDER BY `$temp_tbl`.no DESC";
	}
	elsif($$pd{order} eq "entry"){
		$order = " ORDER BY `$temp_tbl`.no ASC";
	}
	elsif($$pd{order} eq "email"){
		$order = " ORDER BY `$temp_tbl`.email ASC, `$temp_tbl`.no DESC";
	}
	elsif($$pd{order} eq "clicks" || $$pd{order} eq "points"){ 
		$order = " ORDER BY `$temp_tbl`.$$pd{order} DESC, `$temp_tbl`.no DESC";
	}
	elsif($$pd{order} eq 'clicks_asc'){ 
		$order = " ORDER BY `$temp_tbl`.clicks ASC, `$temp_tbl`.no DESC";
	}
	else{
		$order = " ORDER BY `$temp_tbl`.no DESC";
	}
	#$sql .= "SELECT * FROM `$temp_tbl` ".$order;
	$sql .= "SELECT SQL_CALC_FOUND_ROWS `$temp_tbl`.$slct_clm_2 FROM `$temp_tbl` ".$order;
	#########################
#die $sql;
	return $sql;
}

sub one_user_data{
	my $id = $F->param('id') || $_[0];
	my $no = $F->param('no') || $_[1];
	&show::error("この読者は登録されていないか、すでにリストから削除されています。",$EC.__LINE__) if !$no;
	&db::query("SELECT * FROM `ms_user_$id` WHERE no = $no");
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}
sub delivers_count{
	my ($id,$his_no) = @_;
	&db::query("
		SELECT	COUNT(*)
		FROM	`ms_delivers`
		WHERE	id = '$id'			AND
				his_no = $his_no
	");
	return $db::sth->fetchrow_array();
}
sub deliver{
	my ($id,$his_no) = @_;
#	&db::query("
#		SELECT		*
#		FROM		`ms_delivers`
#		WHERE		id = '$id'			AND
#					his_no = $his_no
#		ORDER BY	no
#		LIMIT 1
#	");
	# 1.68 ～ Drop "ORDER BY" clause
	&db::query("
		SELECT		*
		FROM		`ms_delivers`
		WHERE		id = '$id' AND his_no = $his_no
		LIMIT 1
	");
	return $db::sth->fetchrow_hashref();
}
sub delivered{
	my ($id,$his_no,$start,$limit) = @_;
	$limit = $limit ? "LIMIT $start,$limit" : undef;
	&db::query("
		SELECT		*
		FROM		`ms_delivered`
		WHERE		id = '$id'			AND
					his_no = $his_no
		ORDER BY	no
		$limit
	");
	my @dl = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@dl,$href);
	}
	return \@dl;
}
sub one_user_data2{
	my ($id,$user_no) = @_;
	#&db::query("
	#	SELECT	*
	#	FROM	`ms_user_$id`
	#	WHERE	no = $user_no
	#");
	# 1.80 ######################
	# ms_deliversにセットされた後に配信停止状態になった場合も配信しないよう
	# 配信可能状態の読者データだけを得る
	&db::query("
		SELECT	*
		FROM	`ms_user_$id`
		WHERE	no = $user_no AND active = 1
	");
	#############################
	return $db::sth->fetchrow_hashref();
}
sub current{
	my @l = localtime();
	$l[0] = sprintf ("%02d", $l[0]);	#sec
	$l[1] = sprintf ("%02d", $l[1]);	#min
	$l[2] = sprintf ("%02d", $l[2]);	#hour
	$l[3] = sprintf ("%02d", $l[3]);	#day
	$l[4]++;
	$l[4] = sprintf ("%02d", $l[4]);	#month
	$l[5] = $l[5]+1900;					#year
	return @l;
}
#################################################
#sub target_users1{	# Step mail user
sub target_user_nos1{	# Step mail user

}
##############################################################
sub res_sel_box{
	my ($res_date,$res_time) = @_;
	my ($res_year, $res_mon, $res_day,$res_hour,$res_min);
	my ($sec, $min, $hour, $mday, $mon, $year) = &get::current();
	if($res_date =~ /(\d+)-(\d+)-(\d+)/ && $res_date ne '0000-00-00'){
		($res_year, $res_mon, $res_day) = ($1,$2,$3);
	}
	else{
		($res_year, $res_mon, $res_day) = ($year,$mon,$mday);
	}
	if($res_time =~ /(\d+):(\d+):\d+/ && $res_date ne '0000-00-00'){
		($res_hour,$res_min) = ($1,$2);
	}
	else{
		$min =~ s/(\d)\d/$1\0/;
		($res_hour,$res_min) = ($hour,$min);
	}
	my @year  = ($year, $year+1);
	my @month = (1..12);
	my @day   = (1..31);
	my @hour  = (0..23);
	my @min   = ('00',10,20,30,40,50);
	######### Set year
	my $box = "<select name='res_year' class='$switch::sel_main'>\n";
	foreach(@year){
		my $s_y = "";
		if($_ == $res_year){
			$s_y = "selected";
		}
		$box .= "<option value='$_' $s_y>$_</option>\n";
	}
	$box .= "</select> 年 \n";
	######### Set month
	$box .= "<select name='res_mon' class='$switch::sel_main'>\n";
	foreach(@month){
		my $s_m = "";
		if($_ == $res_mon){
			$s_m = "selected";
		}
		$box .= "<option value='$_' $s_m>$_</option>\n";
	}
	$box .= "</select> 月 \n";
	######## Set day
	$box .= "<select name='res_day' class='$switch::sel_main'>\n";
	foreach(@day){
		my $s_d = "";
		if($_ == $res_day){
			$s_d = "selected";
		}
		$box .= "<option value='$_' $s_d>$_</option>\n";
	}
	$box .= "</select> 日 \n";
	######### Set hour
	$box .= "<select name='res_hour' class='$switch::sel_main'>\n";
	foreach(@hour){
		my $s_h = "";
		if($_ == $res_hour){
			$s_h = "selected";
		}
		$box .= "<option value='$_' $s_h>$_</option>\n";
	}
	$box .= "</select> 時 \n";
	######### Set minutes
	$box .= "<select name='res_min' class='$switch::sel_main'>\n";
	foreach(@min){
		my $s_m = "";
		if($_ == $res_min){
			$s_m = "selected";
		}
		$box .= "<option value='$_' $s_m>$_</option>\n";
	}
	$box .= "</select> 分 \n";
	
	return $box;
}
sub entry_sel_box{
	my $pd = $F->Vars;
	my ($sec, $min, $hour, $mday, $mon, $year) = &get::current();
	my @year  = ('',reverse($year-80..$year));
	my @month = ('',1..12);
	my @day   = ('',1..31);
	######### Set from year
	my $box = "<select name='entry_year_from' class='$switch::sel_main'>\n";
	foreach(@year){
		my $s = "";
		if($_ == $$pd{'entry_year_from'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select> - ";
	######### Set from month
	$box .= "<select name='entry_mon_from' class='$switch::sel_main'>\n";
	foreach(@month){
		my $s = "";
		if($_ == $$pd{'entry_mon_from'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select> - ";
	######## Set from day
	$box .= "<select name='entry_day_from' class='$switch::sel_main'>\n";
	foreach(@day){
		my $s = "";
		if($_ == $$pd{'entry_day_from'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select>\n";
	$box .= '～ ';
	######### Set to year
	$box .= "<select name='entry_year_to' class='$switch::sel_main'>\n";
	foreach(@year){
		my $s = "";
		if($_ == $$pd{'entry_year_to'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select> - ";
	######### Set to month
	$box .= "<select name='entry_mon_to' class='$switch::sel_main'>\n";
	foreach(@month){
		my $s = "";
		if($_ == $$pd{'entry_mon_to'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select> - ";
	######## Set to day
	$box .= "<select name='entry_day_to' class='$switch::sel_main'>\n";
	foreach(@day){
		my $s = "";
		if($_ == $$pd{'entry_day_to'}){
			$s = "selected";
		}
		$box .= "<option value='$_' $s>$_</option>\n";
	}
	$box .= "</select>\n";
	
	return $box;

}
######################################################
=pod
sub sex_ch_box{
	my @sex = &item::sex();
	my $box = "";
	for(my $i=1; $i<@sex; $i++){
		$box .= "<input type='radio' name='sex' value='$i'> $sex[$i]&nbsp;&nbsp;&nbsp;";
	}
	return $box;
}
=cut
sub birth_sel_box{
	my ($sec, $min, $hour, $mday, $mon, $year) = &get::current();
	my @year  = ("",$year-80..$year);
	my @month = ("",1..12);
	my @day   = ("",1..31);
	######### Set year
	# class='sel' => 下位互換   1.79
	my $box = "<select name='birth_year' class='sel sel_auto'>\n";
	foreach(@year){
		$box .= "<option value='$_'>$_</option>\n";
	}
	$box .= "</select> 年 \n";
	######### Set month
	$box .= "<select name='birth_mon' class='sel sel_auto'>\n";
	foreach(@month){
		$box .= "<option value='$_'>$_</option>\n";
	}
	$box .= "</select> 月 \n";
	######## Set day
	$box .= "<select name='birth_day' class='sel sel_auto'>\n";
	foreach(@day){
		$box .= "<option value='$_'>$_</option>\n";
	}
	$box .= "</select> 日 \n";
	return $box;
}
=pod
sub live_1_sel_box{
	my @pref = &item::pref();
	my $box = "<select name='live_1' style='font-size:12px;'>\n";
	for(my $i=0; $i<@pref; $i++){
		$box .= "<option value='$i'>$pref[$i]</option>\n";
	}
	$box .= "</select>\n";
	return $box;
}
sub marr_ch_box{
	my @marr = &item::marr();
	my $box = "";
	for(my $i=1; $i<@marr; $i++){
		$box .= "<input type='radio' name='marr' value='$i'> $marr[$i]&nbsp;&nbsp;&nbsp;";
	}
	return $box;
}
sub child_ch_box{
	my @child = &item::child();
	my $box = "";
	for(my $i=1; $i<@child; $i++){
		$box .= "<input type='radio' name='child' value='$i'> $child[$i]&nbsp;&nbsp;&nbsp;";
	}
	return $box;
}
sub house_sel_box{
	my @house = &item::house();
	my $box = "<select name='house' style='font-size:12px;'>\n";
	for(my $i=0; $i<@house; $i++){
		$box .= "<option value='$i'>$house[$i]</option>\n";
	}
	$box .= "</select>\n";
	return $box;
}
sub pet_ch_box{
	my @pet = &item::pet();
	my $box = "";
	for(my $i=1; $i<@pet; $i++){
		$box .= "<input type='radio' name='pet' value='$i'> $pet[$i]&nbsp;&nbsp;&nbsp;";
	}
	return $box;
}
sub pet_kind_ch_box{
	my @pet_kind = &item::pet_kind();
	my $box = "";
	for(my $i=1; $i<@pet_kind; $i++){
		$box .= "<input type='checkbox' name='pet_kind' value='$i'> $pet_kind[$i]\n";
	}
	return $box;
}
sub interest_chk_box{
	my @interest = &item::interest();
	my $box = "";
	for(my $i=1; $i<@interest; $i++){
		$box .= "<input type='checkbox' name='interest' value='$i'>$interest[$i]<br />\n";
	}
	return $box;
}
sub job_sel_box{
	my @job = &item::job();
	my $box = "<select name='job' style='font-size:12px;'>\n";
	for(my $i=0; $i<@job; $i++){
		$box .= "<option value='$i'>$job[$i]</option>\n";
	}
	$box .= "</select>\n";
	return $box;
}
=cut
sub his_right{
	my $id = $F->param('id');
	&db::query("SELECT * FROM `ms_his_$id` ORDER BY no DESC LIMIT 10");
	my @hd = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@hd,$href);
	}
	return \@hd;
}
sub his_list{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;

	my $id = $F->param('id');
	my $order          = "`ms_his_$id`.no DESC";
	if($F->param('sort_type')){
		if($F->param('sort_type') == 1){
			if(!$F->param('sort_mode')){
				$order = "`ms_his_$id`.deliv_day DESC,`ms_his_$id`.deliv_time DESC";
			}
			else{
				$order = "`ms_his_$id`.deliv_day,`ms_his_$id`.deliv_time";
			}
		}
		elsif($F->param('sort_type') == 2){
			if(!$F->param('sort_mode')){
				$order = "`ms_his_$id`.users DESC";
			}
			else{
				$order = "`ms_his_$id`.users";
			}
		}
		elsif($F->param('sort_type') == 3){
			if(!$F->param('sort_mode')){
				$order = "ctr DESC";
			}
			else{
				$order = "ctr";
			}
		}
		elsif($F->param('sort_type') == 4){
			if(!$F->param('sort_mode')){
				$order = "total_clicks DESC";
			}
			else{
				$order = "total_clicks";
			}
		}
	}
	# 1.85 ###########	
	my $where;
	if($F->param('d_type') ne ''){
		$where = "WHERE d_type = '". &proc::conv_html_ref_2($F->param('d_type')). "'";
		$where .= " OR d_type = '3' " if $F->param('d_type') == 0; # 1.86
	}
	##################
	# Make temporary table
#	&db::query("
#		CREATE TEMPORARY TABLE `temp` AS 
#			SELECT	his_no,
#					SUM(tot_clicks) AS total_clicks 
#			FROM	`ms_cs_$id`
#			GROUP	BY his_no
#			$limit
#	");
	# Select join table
#	&db::query("
#		SELECT SQL_CALC_FOUND_ROWS
#			*,
#			`temp`.total_clicks,
#			ROUND((`temp`.total_clicks / `ms_his_$id`.users) * 100, 2) AS ctr 
#		FROM		`ms_his_$id` 
#		LEFT JOIN	`temp`
#		ON 			`ms_his_$id`.no = `temp`.his_no
#		ORDER BY	$order
#		$limit
#	");
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS
			*,
			`temp`.total_clicks,
			ROUND(
				(`temp`.total_clicks / `ms_his_$id`.users) * 100,
				 2
			) AS ctr 
		FROM		`ms_his_$id` 
		LEFT JOIN (
			SELECT
				`ms_cs_$id`.his_no,
				SUM(tot_clicks) AS total_clicks 
			FROM	`ms_cs_$id`
			GROUP	BY `ms_cs_$id`.his_no
		) `temp`
		ON 			`ms_his_$id`.no = `temp`.his_no
		$where 
		ORDER BY	$order
		$limit
	");
	my @hl = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@hl,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@hl,$max);

}

sub his_list_gbs{

}

sub his_data_gbs{

}

sub bcn_list{

}
sub bcn_extra_list{

}
sub his_data{
	my $id     = $F->param('id') || $F->param('m') || $_[0];
	my $his_no = $F->param('his_no') || $F->param('h') || $_[1];
	# 1.86 #######
	#&db::query("
	#	SELECT * FROM `ms_his_$id`
	#	WHERE no = $his_no
	#");
	&db::query(
		"SELECT * FROM `ms\_his\_$id`
		 WHERE no = ?",
		[ {value => $his_no} ]
	);
	##############
	return $db::sth->fetchrow_hashref();
}
sub his_maxno{
	my ($id) = @_;
	&db::query("SELECT MAX(no) FROM `ms_his_$id`");
	my $maxno = $db::sth->fetchrow_array;
	return $maxno;
}
sub err_users_list{
	my ($id,$his_no,$diag) = @_;
	&db::query("
		SELECT 
			`ms_user_$id`.no,
			`ms_user_$id`.name,
			`ms_erradd`.email,
			`ms_user_$id`.entry
		FROM `ms_erradd` 
		LEFT JOIN `ms_user_$id` ON 
			`ms_user_$id`.email = `ms_erradd`.email
		WHERE 
			`ms_erradd`.id     = '$id'		AND
			`ms_erradd`.his_no = $his_no	AND 
			`ms_erradd`.diag   = '$diag' 
		ORDER BY ms_erradd.no
	");
	my @list = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@list,$href);
	}
	return \@list;
}
sub bcn_maxno{

}
sub bcn_extra_maxno{

}
sub total_clicks{
	my ($his_no) = @_;
	my $id = $F->param('id');
	&db::query("SELECT SUM(tot_clicks) FROM ms_cs_$id WHERE his_no=$his_no");
	my $tot_clicks = $db::sth->fetchrow_array;
	return $tot_clicks;
}
sub url_clicks{
	my $id = $F->param('id');
	my $his_no = $F->param('type') != 4 ? $F->param('his_no') : $F->param('no');
	&db::query("SELECT * FROM ms_cs_$id WHERE his_no=$his_no ORDER BY no");
	my @cd = ();
	while(my $href = $db::sth->fetchrow_hashref){
		push(@cd,$href);
	}
	return \@cd;
}
sub cs_data{
	my ($id,$cs_no) = @_;
	&db::query("
		SELECT *
		FROM	`ms_cs_$id`
		WHERE	`ms_cs_$id`.no = $cs_no
	");
	return $db::sth->fetchrow_hashref();
}
=pod
sub cs_redirect{
	my ($id,$cs_no) = @_;
	&db::query("
		SELECT `ms_cs_$id`.redirect
		FROM	`ms_cs_$id`
		WHERE	`ms_cs_$id`.no = $cs_no
	");
	my $href = $db::sth->fetchrow_hashref();
	return $$href{redirect};
}
=cut
sub cs_maxno{
	my ($id) = @_;
	&db::query("SELECT MAX(no) FROM ms_cs_$id");
	my $maxno = $db::sth->fetchrow_array;
	return $maxno;
}
sub cs_firstno_of_his{	# 1.80
	my ($id,$his_no) = @_;
	&db::query("SELECT MIN(no) FROM `ms_cs_$id` WHERE his_no = $his_no");
	return $db::sth->fetchrow_array();
}
sub ind_maxno{
	my ($id) = @_;
	&db::query("SELECT MAX(no) FROM ms_individual_$id");
	my $maxno = $db::sth->fetchrow_array;
	return $maxno;
}

sub repo_sta_name{
	my $id = $_[0] || $F->param('id');
	my %rsd = ();
	#&db::query("SELECT * FROM ms_accounts_$id WHERE type=2 ORDER BY no");
	&db::query("SELECT * FROM `ms_accounts` WHERE id='$id' AND type=2 ORDER BY no");
	while(my $href = $db::sth->fetchrow_hashref()){
		$rsd{$$href{no}} = $$href{name};
	}
	return \%rsd;	
}
sub repo_sta{
	my $id = $_[0] || $F->param('id');
	my @rsd = ();
	#&db::query("SELECT * FROM ms_accounts_$id WHERE type=2 ORDER BY no");
	&db::query("SELECT * FROM `ms_accounts` WHERE id='$id' AND type=2 ORDER BY no");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@rsd,$href);
	}
	return \@rsd;	
}
sub parsed_name{
	my ($name) = @_;
	my $fam_name = "";
	my $full_name = "";
	my $fir_name = "";	# 1.73
	if($name =~ /^([^ ]+?) ([^ ]+?)$/){
		$fam_name = $1;
		$full_name = "$1 $2";
		$fir_name = $2;	# 1.73
	}
	else{
		$fam_name = $name ;
		$full_name = $name ;
		$fir_name = $name;	# 1.73
	}
	#return($fam_name,$full_name);
	return($fam_name,$full_name,$fir_name);
}
sub forming_name{
	my ($name) = @_;
	$name =~ s/　/ /g;
	$name =~ s/^ +(.+)/$1/g;
	$name =~ s/([^ ]+) +$/$1/g;
	$name =~ s/^([^ ]+) +([^ ]+).*$/$1 $2/g;
	return $name;
}
sub parsed_filter{
	my ($filter_cont,$id) = @_;
	my $view = '';
#die $filter_cont;
	#$filter_cont =~ s/&amp;/&/g;	# 1.61
	#$filter_cont = &proc::conv_html_ref_re($filter_cont);	# 1.83
#die $filter_cont;
	my @par  = split(/&/,$filter_cont);
	if(@par != 0){
		#my @active = ("<span style='color:#ff0000;'>配信停止</span>","<span style='color:#00e100;'>配信可能</span>");
		my %active = (	# 1.75
			0  => "<span style='color:#ff0000;'>配信停止</span>",
			1  => "<span style='color:#00e100;'>配信可能</span>",
			-1 => "<span style='color:#ff0000;'>エラー停止</span>",
		);
		my $regist_from = &item::regist_from($id);
		# Get item
		my $regist_mode	= &item::regist_mode();
		my $sex			= &item::sex();
		my $marr			= &item::marr();
		my $child			= &item::child();
		my $live_1			= &item::pref();
		my $job			= &item::job();
		my $house			= &item::house();
		my $pet			= &item::pet();
		my $pet_kind		= &item::pet_kind();
		my $interest		= &item::interest();
		my $sports			= &item::sports();
		my $trouble		= &item::trouble();
		my $domain			= &item::domain();
		my $udevice		= &item::udevice();	# 1.81
		my $is_birthday	= &item::is_birthday();
		my($al,$max) = &get::attri_list();
		my %attri = ();
		if($max){
			unshift(@$al, {no => 0, name => '未設定'});
			map {$attri{$$_{no}} = $$_{name};} @$al;
		}
		my @diag = &item::error_diags();	# 1.75

		my $or = "<span style='font-size:11px;'> または </span>";
		foreach(@par){
			$_ =~ /(.+)=(.*)/;
			# 1.83 XSS measures ########
			#my ($name,$value) = ($1,$2);
			my ($name,$value) = ($1,&proc::conv_html_ref_2($2));	
			###############################
			if($value ne '' || ($name eq 'active' && $value ne '')){
				#$view .= "<li>状態：$active[$value]</li>\n" if $name eq "active";
				$view .= "<li>状態：$active{$value}</li>\n" if $name eq "active";
				if($name eq 'kw'){
					$view .= "<li>名前 / メールアドレス：";
					$view .= join($or, map {"<span class='attention'>$_</span>"} split(/,/,$value));
					$view .= " を含む</li>\n";
				}
				if($name eq 'regist_mode'){
					$view .= "<li>登録方法：";
					$view .= join($or, map {"<span class='attention'>$$regist_mode[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'regist_from'){
					$view .= "<li>獲得元：";
					$view .= join($or, map {"<span class='attention'>$$regist_from{$_}</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'sex'){
					$view .= "<li>性別：";
					$view .= join($or, map {"<span class='attention'>$$sex[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				$view .= "<li>年齢：<span class='attention'>$value"."歳以上</span></li>\n"					if $name eq "under_age";
				#$view .= "<li>年齢：<span class='attention'>$value"."歳未満</span></li>\n"					if $name eq "over_age";
				$view .= "<li>年齢：<span class='attention'>$value"."歳以下</span></li>\n"					if $name eq "over_age";
				$view .= "<li>クリック数：<span class='attention'>$value"."回以上</span></li>\n"			if $name eq "under_clicks";
				#$view .= "<li>クリック数：<span class='attention'>$value"."回未満</span></li>\n"			if $name eq "over_clicks";
				$view .= "<li>クリック数：<span class='attention'>$value"."回以下</span></li>\n"			if $name eq "over_clicks";
				$view .= "<li>ポイント：<span class='attention'>$value"."以上</span></li>\n"				if $name eq "under_points";
				#$view .= "<li>ポイント：<span class='attention'>$value"."未満</span></li>\n"				if $name eq "over_points";
				$view .= "<li>ポイント：<span class='attention'>$value"."以下</span></li>\n"				if $name eq "over_points";
				$view .= "<li>郵便番号：<span class='attention'>$value"."</span> を含む</li>\n"			if $name eq "postal";
				if($name eq 'live_1'){
					$view .= "<li>都道府県：";
					$view .= join($or, map {"<span class='attention'>$$live_1[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				$view .= "<li>市町村以下：<span class='attention'>$value"."</span> を含む</li>\n"			if $name eq "live_2";
				$view .= "<li>電話番号：<span class='attention'>$value"."</span> を含む</li>\n"			if $name eq "phone";
				if($name eq 'job'){
					$view .= "<li>職業：";
					$view .= join($or, map {"<span class='attention'>$$job[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'marr'){
					$view .= "<li>結婚：";
					$view .= join($or, map {"<span class='attention'>$$marr[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'child'){
					$view .= "<li>子供：";
					$view .= join($or, map {"<span class='attention'>$$child[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'house'){
					$view .= "<li>住居形態：";
					$view .= join($or, map {"<span class='attention'>$$house[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'pet'){
					$view .= "<li>ペット：";
					$view .= join($or, map {"<span class='attention'>$$pet[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'pet_kind'){
					$view .= "<li>ペットの種類：";
					$view .= join($or, map {"<span class='attention'>$$pet_kind[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'interest'){
					$view .= "<li>興味分野：";
					$view .= join($or, map {"<span class='attention'>$$interest[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'sports'){
					$view .= "<li>好きなスポーツ：";
					$view .= join($or, map {"<span class='attention'>$$sports[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'trouble'){
					$view .= "<li>生活上の悩み：";
					$view .= join($or, map {"<span class='attention'>$$trouble[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				$view .= "<li>ユーザID：<span class='attention'>$value"."</span> を含む</li>\n"			if $name eq "uid";
				$view .= "<li>誕生日：<span class='attention'>$$is_birthday[$value]</span></li>\n"		if $name eq "is_birthday" && $value;
				$view .= "<li>誕生日：<span class='attention'>$value日後</span></li>\n"						if $name eq "is_birthday_g";
				if($name =~ /entry_(.+)_(.+)/){
					if($2 eq 'from'){
						if($1 eq 'year'){
							$view .= "<li>登録日：<span class='attention'>$value年</span>";
						}
						elsif($1 eq 'mon'){
							$view .= "<span class='attention'>$value月</span>";
						}
						elsif($1 eq 'day'){
							$view .= "<span class='attention'>$value日</span> から</li>\n";
						}
					}
					elsif($2 eq 'to'){
						if($1 eq 'year'){
							$view .= "<li>登録日：<span class='attention'>$value年</span>";
						}
						elsif($1 eq 'mon'){
							$view .= "<span class='attention'>$value月</span>";
						}
						elsif($1 eq 'day'){
							$view .= "<span class='attention'>$value日</span> まで</li>\n";
						}
					}
				}
				if($name eq 'attri'){
					$view .= "<li>属性：";
					$view .= join($or, map {"<span class='attention'>$attri{$_}</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'domain'){
					$view .= "<li>携帯/PC：";
					$view .= join($or, map {"<span class='attention'>$$domain[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				if($name eq 'udevice'){	# 1.81
					$view .= "<li>受信端末：";
					$view .= join($or, map {"<span class='attention'>$$udevice[$_]</span>"} split(/\0|,/,$value));
					$view .= "</li>\n";
				}
				# Free form
				if($name =~ /^(is_)?free_(\d+)_(\d+)(_\w+)?$/){
					my $free_stg  = &get::free_form_setting($2);
					if($3 >= 2 && $3 <= 4){
						# radio,checkbox,selectbox
#						my $parts_stg = &get::free_parts_setting('',$value);
#						$view .= "<li>$$free_stg{form_name}：$$parts_stg{parts_name}</li>\n";
						$view .= "<li>$$free_stg{form_name}：";
						$view .= join ($or,	map {	if($_ == 0){
															$_ = "<span class='unconfig'><span class='attention'>未設定</span></span>";
														}
														else{
															my $parts_stg = &get::free_parts_setting('', $_);
															$_ = "<span class='attention'>$$parts_stg{parts_name}</span>";	
														}
													} split(/\0|,/,$value)
												);
						$view .= "</li>\n";
					}
					elsif($3 == 6){
						# DATE-type
						if($1){
							if($4 eq '_g'){
								$view .= "<li>$$free_stg{form_name}が <span class='attention'>$value 日後</span></li>\n";
							}
							else{
								my $date_select = &item::date_select();
								$view .= "<li>$$free_stg{form_name}が <span class='attention'>$$date_select[$value]</span></li>\n";
							}
						}
						else{
							if($4 eq '_from'){
								$view .= "<li>$$free_stg{form_name}が <span class='attention'>$value から</span></li>\n";
							}
							elsif($4 eq '_to'){
								$view .= "<li>$$free_stg{form_name}が <span class='attention'>$value まで</span></li>\n";
							}
						}
					}
					else{
						# text,password,textarea
						$view .= "<li>$$free_stg{form_name}：<span class='attention'>$value</span> を含む</li>\n";
					}
				}
				# Error diags 1.75
				if($name =~ /^(under|over)_diag_(\w+)?$/){
					map {
						if($$_[0] eq $2){
							$view .= "<li>$$_[1]：<span class='attention'>$value 回";
							#$view .= $1 eq 'under' ? "以上" : "未満";
							$view .= $1 eq 'under' ? "以上" : "以下";
							$view .= "</span></li>\n";
						}
					} @diag;
				}
			}
		}
	}
	$view = "<ul class='filter_list'>\n$view</ul>\n" if $view;
#die $view;
	return $view;
}

########################
sub original_tag_list{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_originaltag`
		ORDER BY no DESC
		$limit
	");
	my @tl = ();
	while (my $href = $db::sth->fetchrow_hashref()){
		push (@tl,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@tl,$max);
}

sub original_tag_maxno{
	&db::query("SELECT MAX(no) FROM ms_originaltag");
	my $maxno = $db::sth->fetchrow_array();
	return $maxno;
}
sub original_tag{
	my $no = $F->param('no') || $_[0];
	&db::query("SELECT * FROM `ms_originaltag` WHERE no = $no");
	my @d = $db::sth->fetchrow_array;
	return @d;
}
#####################
sub action_log{
	my ($start,$view_count) = @_;
	$start = 1 if !$start;
	my @ld = ();
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM
			`ms_actionlog`
		ORDER BY
			no DESC
		LIMIT
			".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@ld, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@ld,$max);
}

sub his_delivered{
	my ($id,$his_no,$start,$view_count) = @_;
	$start = 1 if !$start;

	my $order = "`ms_user_$id`.no DESC";
	if($F->param('sort_type')){
		if($F->param('sort_type') == 1){
			# By No(entry)
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.no ASC";
			}
		}
		elsif($F->param('sort_type') == 2){
			# By click count
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.clicks DESC,`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.clicks ASC,`ms_user_$id`.no DESC";
			}
		}
	}

	my @dd = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS
					`ms_user_$id`.*
		FROM		`ms_delivered`
		INNER JOIN	`ms_user_$id` ON 
					`ms_user_$id`.no = `ms_delivered`.user_no
		WHERE		`ms_delivered`.id     = '$id'	AND
					`ms_delivered`.his_no = $his_no
		ORDER BY	$order
		LIMIT		".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@dd, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@dd,$max);
}

sub his_clicked{
	my ($id,$his_no,$start,$view_count) = @_;
	$start = 1 if !$start;

	my $order = "`ms_user_$id`.no DESC";
	if($F->param('sort_type')){
		if($F->param('sort_type') == 1){
			# By No(entry)
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.no ASC";
			}
		}
		elsif($F->param('sort_type') == 2){
			# By click count
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.clicks DESC,`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.clicks ASC,`ms_user_$id`.no DESC";
			}
		}
	}

	my @cd = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS
					`ms_user_$id`.*
		FROM		`ms_user_$id`
		INNER JOIN	(
			SELECT	`ms_cshis`.user_no
			FROM	`ms_cshis`
			INNER JOIN (	
				SELECT	`ms_cs_$id`.no
				FROM	`ms_cs_$id`
				WHERE	`ms_cs_$id`.his_no = $his_no
			) AS cs_tbl
			ON		`ms_cshis`.cs_no = `cs_tbl`.no
			WHERE	`ms_cshis`.id    = '$id'				-- 1.73
		) AS cs_his_tbl
		ON			`ms_user_$id`.no = `cs_his_tbl`.user_no
		GROUP BY	`ms_user_$id`.no
		ORDER BY	$order
		LIMIT		".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@cd, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@cd,$max);
}

sub his_opened{
	my ($arg) = @_;
	$$arg{fd}{start} = 1 if !$$arg{fd}{start};

	my $order = "`ms_user_$$arg{fd}{id}`.no DESC";
	if($$arg{fd}{sort_type}){
		if($$arg{fd}{sort_type} == 1){
			# By No(entry)
			if(!$$arg{fd}{sort_mode}){
				$order = "`ms_user_$$arg{fd}{id}`.no DESC";
			}
			else{
				$order = "`ms_user_$$arg{fd}{id}`.no ASC";
			}
		}
		elsif($$arg{fd}{sort_type} == 2){
			# By open count
			if(!$$arg{fd}{sort_mode}){
				$order = "`ms_user_$$arg{fd}{id}`.opens DESC,`ms_user_$$arg{fd}{id}`.no DESC";
			}
			else{
				$order = "`ms_user_$$arg{fd}{id}`.opens ASC,`ms_user_$$arg{fd}{id}`.no DESC";
			}
		}
	}

	my @od = ();
	&db::query("
		SELECT			SQL_CALC_FOUND_ROWS `ms_user_$$arg{fd}{id}`.*
		FROM			`ms_user_$$arg{fd}{id}`
		INNER JOIN		`ms_oshis`
		ON				`ms_oshis`.user_no = `ms_user_$$arg{fd}{id}`.no 	AND
						`ms_oshis`.his_no = $$arg{fd}{his_no}
		WHERE         `ms_oshis`.id = '$$arg{fd}{id}' -- 1.85
		GROUP BY		`ms_user_$$arg{fd}{id}`.no
		ORDER BY		$order
		LIMIT			".($$arg{fd}{start}-1).", $$arg{view_num}
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@od, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return ({
		opened_list => \@od,
		max         => $max
	});
}

sub his_clicked_eu{
	my ($id,$cs_no,$start,$view_count) = @_;
	$start = 1 if !$start;

	my $order = "`ms_user_$id`.no DESC";
	if($F->param('sort_type')){
		if($F->param('sort_type') == 1){
			# By No(entry)
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.no ASC";
			}
		}
		elsif($F->param('sort_type') == 2){
			# By click count
			if(!$F->param('sort_mode')){
				$order = "`ms_user_$id`.clicks DESC,`ms_user_$id`.no DESC";
			}
			else{
				$order = "`ms_user_$id`.clicks ASC,`ms_user_$id`.no DESC";
			}
		}
	}

	my @cd = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS
					`ms_user_$id`.*
		FROM		`ms_user_$id`
		INNER JOIN	(
			SELECT	`ms_cshis`.user_no
			FROM	`ms_cshis`
			WHERE	`ms_cshis`.id    = '$id'		AND
					`ms_cshis`.cs_no = $cs_no
		) AS cs_his_tbl
		ON			`ms_user_$id`.no = `cs_his_tbl`.user_no
		GROUP BY	`ms_user_$id`.no
		ORDER BY	$order
		LIMIT		".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@cd, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@cd,$max);
}

sub users_clicked{
	my ($id,$user_no,$start,$view_count) = @_;
	$start = 1 if !$start;

	my $order = "`cs_tbl`.his_no DESC";
	if($F->param('sort_type')){
		if($F->param('sort_type') == 1){
			# By No(entry)
			if(!$F->param('sort_mode')){
				$order = "`cs_tbl`.his_no DESC";
			}
			else{
				$order = "`cs_tbl`.his_no ASC";
			}
		}
	}

	my @cd = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS
					`cs_tbl`.redirect,
					`cs_tbl`.his_no
		FROM		`ms_cshis`
		INNER JOIN	(
			SELECT	`ms_cs_$id`.no,
					`ms_cs_$id`.redirect,
					`ms_cs_$id`.his_no
			FROM	`ms_cs_$id`
		) AS cs_tbl
		ON			`ms_cshis`.cs_no   = `cs_tbl`.no
		WHERE		`ms_cshis`.id      = '$id'		AND
					`ms_cshis`.user_no = $user_no
		ORDER BY	$order
		LIMIT		".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@cd, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@cd,$max);
}

sub his_log{
	my ($id,$his_no,$start,$view_count) = @_;
	$start = 1 if !$start;
	my @ld = ();
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM
			`ms_actionlog`
		WHERE
			id = '$id' AND his_no = $his_no
		ORDER BY no
		LIMIT
			".($start-1).", $view_count
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@ld, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@ld,$max);
}
####################
sub author_list{
	my ($start,$view_count) = @_;
	my $where = $config::oem
		? "WHERE login_id != '$config::master_id'"
		: undef;
	$start = 1 if !$start;
	my $limit = $view_count
		? "LIMIT ".($start-1).",". $view_count
		: undef;
	&db::query("
		SELECT	SQL_CALC_FOUND_ROWS *
		FROM `ms_author`
		$where
		ORDER BY no DESC
		$limit
	");
	my @al = ();
	while (my $href = $db::sth->fetchrow_hashref()){
		push (@al,$href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return (\@al,$max);
}

sub author_maxno{
	&db::query("SELECT MAX(no) FROM `ms_author`");
	my $maxno = $db::sth->fetchrow_array();
	return $maxno;
}
sub author{
	my $no = $F->param('no') || $_[0];
	&db::query("SELECT * FROM `ms_author` WHERE no = $no");
	my $d = $db::sth->fetchrow_hashref;
	return $d;
}
# Get uploaded image list
sub image_list{
	if(!-d './upload'){
		&proc::make_dir('./upload');
	}
	opendir(UPLD,'./upload') || &show::error("アップロードファイル用ディレクトリがオープンできませんでした。",$EC.__LINE__);
	my @list = ();
	my $max_no = 0;
	while(my $file = readdir(UPLD)){
		if($file !~ /^\.+$/ && $file =~ /^(\d+)\.(jpeg|gif|png|bmp|swf)/){
#			$list[$1] = $file;
			push(@list,$file);
			$max_no = $1 if $1 > $max_no;
		}
	}
	closedir(UPLD);
	return($max_no + 1,\@list);
}
# Get default image list
sub image_list2{
	opendir(IMG,'./img/mobile/img') || &show::error("画像ファイル用ディレクトリがオープンできませんでした。",$EC.__LINE__);
	my %list = ();
	while(my $file = readdir(IMG)){
		if($file !~ /^\.+$/ && $file =~ /^([\d_]+)\.(jpeg|gif|png|bmp|swf)/){
			$list{$1} = $file;
		}
	}
	closedir(IMG);
	return \%list;
}
####################

sub cphis_list{	# 1.85
	my ($arg) = @_;
	$$arg{fd}{start} = 1 if !$$arg{fd}{start};
	my @hl = ();
	&db::query("
		SELECT		SQL_CALC_FOUND_ROWS `ms_cphis`.*
		FROM		`ms_cphis` "
		.($config::oem ? "WHERE login_id != '$config::master_id' " : undef)
		."ORDER BY	no DESC
		  LIMIT ".($$arg{fd}{start}-1).", $$arg{view_num}
	");
	while(my $href = $db::sth->fetchrow_hashref()){
		push(@hl, $href);
	}
	&db::query("SELECT FOUND_ROWS()");
	my ($max) = $db::sth->fetchrow_array()	;
	return ({
		list => \@hl,
		max  => $max
	});
}

sub benefits_list{

}
sub benefits_maxno{

}
sub benefits_data{

}
sub form_benefits{

}

sub form_benefits_if_path{

}

sub form_benefits_iframe{

}
=pod
sub qrcode_to_mailer{

}

sub qrcode_to_link{
	my ($arg) = @_;
	my $str =	$$arg{extend} ? "mailto:$$arg{to}" : "mailto:$$arg{to}?body=ms_mid:$$arg{id}";
	my $return;
		my $qr_obj = 
		GD::Barcode::QRcode->new(
			$str,
			{ ModuleSize => 2 }	# Ecc & Version => auto select
		);
		my $qr_img;
		my $ext = 'gif';
		eval {	$qr_img = $qr_obj->plot()->gif(); };
		if($@){
			$ext = 'png';
			eval { $qr_img = $qr_obj->plot()->png(); };
			if($@){
				$ext = 'jpeg';
				eval { $qr_img = $qr_obj->plot()->jpeg(); };
				if($@){
					return "ご利用中のGDライブラリが「gif」「png」「jpeg」形式をサポートしていません。";
				}
			}
		}
		my $qr_file = "./img/qr/QR_$$arg{id}\_$$arg{mode}\_link"
			. ($$arg{extend} ? '_ext' : undef)
			.".$ext";
		my $fh;
		open($fh,">$qr_file");
		binmode $fh;
		print $fh ($qr_img);
		close $fh;
		$return .= "<div><img src='$qr_file' /></div>";
	return $return;
}
=cut
sub topics{
eval {&check::auto_get_mod();};
	my $feed_url = $config::oem
		? $config::oem_topics
		: 'http://milkystep.com/topics/?feed=rss2';
	my $ua = LWP::UserAgent->new();
	my $res_thread = (
		$ua->request(
			&HTTP::Request::Common::GET($feed_url)
		)
	);
	my $xml = $res_thread->content();
	print "Content-type: text/plain\n\n";
	print	$xml;
	exit;
}

sub community_thread{
eval {&check::auto_get_mod();};
	my $feed_url = $config::oem
		? $config::oem_thread
		: 'http://milkystep.com/ms_poc/?feed=rss2';
	my $ua = LWP::UserAgent->new();
	my $res_thread = (
		$ua->request(
			&HTTP::Request::Common::GET($feed_url)
		)
	);
	my $xml = $res_thread->content();
	print "Content-type: text/plain\n\n";
	print	$xml;
	exit;
}

sub community_comment{
eval {&check::auto_get_mod();};
	my $feed_url = $config::oem
		? $config::oem_comment
		: 'http://milkystep.com/ms_poc/?feed=comments-rss2';
	my $ua = LWP::UserAgent->new();
	my $res_comment = (
		$ua->request(
			&HTTP::Request::Common::GET($feed_url)
		)
	);
	my $xml = $res_comment->content();
	print "Content-type: text/plain\n\n";
	print $xml;
	exit;
}

sub latest_ver_for_ajax{
	my $is_newver = 0;
	if(&check::vup_mod()){
		my ($latest) = split(/\n/, &get::latest_ver());
		if($latest =~ /^system:(\d+\.\d+):(\d+)$/){
			if($2 == 1 && $1 > $ver::version){
				$is_newver = $1;
			}
		}
	}
	print "Content-type: text/html\n\n";
	print	$is_newver;
	exit;
}

#################
sub bcn_setting{

}
=pod
sub default_bcn_template{

}
=cut
sub default_data{
	my ($stg,$name,$device) = @_;
	# 1.86 ########
	#&db::query("
	#	SELECT  $name, flw_$name
	#	FROM   `ms_default` 
	#	WHERE   id = '$$stg{id}' AND device = $device
	#");
	# SQLインジェクション対策のためカラム名にもパラメタ値は使用しない
	# カラム名にプレースホルダは使えない
	&db::query(
		"SELECT  *
		 FROM   `ms\_default` 
		 WHERE   id = ? AND device = ?",
		[ {value => $$stg{id}}, {value => $device} ]
	);
	###############
	return $db::sth->fetchrow_hashref();
}

sub mailto{	# 1.81
	my ($arg) = @_;
#die $$arg{stg}{karame_add};
	my $mailto;
	if($$arg{mode} eq 'reg' || !$$arg{mode}){
		$mailto = $$arg{stg}{karame_add};
	}
	elsif($$arg{mode} eq 'rm'){
		$mailto = $$arg{stg}{karame_add2};
	}
	if($$arg{ext}){	# Case extended address
		my $si = &get::sys_info();
		$$si{ext_delimiter} = '+' if $$si{ext_delimiter} eq '';
		$mailto =~ s/\@/$$si{ext_delimiter}$$arg{stg}{id}\@/;
		$mailto = &proc::urlencode($mailto);
	}else{
		$mailto = &proc::urlencode($mailto)."?body=ms_mid:$$arg{stg}{id}";
	}
	return $mailto;
}

#################
sub vup_his{
	my @hd = ();
	&db::query("SELECT * FROM ms_updatehis ORDER BY entry DESC LIMIT 0,20");
	while(my $href = $db::sth->fetchrow_hashref){
		push(@hd,$href);
	}
	return \@hd;
}
sub latest_ver{
	my $url = 'http://milkystep.com/download/ch_msver.pl';
	my $ua = LWP::UserAgent->new;
	my $req = HTTP::Request->new('GET',$url);
	my $res = $ua->request($req);
	&show::error("バージョン情報を取得するためのHTTPリクエストに失敗しました。",$EC.__LINE__)if !($res->is_success);
	my $content = $res->content;
	return $content;
}
sub latest_file{
	my $fd = $F->Vars;
	my %formdata = (
		vup_type			=> $$fd{vup_type},
		sys_name			=> $$fd{sys_name},
		asp_name			=> $$fd{asp_name},
		version			=> $$fd{latest_ver},
		key_1				=> $$fd{key_1},
		key_2				=> $$fd{key_2},
		oem					=> $config::oem,
		oem_key1			=> $config::oem_key1,
		oem_key2			=> $config::oem_key2,
		print_latest_ver	=> 1
	);
	my $url = "http://milkystep.com/download/dl_ms.pl";
	my $ua  = LWP::UserAgent->new;
	my $req = HTTP::Request::Common::POST($url,\%formdata);
	my $res = $ua->request($req);
#	&show::error("ファイルを取得するためのHTTPリクエストに失敗しました。",$EC.__LINE__)if !($res->is_success);
	return(0,"HTTPリクエスト失敗") if !($res->is_success);

	my $file = $res->content;
	if(!$file || $file =~ /Initial page|Download Error|software error|internal server error|404 not found/i){
#		&show::error("ファイルの取得に失敗しました。ダウンロードキーが正しいか確認してください。",$EC.__LINE__);
		return(0,"取得失敗 - バージョンアップキー（ダウンロードキー）が正しいか確認してください");
	}
	return (1,undef,$file);
}

sub keys_cookie{
	my $fd = $F->Vars;
	my $key_type = '';
	if($$fd{'vup_type'} eq 'system'){
		$key_type = 'sys';
	}
	elsif($$fd{'vup_type'} eq 'asp_option'){
		$key_type = $$fd{'asp_name'};
	}
	my %cookies = fetch CGI::Cookie;
	my $value = $cookies{"milkystepvupkey_$key_type"}->value if(exists $cookies{"milkystepvupkey_$key_type"});
	$value = &cp::dec_pass($value);
	return $value;
}
sub list_sort_cookie{
	my $fd = $F->Vars;
	my %cookies = fetch CGI::Cookie;
	my $value = $cookies{"milkystep_listsort_$$fd{'type'}"}->value if(exists $cookies{"milkystep_listsort_$$fd{'type'}"});
	return $value;
}
sub active_proc{
	my @active = ();
	my $list = &get::all_id_and_type();
	if($list && @$list != 0){
		foreach my $tmp(@$list){
			if($$tmp{'type_num'} != 4){
				&db::query("SELECT story_no,pid FROM ms_his_$$tmp{'id'} WHERE complete = 0");
				my @pid = ();
				while(my $href = $db::sth->fetchrow_hashref()){
					push(@pid,$href);
				}
				foreach my $tmp2(@pid){
					my $proc = "/proc/$$tmp2{'pid'}";
					if(-e $proc){
						push(	@active,{
									'id'		=> $$tmp{'id'},
									'story_no'	=> $$tmp2{'story_no'}
								}
						);
					}
				}
			}
		}
	}
	return \@active;
}
#################
sub rand_str{
	my ($str_len,$char_type) = @_;
	my @chars;
	push @chars, ('a'..'z') if $char_type =~ /a-z/;
	push @chars, ('A'..'Z') if $char_type =~ /A-Z/;
	push @chars, (0..9) if $char_type =~ /0-9/;
	my $total = @chars;
	my $rand_str = "";
	$rand_str .= $chars[int(rand($total))] for (1..$str_len);
	return $rand_str;
}
sub month{
	my ($alpha) = @_;
	if($alpha =~ /Jan/i){
		return '01';
	}
	elsif($alpha =~ /Feb/i){
		return '02';
	}
	elsif($alpha =~ /Mar/i){
		return '03';
	}
	elsif($alpha =~ /Apr/i){
		return '04';
	}
	elsif($alpha =~ /May/i){
		return '05';
	}
	elsif($alpha =~ /Jun/i){
		return '06';
	}
	elsif($alpha =~ /Jul/i){
		return '07';
	}
	elsif($alpha =~ /Aug/i){
		return '08';
	}
	elsif($alpha =~ /Sep/i){
		return '09';
	}
	elsif($alpha =~ /Oct/i){
		return '10';
	}
	elsif($alpha =~ /Nov/i){
		return '11';
	}
	elsif($alpha =~ /Dec/i){
		return '12';
	}
}
###############
sub mailtext{

}

sub unknown_list{
	&db::query("SELECT * FROM ms_unknown ORDER BY entry DESC");
	my @unl = ();
	while(my $href = $db::sth->fetchrow_hashref()){
		push (@unl,$href);
	}
	return \@unl;
}
sub unknown_data{
	my $no = $F->param('no');
	&db::query("SELECT * FROM ms_unknown WHERE no=$no");
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}
sub sys_info{
	&db::query("SELECT * FROM `ms_system`");
	my $href = $db::sth->fetchrow_hashref();
	return $href;
}
sub mobile_domain{
	my $si = &get::sys_info();
	my %mob_doms = (
		docomo		=> [split(/\r\n|\r|\n/,$$si{'domain_docomo'})		],
		ezweb		=> [split(/\r\n|\r|\n/,$$si{'domain_ezweb'})		],
		softbank	=> [split(/\r\n|\r|\n/,$$si{'domain_softbank'})	]
	);
	return \%mob_doms;
}
sub sys_env{
	my %sys_env = ();
	my $command = "perl";
	my $shebang = '';
	foreach my $key( split(/:/, $ENV{'PATH'}) ){
    	$key =~ '.' if $key eq '';
    	if ( -f "$key/$command" and -x _){
    	    $shebang = "$key/$command";
    	}
    	else{
    		$shebang = "不明";
    	}
	}
	$sys_env{'is_good_pv'} = 1;
	my $p_ver = sprintf("%vd",$^V);
	if ($] < 5.006001){
		$p_ver .= "<p style='color:#ff0000;'>※perlのバージョンは5.6.1以上が必要です</p>\n";
		$sys_env{'is_good_pv'} = 0;
	}

	$sys_env{'is_good'} = 1;
	my $RESULT = '';
	for my $list (\@ver::REQ,\@ver::OPT) {
    	my $req = 1 if $list == \@ver::REQ;
		my $S = "";
    	if($req){
    		$S = "必須";
    	}
    	else{
    		$S = "オプション";
    	}
    	
		$RESULT .= <<EOM;
 			<tr><td>&nbsp;</td></tr>
   			<tr><td align='center'>【$Sモジュールのインストール状況】</td></tr>
			<tr><td>&nbsp;</td></tr>
EOM
		my $got_one_data = 0;
		my $m_ver = "";
		for my $ref (@$list) {
			my($mod, $ver, $req, $desc) = @$ref;
			$RESULT .= "
				<tr>
					<td>
						<b>$mod</b>" 
						.($ver ? " (必須バージョン$ver以上)" : "") 
						. "..."
					."</td>
				</tr>
			";
			eval("use $mod".($ver ? " $ver;" : ";"));
			if($@){
				$sys_env{'is_good'} = 0 if $req == 1;
				my $msg = $ver
				? "　　[ <span style='color:#ff0000;'>N G</span> ] あなたの使用しているサーバには、$mod がインストールされていないか、バージョンが合っていません。<br />" 
				: "　　[ <span style='color:#ff0000;'>N G</span> ] あなたの使用しているサーバには、$mod モジュールがインストールされていません。<br />";
					$msg .= $desc;
				$RESULT .= "
					<tr>
						<td>$msg</td>
					</tr>
				";
			}else{
				$RESULT .= "
					<tr>
						<td>
							　　[ <span style='color:#00ff00;'>O K</span> ] あなたの使用しているサーバには、$modモジュールがインストールされています。<br />
							　　　　(バージョン @{[$mod->VERSION]})
						</td>
					</tr>
				";

			}
		}
	}
	$sys_env{'RESULT'} = <<EOM;
				<tr>
					<td>サーバOS: </td>
					<td>$^O</td>
				</tr>
				<tr>
					<td>Perlのバージョン: </td>
					<td>$p_ver</td>
				</tr>
				<tr>
					<td>Perlのパス：</td>
					<td>$shebang</td>
				</tr>
				<tr>
					<td colspan='2'>
						<table class='nor'>
							$RESULT
						</table>
					</td>
				</tr>
EOM
	return \%sys_env;
}

sub page_ctrl_prms{
	my (
		$max,
		$start,
		$view_count
	) = @_;
	$start = 1 if !$start;
#die "$max,$start,$view_count";
	$view_count = $view_count > $max ? $max : $view_count;
	return {
		max			=> $max,
		start		=> $start,
		end			=> ($start + $view_count - 1) <= $max
							? ($start + $view_count - 1)
							: $max,
		s_prev		=> $start == 1
							? undef
							: $start - $view_count,
		s_next		=> ($start + $view_count) <= $max
							? $start + $view_count
							: undef,
		s_first	=> $start == 1
							? undef
							: 1,
		s_last		=> ($start + $view_count) <= $max
							? (	$max % $view_count == 0
									? ($max - $view_count) + 1
									: (int($max / $view_count) * $view_count) + 1  )
							: undef
	};
}

sub mltpt_text {
	my ($str) = @_;
	my $grep_1 = '<a[^<>]*?href[^<>]*?(s?https?:\/\/[-_.!~*()a-zA-Z0-9;\/?:\@&=+\$,%#]+)[^<>]*?>(.*?)<\/a>';
	my $grep_2 = '<[^<>]*?(s?https?:\/\/[-_.!~*()a-zA-Z0-9;\/?:\@&=+\$,%#]+)[^<>]*?>'; # img,embed etc
	my $grep_3 = '<img[^<>]*?src="cid:img_cid_00(.*?)\@.*?"[^<>]*?>'; # cid tag
	$str =~ s/$grep_1/$2 \[リンク: $1 \]/gi;
	$str =~ s/$grep_2/ \[画像リンク: $1 \]/gi;
	$str =~ s/$grep_3/ \[添付ファイル: $1 \]/gi;
	$str =~ s/\r\n|\r|\n//g;
	$str =~ s/<br[^<>]*?>|<\/(pre|p|h\d+|div|ol|ul|li|table|tr|blockquote|dl|address)>/\n/gi;
	$str =~ s/<[^<>]*?>//g;	# Remove all html tag 
	$str = "※ご利用の受信環境で表示できない形式のためテキスト形式に変換して表示しています。※\n\n".$str;
	return $str;
}

sub uri_params {	# 1.82
	my $uri_params = $ENV{QUERY_STRING};
	foreach(split(/&/, $ENV{QUERY_STRING})){
		if($_ =~ /^(id|m|type|mode|nc|ac|modify|again|exe_resist|charset|device)=.*$/){ $uri_params =~ s/\&?$&\&?//i; }
	}
	return $uri_params ? $uri_params : undef;
}

1;

