###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Inc. owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package idms;
use strict;
my $EC = __PACKAGE__.$ver::version.'_';

sub manage_inode{
	# 1.77 ################
	#my (
	#	$common,
	#	$subject,
	#	$tot_body,
	#	$attach
	#) = @_;
	my ($common) = @_;
	######################
	if(!&idms::check_inode()){
		my $hd = &get::his_data($$common{id},$$common{his_no});
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$$hd{d_type},		# Delivery type
			"inode使用率が制限値に達したため一旦配信を制限します。"
		);
=pod
		while(!&idms::check_inode()){
			&save::history_idms(
				$$common{id},
				$$common{his_no},
				1	# In the limit inode -> 1
			);
			my $wait = 10;	# sec
			for(my $sec=0; $sec<$wait; $sec++){	# Waiting loop
				WAIT_I: {
					select(undef,undef,undef,1);
					if($$dd{switch_proc} && (time - $proc_start) >= $$dd{switch_time} && ($sec+1 != $$dd{intervals})){
						my $new_pid = '';
						if($new_pid = fork){
							exit;
						}
						elsif(defined $new_pid) {
							$proc_start = time;
							&db::child_open();
							# Update pid info
							&save::history_pid(
								$$common{id},
								$$common{his_no},
								$$
							) if $$common{id};
							$sec++;
							redo WAIT_I;
						}
						else{
							# Case can't fork or too many processes
							next;
						}
					} # if
				} # end of WAIT_I 
			} # for
		} # While
		&save::history_idms(
			$$common{id},
			$$common{his_no},
			0
		);
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$$common{type},
			"配信を再開しました。\n"
		);
=cut
		&save::history_idms(
			$$common{id},
			$$common{his_no},
			1	# In the limit inode -> 1
		);
		#&idms::set_continue(
		#	$common,
		#	$subject,
		#	$tot_body,
		#	$attach,
		#	$hd
		#);
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$$hd{d_type},		# Delivery type
			"配信を制限しました。"
		);
		exit;
	} # if

}

sub manage_memory{
	# 1.77 ################
	#my (
	#	$common,
	#	$subject,
	#	$tot_body,
	#	$attach
	#) = @_;
	my ($common) = @_;
	######################
	if(!&idms::check_memory()){
		my $hd = &get::his_data($$common{id},$$common{his_no});
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$$hd{d_type},		# Delivery type
			"メモリ使用率が制限値に達したため一旦配信を制限します。"
		);
=pod
		# Set continue table
		if($$hd{html} == 2 && $attach && !-e "./attach/$$common{id}-$$common{his_no}"){
			if(!open(ATTACH,">./attach/$$common{id}-$$common{his_no}")){
				&save::action_log(
					$$common{id},
					$$common{his_no},
					$$hd{d_type},		# Delivery type
					"※添付ファイルの書込みオープンができませんでした。"
				);
				exit;
			}
			binmode ATTACH;
			flock(ATTACH,2);
			print ATTACH $attach;
			flock(ATTACH,8);
			close(ATTACH);
		}
		&save::continue(
			$$common{id},
			$$common{his_no},
			$subject,
			$tot_body
		);
=cut
		&save::history_idms(
			$$common{id},
			$$common{his_no},
			2	# In the limit memory -> 2
		);
		#&idms::set_continue(
		#	$common,
		#	$subject,
		#	$tot_body,
		#	$attach,
		#	$hd
		#);
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$$hd{d_type},		# Delivery type
			"配信を制限しました。"
		);
		exit;
	}
}

sub stop_manualy {	# 1.77
	my ($fd) = @_;
	my $hd = &get::his_data($$fd{id},$$fd{his_no});
	# kill a process
	if($$hd{idms} == 0){	# in delivery
		#if(my $sig = kill('TERM', $$hd{pid})){
		if(my $sig = kill('TERM', $$hd{pid}) || $$fd{in_uxpctd}){	# 1.80
			&save::history_idms(
				$$fd{id},
				$$hd{no},
				11	# Manualy stop -> 11
			);
			&save::action_log(
				$$fd{id},
				$$hd{no},
				$$hd{d_type},		# Delivery type
				"手動により配信を停止しました。"
			);
		}
		else{	# failed kill
			&show::error("配信停止に失敗しました。すでにプロセスが停止している可能性があります。（シグナルの戻り値無し）",$EC.__LINE__);
		}
	}
	elsif($$hd{idms} == 1 || $$hd{idms} == 2){	# in stopped by limited
		&save::history_idms(
			$$fd{id},
			$$hd{no},
			11	# Manualy stop -> 11
		);
		&save::action_log(
			$$fd{id},
			$$hd{no},
			$$hd{d_type},		# Delivery type
			"手動により配信を停止しました。"
		);
	}
	else{
		&show::error("配信停止に失敗しました。（配信状態不明）",$EC.__LINE__);
	}
}
=pod
sub set_continue{
	my (
		$common,
		$subject,
		$tot_body,
		$attach,
		$hd
	) = @_;
	############################
	# Set continue table
	# 1.71 ####################################################################################
	if($$hd{html} >= 2){
		unlink("./attach/$$cond{id}-$$cond{his_no}-image");
		if($$attach{image}){
			# image
			if(!open(ATTACH,">./attach/$$common{id}-$$common{his_no}-image")){
				&save::action_log(
					$$common{id},
					$$common{his_no},
					$$hd{d_type},		# Delivery type
					"※添付ファイルデータ(画像)の書込みオープンができませんでした。"
				);
				# remove idms flag in history data
				&save::history_idms(
					$$common{id},
					$$common{his_no},
					0
				);
				exit;
			}
			binmode ATTACH;
			flock(ATTACH,2);
			print ATTACH $$attach{image};
			flock(ATTACH,8);
			close(ATTACH);
		}
		unlink("./attach/$$cond{id}-$$cond{his_no}-pictgram");
		if($$attach{pictgram}){
			# Pictgram image
			if(!open(ATTACH,">./attach/$$common{id}-$$common{his_no}-pictgram")){
				&save::action_log(
					$$common{id},
					$$common{his_no},
					$$hd{d_type},		# Delivery type
					"※添付ファイルデータ(絵文字画像)の書込みオープンができませんでした。"
				);
				# remove idms flag in history data
				&save::history_idms(
					$$common{id},
					$$common{his_no},
					0
				);
				exit;
			}
			binmode ATTACH;
			flock(ATTACH,2);
			print ATTACH $$attach{pictgram};
			flock(ATTACH,8);
			close(ATTACH);
		}
	}
	########################################################################################
	&save::continue(
		$$common{id},
		$$common{his_no},
		$subject,
		$tot_body
	);
}
=cut

sub continue_manualy {	# 1.77
#=pod
	FORK: {
		my $pid;
		if( $pid = fork ) {
			sleep 1;
			&show::his_list();
			close(STDOUT);
			close(STDERR);
			close(STDIN);
			wait;
		}
		elsif(defined $pid) {
			close(STDOUT);
			close(STDERR);
			close(STDIN);
			&db::child_open();
#=cut
			my ($fd) = @_;
			my $hd = &get::his_data($$fd{id},$$fd{his_no});
			&save::action_log(
				$$fd{id},
				$$hd{no},
				$$hd{d_type},		# Delivery type
				"手動により配信を再開します。"
			);
			&idms::restart_delivery($$fd{id},$hd);
#=pod
		}
		elsif ( $! =~ /No more process/) {
			# Case too many processes
			sleep 5;
			redo FORK;
		}
		else {
			&show::error("
				<p>forkがサポートされていません。</p>
				<p>サーバ管理者にお問い合わせください。</p>
			");   
		}
	} # End Of FORK
#=cut
}

sub continue {
	my @his_tbl = ();
	&db::query("SHOW TABLES LIKE 'ms_his_%'");
	while(my @ary = $db::sth->fetchrow_array()){
		push(@his_tbl,$ary[0]);
	}
	LOOP_HIS: foreach(@his_tbl){
		my $id; if($_ =~ /^ms_his_([\d\w]+)$/){$id = $1;}
		#&db::query("
		#	SELECT	*
		#	FROM	`ms_continue`
		#	ORDER	BY entry ASC
		#	LIMIT	1
		#");
		if($id){
			# 1.80 #################
			if($config::oem){
				&db::query("
					SELECT	*
					FROM	`ms_his_$id`
					WHERE  idms = 1 OR idms = 2
					ORDER	BY no ASC
					LIMIT	1
				");
				if(my $hd = $db::sth->fetchrow_hashref()){
					# Continue for deliveries managed resouce.
					&save::action_log(
						$id,
						$$hd{no},
						$$hd{d_type},
						"リソース制限によるコンティニューデータを取得しました。"
					);
					&idms::restart_delivery($id,$hd);	# 1.77
					last LOOP_HIS;	#########
				}	# if $hd
				else {
					&idms::continue2($id);
				} # else
			}
			else{
				&idms::continue2($id);
			}
			###################
		}	# if $id
	} # foreach
}

sub continue2 {	# 1.80
	my ($id) = @_;
	# Find deliveries killed own proccess.
	&db::query("
		SELECT	*
		FROM	`ms_his_$id`
		WHERE  complete = 0 AND pid != 0 AND idms = 0 AND continue_uxpctd = 1
		ORDER	BY no ASC
		LIMIT	1
	");
	if(my $hd = $db::sth->fetchrow_hashref()){
		if(!&check::process_exists($$hd{pid})){
			# Continue for deliveries killed own proccess.
			&save::action_log(
				$id,
				$$hd{no},
				$$hd{d_type},
				"不測のエラーによるコンティニューデータを取得しました。"
			);
			&idms::restart_delivery($id,$hd);	# 1.77
			last LOOP_HIS;
		} # if
	}	# if $hd
}

sub restart_delivery {	# 1.77
	my ($id,$hd) = @_;
	my $stg = &get::setting_data($id);
	my $common = {
		id		=> $id,
		from	=> &proc::set_mail_from($stg),
		rep		=> $$stg{reply_add},
		env		=> $$stg{envelope_add},
		his_no	=> $$hd{no},
		bulk	=> 1,
		type	=> $$hd{d_type}
	};
	my %md = (
		id					=>	$id,
		#sort_no			=>	$$hd{sort_no},
		html				=>	$$hd{html},
		lang				=>	$$hd{lang},
		nl2br				=>	$$hd{nl2br},
		os					=>	$$hd{os},		# 1.81
		auto_sbj			=>	$$hd{auto_sbj},
		sbj_cont			=>	$$hd{sbj_cont},
		define_header		=>	$$hd{define_header},
		define_header_no	=>	$$hd{define_header_no},
		header				=>	$$hd{header},
		body				=>	$$hd{o_body},	#########
		define_footer		=>	$$hd{define_footer},
		define_footer_no	=>	$$hd{define_footer_no},
		footer				=>	$$hd{footer},
		cs					=>	$$hd{cs},
		excl_cs			=>	$$hd{excl_cs},
		filter				=>	$$hd{filter},
		filter_cont		=>	$$hd{filter_cont},
		excl_word			=>	$$hd{excl_word},
		his_no				=>	$$hd{no}	# 1.80
	);
	my $md = &proc::make_cont(\%md);
	my $tot_body = $$md{header}
		? ($$md{footer}	? $$md{header}."\n".$$md{body}."\n".$$md{footer}
							: $$md{header}."\n".$$md{body} )
		: ($$md{footer}	? $$md{body}."\n".$$md{footer}
							: $$md{body} );
	# Convert Image
	#my $save_subject;
	#my $save_body;
	my $post_body;
	my $attach;
	if($$hd{html}){
		if($$hd{nl2br}){
			$tot_body  =~ s/\r\n|\r|\n/<br \/>\n/g;
			$$md{body} =~ s/\r\n|\r|\n/<br \/>\n/g;
		}
		my $wwwdir = &get::wwwdir($id);
		#$save_subject = &proc::conv_pictgram_image(0,$$md{subject},$wwwdir);
		my $pc_body = &proc::conv_image($tot_body,$wwwdir);
		#$save_body = &proc::conv_pictgram_image(0,$pc_body,$wwwdir);
		$post_body = &proc::conv_image($$md{body},$wwwdir);
		$post_body = &proc::conv_pictgram_image(0,$post_body,$wwwdir);
		require './lib/mobile.pl';
		if($$hd{html} >= 2){	# For mobile
			($tot_body,$attach) = &proc::conv_image_for_mobile($tot_body);
		}
		else{	# For PC
			($tot_body,$attach) = ($pc_body, {});
		}
	}
	else{	# text
		#$save_body    = $tot_body;
		#$save_subject = $$md{subject};
		$post_body = $$md{body};
	}
	# 1.80 #####################
	# Convert url(not save to db)
	if($$hd{cs} == 1){
		$tot_body = &save::convert_url(
			$id,
			$tot_body,
			$$hd{excl_cs},
			$$stg{cs_path},
			$$hd{no},
			$$hd{html},
			1	# is restart-> 1  1.80
		);
	}
	#############################
	my $mob_doms  = &get::mobile_domain();
	my @user_info = &item::user_info($id);
	my $free_list = &get::free_form_list($id);
	&save::history_pid(
		$id,
		$$hd{no},
		$$
	);
	&save::history_idms(
		$id,
		$$hd{no},
		0
	);
	&save::action_log(
		$id,
		$$hd{no},
		$$hd{d_type},
		"配信を再開しました。"
	);
	$tot_body =~ s/\r\n|\r|\n/\n/g;
	$tot_body = &proc::insert_break_utf8($$hd{html},$tot_body,200);
	my $dd = &get::delivery($id);
	my ($res,$msg) = &start::sendmail(
		$dd,
		$common,
		undef,			# $ud
		\@user_info,
		$md,
		$stg,
		$tot_body,
		$mob_doms,	
		$attach,
		$free_list,
		$$hd{d_type}
	);
	&save::action_log(
		$id,
		$$hd{no},
		$$hd{d_type},
		$msg
	);
	if(!$res){
		&save::action_log(
			$id,
			$$hd{no},
			$$hd{d_type},
			"※メールの送信に失敗しました。"
		);
		&save::del_delivers(
			$id,
			$$hd{no}
		);
		&save::action_log(
			$id,
			$$hd{no},
			$$hd{d_type},
			"※配信予定読者デーブルからデータを削除しました。"
		);
	}
	# Remove attachment files
	#unlink("./attach/$$cond{id}-$$cond{his_no}-image");
	#unlink("./attach/$$cond{id}-$$cond{his_no}-pictgram");
	my $comp = $res ? 1 : 2;
	&save::history_last(
		$id,
		$$hd{no},
		$comp
	);
	# Remove old history and clicks data
	if($$stg{data_period} ne '' && $$stg{data_period} != 0){
		&save::del_olddata(
			$id,
			$$stg{data_period}
		);
	}
	&save::action_log(
		$id,
		$$hd{no},
		$$hd{d_type},
		"※古い履歴データ等をを削除しました。"
	);
	# Post weblogs
	&start::post_weblog(
		$stg,
		$dd,
		$md,
		$post_body,
		$$hd{no},
		$$hd{d_type}	# delivery type
	);
	# Send report to admin
	&start::report(
		$stg,
		$dd,
		$$hd{no},
		0					# delivery type
	);
}

sub check_inode{
	my $inode = `df -i | grep -i /\$`;
	$inode =~ /.*?\d+.*?\d+.*?\d+.*?(\d+)\%/i;
	$inode = $1;
	return 0 if $inode >= $config::limit_inode;
	return 1;
}

sub check_memory{
	my $mem = `free -m | grep -i ^mem:`; # KB
	$mem =~ /.*?(\d+).*?(\d+).*?\d+.*?\d+.*?(\d+).*?(\d+).*?/;
	$mem = sprintf('%.0f', ($2-$3-$4)/$1*100);
	return 0 if $mem >= $config::limit_memory;
	return 1;
}

1;

