###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Inc. owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package start;

use strict;

my $F = CGI->new();
my $EC = __PACKAGE__.$ver::version.'_';
my $product_name = $config::oem ? $config::oem_product  : 'MilkyStep';

# Test delivery
sub test{
	my $md = $F->Vars;
#die $$md{auto_sbj};
	$md = &proc::make_cont($md); # 1.71
#die $$md{subject};
	$$md{header} = $$md{header} ? $$md{header}."\n" : '';
	$$md{footer} = $$md{footer} ? "\n".$$md{footer} : '';
	my $tot_body = $$md{header}.$$md{body}.$$md{footer};
#die $tot_body;
	# Convrt fixed tags
	my @info = &item::user_info();
	for(my $i=0; $i<@info; $i++){
		$$md{subject} =~ s/$info[$i][0]/\[$info[$i][1]\]/g;
		$tot_body     =~ s/$info[$i][0]/\[$info[$i][1]\]/g;
	}
	# Convrt free tags
	my $free_list = &get::free_form_list($$md{id});
	if($free_list && @$free_list != 0){
		foreach(@$free_list){
			$tot_body =~ s/\%\%FREE_$$_{no}\%\%/\[$$_{form_name}\]/g;
		}
	}
	# Convert given-days tag
	my $func = sub {
		my($num,$p_or_f,$from) = @_;
		$p_or_f = $p_or_f eq 'AGO'   ? '前' : '後';
		$from   = $from   eq 'TODAY' ? '配信日' : '読者登録日';
		return '['.$from.'から'.$num.'日'.$p_or_f.'の日付]';
	};
	$$md{subject} =~ s/\%\%(\d+)_DAYS_(\w+)_FROM_(\w+)\%\%/{$func->($1,$2,$3)}/eg;
	$tot_body     =~ s/\%\%(\d+)_DAYS_(\w+)_FROM_(\w+)\%\%/{$func->($1,$2,$3)}/eg;

	# Convert limited-page tag
	my ($lmtd_list,$max) = &get::lmtd_list($$md{id});
	if($max){
		foreach(@$lmtd_list){
			$tot_body =~ s/\%\%LMTD_$$_{no}\%\%/[期間限定ページ（$$_{name}）のURL]/g;
		}
	}
	# 1.80 ################
	#$$md{subject} = "$product_name テスト配信 - ". $$md{subject};
	$$md{subject} = $$md{test_prefix}.$$md{subject};
	######################
	$tot_body =~ s/\%\%ULK_URL\%\%/\[1クリック解除URL\]/g;
	# Convert images and pictgrams
	my $mob_doms  = &get::mobile_domain();
	my $attach;

	if($$md{html}){
		if($$md{nl2br}){
			$tot_body =~ s/\r\n|\r|\n/<br \/>\n/g;
		}
		require './lib/mobile.pl';
		if($$md{html} == 1){	# For PC
			my $wwwdir = &get::wwwdir($$md{id});
			$$md{subject} = &proc::conv_pictgram_image(0,$$md{subject},$wwwdir);
			$tot_body = &proc::conv_image($tot_body,$wwwdir);
			# 1.71 ##########################
			#$tot_body = &proc::conv_pictgram_image(0,$tot_body,$wwwdir);
			$attach = {};	# hash ref
			#################################
		}
		# 1.71 ####################
		elsif($$md{html} >= 2){	# For Mobile
			#require './lib/mobile.pl';
			($tot_body,$attach) = &proc::conv_image_for_mobile($tot_body);
		}
		else{
			&show::error("メール形式の指定が不正です。",$EC.__LINE__);
		}
		###########################
	}
	# 1.70 Add unlink url at last ################
	my $stg = &get::setting_data();	
	if($$stg{unlink}){
		my $msg = "\n\n配信を解除する場合は下記URLをクリックしてください。\n\[1クリック解除URL\]";
		$msg =~ s/\n/<br \/>\n/g if $$md{html};
		$tot_body .= $msg;
	}
	####################################################
	# Set mail data
	# 1.74 ##########################
	my @ud = map {$_ =~ s/\s|　//g; {email => $_};} split(/,/,$$md{test_add});
	#my @ud = ({email => $$md{test_add}});
	#################################
	my %common = (
		id		=> $$stg{id},	# 1.67
		from	=> &proc::set_mail_from($stg,$$md{lang}),	# 1.60
		rep		=> $$stg{reply_add},
		env		=> $$stg{envelope_add},
		his_no	=> undef,
		bulk	=> undef
	);
	my $dd = &get::delivery();
	# Send
	$tot_body =~ s/\r\n|\r|\n/\n/g;
	# Insert line-break witin certain characters (1.70)###################
	$tot_body = &proc::insert_break_utf8($$md{html},$tot_body,200);
	##########################################################################
	my($res,$log) = &start::sendmail(
		$dd,
		\%common,
		\@ud,
		undef,			# \@user_info
		$md,
		$stg,
		$tot_body,
		$mob_doms,
		$attach,
		undef,			# $free_list
		undef			# $d_type
	);
	&show::error($log,$EC.__LINE__) if !$res;
	&show::test_done() if !$$md{save_extra};
}

sub report{
	my (
		$stg,
		$dd,
		$his_no
	) = @_;
	if($$stg{admin_repo} == 1){
		my $hd = &get::his_data($$stg{id},$his_no);
		my $dl = &get::delivered($$stg{id},$his_no,0,10); # Limit 10
		my ($art,$no_name);
		if($$hd{story_no}){
			($art,$no_name) = ("ストーリー定期配信","ストーリー");
		}
		else{
			if($$hd{d_type} == 0){
				($art,$no_name) = ("即時配信",undef);
			}
			elsif($$hd{d_type} == 3){
				($art,$no_name) = ("予約配信",undef);
			}
			$art = "号外記事/$art" if $$stg{type_num} != 3;
		}
		# 1.71 ###############################################
		#my $mime = !$$hd{html}	? 'テキスト'
		#							: ($$hd{html} == 1
		#									? 'PCアドレス向けHTML'
		#									: '携帯向け（絵文字・画像含む）'
		#							);
		my $mime;
		if   ($$hd{html} == 1){$mime = 'PCアドレス向けHTML';}
		elsif($$hd{html} == 2){$mime = 'フィーチャーフォン向けHTML';}
		elsif($$hd{html} == 3){$mime = 'スマートフォン向けHTML';}
		else {$mime = 'テキスト';}
		######################################################
		my $lang = $$hd{lang}	? '多言語（UTF8）' : '日本語';
		if($$hd{cs} == 1){
			$$hd{cs} = "す る";
			if(!$$hd{excl_cs}){
				$$hd{excl_cs} = "な し";
			}
			else{
				my %hash = (excl_cs => $$hd{excl_cs});
				my $href = &proc::conv_original_tag(\%hash);
				$$hd{excl_cs} =~ $$href{excl_cs};
				$$hd{excl_cs} =~ s/\r\n|\r|\n/\n/g;
				$$hd{excl_cs} = "\n".$$hd{excl_cs};
			}
		}
		else{
			$$hd{cs} = "しない";
			$$hd{excl_cs} = "-----";
		}

		my $exp_filter = "";
		if($$hd{filter} == 1){
			$exp_filter = &get::parsed_filter($$hd{filter_cont});	
			$exp_filter =~ s/<.*?>//g;
		}
		else{
			$exp_filter = "な し";
		}
		my $type;
		if($$stg{type_num} == 1){
			$type = "ステップメール";
		}
		elsif($$stg{type_num} == 2){
			$type = "自動メルマガ";
		}
		elsif($$stg{type_num} == 3){
			$type = "標準メルマガ";
		}
		my $report = "$type送信レポート($$stg{id})\n\n";
		$report .= "【タイトル】\t$$stg{mag_name}\n";
		$report .= "【ＩＤ】\t$$stg{id}\n";
		$report .= "【$no_name】\t$$hd{story_no}\n\n" if $$hd{story_no} > 0;
		$report .= ("-" x 70)."\n\n";
		$report .= "【記事種別】\t$art\n";
		$report .= "【配信日】\t$$hd{deliv_day}\n";
		$report .= "【配信開始時刻】\t$$hd{deliv_time}\n";
		$report .= "【所用時間】\t$$hd{time_required}\n";
		$report .= "【配信部数】\t$$hd{users} 部\n\n";
		$report .= "【メール形式】\t$mime\n";
		$report .= "【言 語】\t$lang\n";
		$report .= "【クリック測定】\t$$hd{cs}\n";
		$report .= "【測定しないURL】\t$$hd{excl_cs}\n";
		$report .= "【配信フィルタ】\t$exp_filter\n\n";
		$report .= "【件　名】\n$$hd{subject}\n\n";
		if($$stg{repo_inc_users} && @$dl != 0){
			$report .= "【配信した読者の名前とメールアドレス一覧】（最大10件まで表示）\n";
			foreach(@$dl){
				my $ud = &get::one_user_data2(
					$$stg{id},
					$$_{user_no}
				);
				$report .= "・$$ud{name} $$ud{email}\n" if $ud;
			}
			my $dl = @$dl;
			if($$hd{users} > $dl){
				$report .= "他".($$hd{users} - $dl)."名\n";
			}
			$report .= "\n";
		}
		$report .= ("-" x 70)."\n\n";

		###################### 1.69
		if($$stg{repo_inc_body}){
			$report .= "【本　文】\n";
		}
		if($$hd{html}){
			$report =~ s/\r\n|\r|\n/<br \/>\n/g;
		}
		if($$stg{repo_inc_body}){
			my $wwwdir = &get::wwwdir($$stg{id});
			my $body = &proc::conv_pictgram_image(0,$$hd{body},$wwwdir);
			$report .= $body;
		}
		###################### 1.69

		my %repod = (
			id			=> $$stg{id},
			subject	=> "$product_name - $type送信レポート（$$stg{id}/$$hd{deliv_day}）",
			html		=> $$hd{html},
			lang		=> $$hd{lang}
		);
		my @ud = ({ email => $$stg{admin_add} });
		my %common = (
			id		=> $$stg{id},
			from	=> &proc::set_mail_from($stg,$$hd{lang}),
			rep		=> $$stg{reply_add},
			env		=> $$stg{envelope_add},
			his_no	=> undef,
			bulk	=> undef
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$$hd{d_type},
			"配信結果を管理者宛にメールしています・・・\n"
		);
		$report =~ s/\r\n|\r|\n/\n/g;
		# Insert line-break witin certain characters (1.70)###################
		$report = &proc::insert_break_utf8($repod{html},$report,200);
		##########################################################################
		my($res,$msg) = &start::sendmail(
			$dd,
			\%common,
			\@ud,
			undef,		# \@user_info
			\%repod,	# $md
			$stg,
			$report,	# $tot_body
			undef,		# $mob_doms	
			#undef,	# $attach
			{},			# $attach -> no-name hash ref # 1.71
			undef,		# $free_list
			$$hd{d_type}	# 1.73
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$$hd{d_type},
			$msg
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$$hd{d_type},
			"※メールの送信に失敗しました。\n"
		) if !$res;
	}
}

sub err_report{
	my (
		$d_type,
		$stg,
		$dd,
		$md,	# $ed or $sd
		$body,
		$today
	) = @_;
	if($$stg{admin_repo} == 1){
		my ($type,$art,$no_name,$time);
		if($d_type == 1){
			($type,$art,$no_name,$time) = ("ステップメール","ストーリー定期配信","ストーリーNo",$$md{deliv_time});
		}
		elsif($d_type == 2){
			($type,$art,$no_name,$time) = ("自動メルマガ","ストーリー定期配信","ストーリーNo",$$md{deliv_time});
		}
		elsif($d_type == 3){
			($art,$no_name,$time) = ("予約配信",undef,$$md{reserve_time});
			if($$stg{type_num} == 1){
				$type = "ステップメール";
				$art = "号外記事/$art";
			}
			elsif($$stg{type_num} == 2){
				$type = "自動メルマガ";
				$art = "号外記事/$art";
			}
			elsif($$stg{type_num} == 3){
				$type = "標準メルマガ";
			}
		}
		my $report = "$type送信エラーレポート($$stg{id})\n\n";
		$report .= "【タイトル】\t$$stg{mag_name}\n";
		$report .= "【ＩＤ】\t$$stg{id}\n";
		$report .= "【$no_name】\t$$md{sort_no}\n" if $no_name;
		$report .= "\n";
		$report .= ("-" x 70)."\n\n";
		$report .= "【記事種別】\t$art\n";
		$report .= "【配信予定日】\t$today\n";
		$report .= "【配信予定時刻】\t$time\n\n";
		$report .= ("-" x 70)."\n\n";
		$report .= "【エラー内容】\n\n";
		$report .= $body."\n";

		my %repod = (
#			id			=> undef,
			id			=> $$stg{id},	################## 1.67
			subject	=> "$product_name - $type送信エラーレポート（$today）",
			html		=> 0
		);
		my @ud = ({ email => $$stg{admin_add} });
		my %common = (
#			id		=> undef,
			id		=> $$stg{id},	################ 1.67
			from	=> &proc::set_mail_from($stg),
			rep		=> $$stg{reply_add},
			env		=> $$stg{envelope_add},
			his_no	=> undef,
			bulk	=> undef
		);
		$report =~ s/\r\n|\r|\n/\n/g;
		# Insert line-break witin certain characters (1.70)###################
		$report = &proc::insert_break_utf8($repod{html},$report,200);
		##########################################################################
		my($res,$msg) = &start::sendmail(
			$dd,
			\%common,
			\@ud,
			undef,		# \@user_info
			\%repod,	# $md
			$stg,
			$report,	# $tot_body
			undef,		# $mob_doms	
			undef,		# $attach
#			undef,		# $his_no
			undef,		# $free_list
			$d_type	# 1.73～
		);
	}
}

#sub report_uless{
#}

sub report_reg_rm {
	my($stg,$dd,$ud,$pd) = @_;

	#my $act = '';
	my ($act,$mode);
	#if($$pd{mode} == 1 || $$pd{mode} eq 'doi' || $$pd{mode} eq 'doi2'){
	if($$pd{mode} == 1 || $$pd{mode} eq 'doi' || $$pd{mode} eq 'doi2' || $$pd{mode} == 4){	# 1.73
		$act = '新規読者登録';
		$mode = 1;
	}
	elsif($$pd{mode} == 2){
		$act = '配信解除';
		$mode = 2;
	}
	elsif($$pd{mode} eq 'one_clk'){
		$act = '1クリック配信解除';
		$mode = 2;
	}
	elsif($$pd{mode} == 3){	# 1.79
		$act = '読者情報変更';
		$mode = 3;
	}
	my $subject = '';
	my $report = '';
	#if(	(	($$pd{mode} == 1 || $$pd{mode} eq 'doi' || $$pd{mode} eq 'doi2') && $$stg{admin_repo_reg}	)	||
	#	(	($$pd{mode} == 2 || $$pd{mode} eq 'one_clk')	&& $$stg{admin_repo_rm}	)		){
	if(($mode == 1 && $$stg{admin_repo_reg}) || ($mode == 2 && $$stg{admin_repo_rm}	)){	# 1.73
		# Convert common tags
		my @info = &item::user_info();
		my $list = '';
		for(my $i=0; $i<@info; $i++){
			if($info[$i][3]){
				if($info[$i][4]){
					if($info[$i][4] == 1){
						# Alternative select
						my $data = '';
						if($info[$i][3] eq 'regist_from'){
							$data = $info[$i][5]{$$ud{$info[$i][3]}};
						}
						else{
							$data = $info[$i][5][$$ud{$info[$i][3]}];
						}
#						if(!$data || $data =~ /^-*$/){
						if(!$data || $data =~ /^-*$/ || $data =~ /未設定/){	############# 1.61
							next;
						}
						$list .= $info[$i][1]."：".$data."\n\n";
					}
					elsif($info[$i][4] == 2){
						# Multiple select
						my @tmp = ();
						foreach(split(/,/, $$ud{$info[$i][3]})){
							push(@tmp, $info[$i][5][$_]);
						}
						my $data = join(",", @tmp);
						if(!$data){
							next;
						}
						$list .= $info[$i][1]."：".$data."\n\n";
					}
				}
				else{
					#if($info[$i][3] eq 'points' || $info[$i][3] eq 'clicks'){
					if($info[$i][3] =~ /^points|clicks|opens$/ ){	# 1.81
						next;
					}
					my $data = $$ud{$info[$i][3]};
					if($info[$i][3] eq 'next_story'){
						if($$stg{'type_num'} != 1){
							next;
						}
					}
					if($data eq '' || $data eq '0000-00-00'){
						next;
					}
					$list .= $info[$i][1]."：".$data."\n\n";
				}
			}
		}
		# Convert free form tags
		my $free_list = &get::free_form_list($$stg{id});
		if($free_list && @$free_list != 0){
			foreach(@$free_list){
				my $user_free_parts = &get::user_free_parts($_,$$ud{no});
				if($user_free_parts && @$user_free_parts != 0){
					my $data = '';
					if($$_{form_type} >= 2 && $$_{form_type} <= 4){
						$data = join(',',map($$_{parts_name},@$user_free_parts));
					}
					else{
						$data = $$user_free_parts[0]{parts_cont}
					}
					$list .= $$_{form_name}."：".$data."\n\n";
				}
			}
		}

		$report = "$$stg{mag_name}($$stg{id})の$actがありました。\n\n"
		."----------------------------------------------------------------------\n\n"
		.$list
		."----------------------------------------------------------------------\n\n";
		$report .=
		"コメント：\n\n".$$pd{user_comment}."\n\n"
		."----------------------------------------------------------------------\n\n" if($$pd{user_comment} && $$pd{user_comment} !~ /^[\t\s\r\n　 ]*$/);	
	
		#$subject = "$product_name：$actがありました";
		$subject = "$product_name：$actがありました（$$stg{id}）";
	}
	else{
		if($$pd{user_comment} && $$pd{user_comment} !~ /^[\t\s\r\n　 ]*$/){
			$$ud{name} = $$ud{email} if !$$ud{name};	
			$report = "$$stg{mag_name}($$stg{id})の$act時に、「$$ud{name}」さんよりコメントがありました。\n\n"
			."----------------------------------------------------------------------\n\n"
			.$$pd{user_comment}."\n\n"
			."----------------------------------------------------------------------\n\n";
			$subject = "$product_name：$act時にコメントがありました（$$stg{id}）";
		}
	}
	if($report){
		my %md = (
#			id			=> undef,
			id			=> $$stg{id},	#################### 1.67
			subject	=> $subject,
			html		=> 0
		);
		my @ud = ({ email => $$stg{admin_add} || $$stg{reply_add} });
		my %common = (
#			id		=> undef,
			id		=> $$stg{id},	################## 1.67
			from	=> &proc::set_mail_from($stg),
			rep		=> $$stg{reply_add},
			env		=> $$stg{envelope_add},
			his_no	=> undef,
			bulk	=> undef
		);
		$report =~ s/\r\n|\r|\n/\n/g;
		# Insert line-break witin certain characters (1.70)###################
		$report = &proc::insert_break_utf8($md{html},$report,200);
		##########################################################################
		my($res,$msg) = &start::sendmail(
			$dd,
			\%common,
			\@ud,
			undef,			# \@user_info
			\%md,
			$stg,
			$report,		# $tot_body
			undef,			# $mob_doms	
			undef,			# $attach
			undef,			# $free_list
			undef			# $d_type
		);
	}
}	

sub post_weblog{
	my (
		$stg,
		$dd,
		$md,
		$post_body,
		$his_no,
		$d_type
	) = @_;
	if($$stg{post_blog} == 1){
		my %pmd = (
			subject	=> $$md{subject},
			body		=> $post_body
		);
		my $pmd = &proc::conv_personal_for_post(\%pmd);
		my %blog = (
			id			=> $$stg{id},	# 1.67
			subject	=> $$pmd{subject},
			html		=> $$md{html}
		);
		my @ud = ({ email => $$stg{post_add} });
		my %common_b = (
#			id		=> undef,
			id		=> $$stg{id},	# 1.67
			from	=> &proc::set_mail_from($stg),
			rep		=> $$stg{reply_add},
			env		=> $$stg{envelope_add},
			his_no	=> undef,
			bulk	=> undef
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$d_type,
			"配信内容を指定のブログにメール投稿しています・・・\n"
		);
		$$pmd{body} =~ s/\r\n|\r|\n/\n/g;
		$$pmd{body} = &proc::insert_break_utf8($blog{html},$$pmd{body},200);	# 1.70
		my($res,$msg) = &start::sendmail(
			$dd,
			\%common_b,
			\@ud,
			undef,			# \@user_info
			\%blog,		# $md
			$stg,
			$$pmd{body},	# $tot_body
			undef,			# $mob_doms	
			#undef,		# $attach
			{},				# $attach -> no-name hash ref # 1.71
			undef,			# $free_list
			$d_type		# $d_type # 1.73
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$d_type,
			$msg
		);
		&save::action_log(
			$$stg{id},
			$his_no,
			$d_type,
			"※メールの送信に失敗しました。\n"
		) if !$res;
	}
}

sub sendmail{
	my(
		$dd,
		$common,
		$ud_ary,
		$user_info,
		$md,
		$stg,
		$tot_body,
		$mob_doms,	
		$attach,
		$free_list,
		$d_type	# 1.73
	) = @_;
	my $log;
	my $wwwdir = $$md{id} ? &get::wwwdir($$md{id}) : &get::msdir();
	my ($count,$prcdc) = $$common{bulk}
		? (	&get::delivers_count($$common{id}, $$common{his_no}), 'bulk')
		: (	eval {	my $cnt = @$ud_ary; return $cnt; }, 'list');
	# 1.77 ###############################
	if($$common{bulk} && !$count){
		&save::action_log(
			$$common{id},
			$$common{his_no},
			$d_type,
			"配信予定読者テーブルのデータ存在しないかすでに削除されています。"
		);
		return(1,"メールの送信が完了しました。");
	}
	#####################################
	if($config::oem && $$common{bulk}){
		# Call IDMS program
		require './lib/idms.pl';
		# Drop rejected addresses in commonDB
		require './lib/db_common.pl';
		my $res = &db_common::open();
		if(!$res){
			&save::action_log(
				$$common{id},
				$$common{his_no},
				$d_type,
				"共通データベースへの接続に失敗しました。"
			);
		}
		else{
			my $diag = 'Account_not_exists';
			&db_common::query("
				SELECT	email
				FROM	`reject_add`
			");
			while(my $href = $db_common::sth->fetchrow_hashref()){
				# Delete from delivers table
				&db::query("
					DELETE FROM `ms_delivers`
					WHERE	user_no	= (
								SELECT	no
								FROM	`ms_user_$$stg{id}`
								WHERE	email = '$$href{email}' 
							)	OR
							temp_email	= '$$href{email}'
				");
				&db::query("
					UPDATE	`ms_user_$$stg{id}`
					SET		$diag = $diag + 1
					WHERE	email = '$$href{email}'
				");
			}
			# Update user list
			if($$stg{treat_err} == 1){
				&db::query("
					DELETE 	`ms_user_$$stg{id}`,`ms_freeusersinfo`
					FROM		`ms_user_$$stg{id}`
					LEFT JOIN	`ms_freeusersinfo`
					ON			`ms_user_$$stg{id}`.no = `ms_freeusersinfo`.user_no	AND
								`ms_freeusersinfo`.id = '$$stg{id}'
					WHERE		$diag >= $$stg{$diag}
				");
			}
			else{
				&db::query("
					UPDATE	`ms_user_$$stg{id}`
					SET		active = '-1'
					WHERE	$diag >= $$stg{$diag}
				");
			}
			&db_common::close();
		}
	}
	################################################################
	
#	my $fqdn = &get::msfqdn(); -> ×
#	$$stg{from_add} =~ /\@(.+)$/;
	#my $fqdn = &get::parsed_fqdn($wwwdir);	# 1.63
	my $fqdn = $config::oem ? ($config::fqdn || &get::parsed_fqdn($wwwdir)) : &get::parsed_fqdn($wwwdir);	# 1.84
	my $si   = &get::sys_info();			# 1.63
	# 1.84 ############################
	if($tot_body eq ''){ return(0, "本文のコンテンツデータが見つかりません。配信を中止します。\n"); }
	###################################

	# ▼ 2015-10-22 ##################
	$$common{err} = $$common{env};
	# ▲ 2015-10-22 ##################

	# Given SMTP server
	if($$dd{smtp_given}){

		my $sl;
		if($$dd{smtp_given} == 1){
			push(@{$sl},$dd);
		}
		elsif($$dd{smtp_given} == 2){
			($sl) = &get::smtp_list();
			# Add localhost
			push(@{$sl},{
				smtp_server	=> '127.0.0.1',
				smtp_port		=> 25,
				smtp_auth		=> 0,
				smtp_prot		=> 0,
				# ▼ 2015-10-22 ##################
				smtp_envelope => 0
				# ▲ 2015-10-22 ##################
			});
		}
		elsif($$dd{smtp_given} == 3){	# 1.75
			($sl) = &get::smtp_list();
		}
		use Net::SMTP;
		# ▼ 2015-10-22 ##################
		#my @smtp_obj = ();
		# ▲ 2015-10-22 ##################
		foreach my $smtp(@$sl){
			my $obj;
			# Over TLS
			if($$smtp{smtp_prot} == 1){
				eval "use Net::SMTP::TLS;";
				if(!$@){
					$obj = Net::SMTP::TLS->new(
								$$smtp{smtp_server}				,
								Port				=> $$smtp{smtp_port}	,	#SSL_verify_mode	=> 'SSL_VERIFY_PEER',
								Timeout			=> 30,
								User				=> $$smtp{smtp_user}	,
								Password			=> &cp::dec_pass($$smtp{smtp_pass})
					) || return(0,"※SMTPサーバ($$smtp{smtp_server})へのTLS接続に失敗しました。\n");
				}
				else{
					return(0,"Net/SMTP/TLS.pmが参照できませんでした。\n");
				}
			}
			# Over SSL
			elsif($$smtp{smtp_prot} == 2){
				eval "use Net::SMTP::SSL;";
				if(!$@){
					$obj = Net::SMTP::SSL->new(
								$$smtp{smtp_server},
								Port				=> $$smtp{smtp_port},	#SSL_verify_mode	=> 'SSL_VERIFY_PEER',	# 1.71
								Timeout			=> 30
					) || return(0,"※SMTPサーバ($$smtp{smtp_server})へのSSL接続に失敗しました。\n$!");
				}
				else{
					return(0,"Net/SMTP/SSL.pmが参照できませんでした。\n");
				}
			}
			# No secure
			else{
				$obj = Net::SMTP->new(
							$$smtp{smtp_server},
							Port		=> $$smtp{smtp_port},
							Timeout	=> 30
				) || return(0,"※SMTPサーバ($$smtp{smtp_server})への接続に失敗しました。\n");
			}
			if($$smtp{smtp_prot} != 1 && $$smtp{smtp_auth}){
				$obj->auth(
					$$smtp{smtp_user},
					&cp::dec_pass($$smtp{smtp_pass})
				) || return(0,"※SMTPサーバ($$smtp{smtp_server})へのSMTP認証に失敗しました。\n");
			}

			# ▼ 2015-10-22 ##################
			#push (@smtp_obj,$obj);
			$$smtp{obj} = $obj;
			# ▲ 2015-10-22 ##################

		} # foreach

		# ▼ 2015-10-22 ##################
		#@smtp_obj = &proc::shuffle_array(@smtp_obj);
		#my $obj_n = 0;
		@$sl = &proc::shuffle_array(@$sl);
		my $smtp_n = 0;
		# ▲ 2015-10-22 ##################

		# For multiple IP option	(1.65～) #####################
		my @ips = ();
		if($config::multi_ip && $config::multi_ip > 1){
			@ips = &proc::shuffle_array((1..$config::multi_ip));
		}
		else{
			$ips[0] = 1;
		}
		my $ip_n = 0;
		##############################################################

		my $proc_start = time;
#eval{
		for(my $i=0; $i<$count; $i++){
			SEND:{
				my $ud;
				if($$common{bulk}){
					my $deliver = &get::deliver(
						$$common{id},
						$$common{his_no}
					);
					$ud = $$deliver{user_no}
							? &get::one_user_data2(
								$$common{id},
								$$deliver{user_no}
							)
							: {
								email	=> $$deliver{temp_email},
								name	=> $$deliver{temp_name}
					 		} ;
					############################### Urgent correction
#					&save::del_deliver($$deliver{no});
					&save::del_deliver($$deliver{no}) if $$deliver{no};
					########################################################
				}
				else{
					$ud = $$ud_ary[$i];
				}
				if($ud){
					########################################### 1.65 ～
					if($config::oem){

						# ▼ 2015-10-22 ##################
#						$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-1-'.$$ud{email};
						#$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-'.$ips[$ip_n].'-'.$$ud{email};
						#$$common{env} =~ s/@/=/;
						#$$common{env} .= '@'.$fqdn;

						$$common{err} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-'.$ips[$ip_n].'-'.$$ud{email};
						$$common{err} =~ s/@/=/;
						$$common{err} .= '@'.$fqdn;
						if($$sl[$smtp_n]{smtp_envelope}){
							$$common{env} = $$stg{from_add};
						}
						else{

#							$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-1-'.$$ud{email};
							#$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-'.$ips[$ip_n].'-'.$$ud{email};
							#$$common{env} =~ s/@/=/;
							#$$common{env} .= '@'.$fqdn;
							$$common{env} = $$common{err};
						}
						# ▲ 2015-10-22 ##################

					}
					###########################################
# debug ######
#$$common{from} = $$common{env} = 'dahh-sp@i.softbank.jp';
################
					my %psnl = ();
					(	$psnl{mail_head},
						$psnl{mail_foot},
						$psnl{to},
						$psnl{sub},
						$psnl{body},
						$psnl{unsb}
					) = &proc::set_users_maildata(
						$ud,
						$user_info,
						$md,
						$stg,
						$tot_body,
						$mob_doms,	
						$attach,
						$$common{his_no},
						$free_list,
						$si,			############### 1.63
						$wwwdir		############### 1.63
					);
					# Set mail header
# ▼ 2015-10-22 ############
#					my $header = <<HEADER;
#From: $$common{from}
#To: $psnl{to}
#Return-Path: $$common{env}
#Errors-To: $$common{env}
#Reply-To: $$common{rep}
#List-Unsubscribe: <$psnl{unsb}>
#X-List-Unsubscribe: <$psnl{unsb}>
#Precedence: $prcdc
#Subject: $psnl{sub}
#$psnl{mail_head}
#HEADER
					my $header = <<HEADER;
From: $$common{from}
To: $psnl{to}
Return-Path: $$common{err}
Errors-To: $$common{err}
Reply-To: $$common{rep}
List-Unsubscribe: <$psnl{unsb}>
X-List-Unsubscribe: <$psnl{unsb}>
Precedence: $prcdc
Subject: $psnl{sub}
$psnl{mail_head}
HEADER
# ▲ 2015-10-22 ############
					#### Print

					# ▼ 2015-10-22 ############
					#$smtp_obj[$obj_n]->mail($$common{env});
					#$smtp_obj[$obj_n]->to($psnl{to});	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")から接続を拒否されました。\n");
					#$smtp_obj[$obj_n]->data();			#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのデータ送信に失敗しました。\n");
					#$smtp_obj[$obj_n]->datasend($header);	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのメールヘッダ送信に失敗しました。\n");
					#$smtp_obj[$obj_n]->datasend($psnl{body}."\n".$psnl{mail_foot});	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのメールボディ送信に失敗しました。\n");
					##$smtp_obj[$obj_n]->datasend($psnl{body}.'given smtp test'.$psnl{mail_foot});
					#$smtp_obj[$obj_n]->dataend();		#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")からのメール送信に失敗しました。\n");

					$$sl[$smtp_n]{obj}->mail($$common{env});
					$$sl[$smtp_n]{obj}->to($psnl{to});	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")から接続を拒否されました。\n");
					$$sl[$smtp_n]{obj}->data();			#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのデータ送信に失敗しました。\n");
					$$sl[$smtp_n]{obj}->datasend($header);	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのメールヘッダ送信に失敗しました。\n");
					$$sl[$smtp_n]{obj}->datasend($psnl{body}."\n".$psnl{mail_foot});	#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")へのメールボディ送信に失敗しました。\n");
					$$sl[$smtp_n]{obj}->dataend();		#|| return(0,"※SMTPサーバ(".$smtp_obj[$obj_n]->domain().")からのメール送信に失敗しました。\n");
					# ▲ 2015-10-22 ############

					if($$common{bulk}){
						&save::history_during(
							$$common{id},
							$$common{his_no}
						);

						# IDMS START
						if($config::oem && ($i+1) % $config::chk_unit == 0 && ($i+1) < $count){
							# 1.77 ##############################
							#&idms::manage_inode(
							#	$common,
							#	$$md{subject},
							#	$tot_body,
							#	$attach
							#);
							#&idms::manage_memory(
							#	$common,
							#	$$md{subject},
							#	$tot_body,
							#	$attach
							#);
							&idms::manage_inode($common);
							&idms::manage_memory($common);
							###################################
						}
						# IDMS END
						if($$dd{mass} != 0 && $$dd{intervals} != 0){
							if(($i+1) % $$dd{mass} == 0 && $i+1 != $count){
								for(my $sec=0; $sec<$$dd{intervals}; $sec++){
									WAIT: {
										select(undef,undef,undef,1);
										if($$dd{switch_proc} && (time - $proc_start) >= $$dd{switch_time} && ($sec+1 != $$dd{intervals})){
											my $new_pid = '';
											if($new_pid = fork){
												exit;
											}
											elsif(defined $new_pid) {
												$proc_start = time;
#												&db::child_open();
												&db::change_connection();
												# Update pid info
												&save::history_pid(
													$$common{id},
													$$common{his_no},
													$$
												) if $$common{id};
												$sec++;
												redo WAIT;
											}
											else{
												# Case can't fork or too many processes
												next;
											}
										}
									}# end of WAIT
								}
							}
						}
						if($$dd{switch_proc} && (time - $proc_start) >= $$dd{switch_time}	&& ($i+1 != $count)){
							my $new_pid = '';
							if($new_pid = fork){
								exit;
							}
							elsif(defined $new_pid) {
								$proc_start = time;
#								&db::child_open();
								&db::change_connection();
								# Update pid info
								&save::history_pid(
									$$common{id},
									$$common{his_no},
									$$
								) if $$common{id};
								$i++;
								redo SEND;
							}
							else{
								# Case can't fork or too many processes
								next;
							}
						}
						############################################################################################
					} # if bulk	1.74
				} # if $ud
				else{
					# Case user's data is not find (unlinked while execting this loop)
					if($$common{bulk}){
						&save::history_during(
							$$common{id},
							$$common{his_no}
						);
					}
				} # else
				undef $ud;
				############################################################################################
			} # end of SEND

			# ▼ 2015-10-22 ############
			#$obj_n = (($obj_n + 1) >= @smtp_obj) ? 0 : $obj_n + 1;	####################
			$smtp_n = (($smtp_n + 1) >= @$sl) ? 0 : $smtp_n + 1;	####################
			# ▲ 2015-10-22 ############

			# ▼ 2015-10-22 ############
			#$ip_n = $obj_n == 0 && ($ip_n + 1) < @ips
			#	? $ip_n + 1 : 0;	####################
			$ip_n = $smtp_n == 0 && ($ip_n + 1) < @ips
				? $ip_n + 1 : 0;	####################
			# ▲ 2015-10-22 ############

		}# for
		# ▼ 2015-10-22 ############
		#map {$_->quit();} @smtp_obj;
		map {$$_{obj}->quit();} @$sl;
		# ▲ 2015-10-22 ############
		
#=cut
	}
	# Use Local host(sendmail)
	else{
		my $si = &get::sys_info();
		# For multiple IP option	(1.65～) #####################
		my @ips = ();
		if($config::multi_ip && $config::multi_ip > 1){
			@ips = &proc::shuffle_array((1..$config::multi_ip));
		}
		else{
			$ips[0] = 1;
		}
		my $ip_n = 0;
		##############################################################
		my $proc_start = time;
#die $tot_body;
		for(my $i=0; $i<$count; $i++){
			SEND:{
				my $ud;
				if($$common{bulk}){
					my $deliver = &get::deliver(
						$$common{id},
						$$common{his_no}
					);
					$ud = $$deliver{user_no}
							? &get::one_user_data2(
								$$common{id},
								$$deliver{user_no}
							)
							: {
								email	=> $$deliver{temp_email},
								name	=> $$deliver{temp_name}
					 		} ;
					############################### Urgent correction
#					&save::del_deliver($$deliver{no});
					&save::del_deliver($$deliver{no}) if $$deliver{no};
					########################################################

					###########################################
#					if($config::oem){
#						$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-1-'.$$ud{email};
#						$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-'.$ips[$ip_n].'-'.$$ud{email};
#						$$common{env} =~ s/@/=/;
#						$$common{env} .= '@'.$fqdn;
#					}
					###########################################
				}
				else{
					$ud = $$ud_ary[$i];
				}
				if($ud){
					########################################### 1.65 ～

					if($config::oem){
#						$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-1-'.$$ud{email};
						$$common{env} = 'bounce+'.$$common{id}.'-'.$$common{his_no}.'-'.$ips[$ip_n].'-'.$$ud{email};
						$$common{env} =~ s/@/=/;
						$$common{env} .= '@'.$fqdn;
					}
					###########################################
					my %psnl = ();
					(	$psnl{mail_head},
						$psnl{mail_foot},
						$psnl{to},
						$psnl{sub},
						$psnl{body},
						$psnl{unsb}
					) = &proc::set_users_maildata(
						$ud,
						$user_info,
						$md,
						$stg,
						$tot_body,
						$mob_doms,	
						$attach,
						$$common{his_no},
						$free_list,
						$si,			############### 1.63
						$wwwdir		############### 1.63
					);
#die $psnl{body};
					open(MAIL, "| $$si{s_m_path} -t -f $$common{env}") || return(0,"※sendmailのオープンに失敗しました。\n");
					print MAIL <<EOM;
From: $$common{from}
To: $psnl{to}
Return-Path: $$common{env}
Errors-To: $$common{env}
Reply-To: $$common{rep}
List-Unsubscribe: <$psnl{unsb}>
X-List-Unsubscribe: <$psnl{unsb}>
Precedence: $prcdc
Subject: $psnl{sub}
$psnl{mail_head}
$psnl{body}
$psnl{mail_foot}
EOM
					close MAIL;
					if($$common{bulk}){
						&save::history_during(
							$$common{id},
							$$common{his_no}
						);

						#########################################################
						# IDMS START
						if($config::oem && ($i+1) % $config::chk_unit == 0 && ($i+1) < $count){
							# 1.77 ##############################
							#&idms::manage_inode(
							#	$common,
							#	$$md{subject},
							#	$tot_body,
							#	$attach
							#);
							#&idms::manage_memory(
							#	$common,
							#	$$md{subject},
							#	$tot_body,
							#	$attach
							#);
							&idms::manage_inode($common);
							&idms::manage_memory($common);
							###################################
						}
						# IDMS END
						#########################################################
						if($$dd{mass} != 0 && $$dd{intervals} != 0){
							# Case delivery limit
							if(($i+1) % $$dd{mass} == 0 && $i+1 != $count){
								for(my $sec=0; $sec<$$dd{intervals}; $sec++){
									WAIT: {
										select(undef,undef,undef,1);
										if($$dd{switch_proc} && (time - $proc_start) >= $$dd{switch_time} && ($sec+1 != $$dd{intervals})){
											my $new_pid = '';
											if($new_pid = fork){
												exit;
											}
											elsif(defined $new_pid) {
												$proc_start = time;
#												&db::child_open();
												&db::change_connection();
												# Update pid info
												&save::history_pid(
													$$common{id},
													$$common{his_no},
													$$
												) if $$common{id};
												$sec++;
												redo WAIT;
											}
											else{
												# Case can't fork or too many processes
												next;
											}
										}
									}# end of WAIT
								}
							}
						}
						if($$dd{switch_proc} && (time - $proc_start) >= $$dd{switch_time}	&& ($i+1 != $count)){
							my $new_pid = '';
							if($new_pid = fork){
								exit;
							}
							elsif(defined $new_pid) {
								$proc_start = time;
								&db::change_connection();	##############################
								# Update pid info
								&save::history_pid(
									$$common{id},
									$$common{his_no},
									$$
								) if $$common{id};
								$i++;
								redo SEND;
							}
							else{
								# Case can't fork or too many processes
								next;
							}
						}
					}################ if bulk	1.74
				} # if $ud
				else{
					# Case the user's data is not found (unlinked while execting this loop)
					if($$common{bulk}){
						&save::history_during(
							$$common{id},
							$$common{his_no}
						);
					}
				} # else
				undef $ud;
			}# end of SEND

			$ip_n = (($ip_n + 1) >= @ips) ? 0 : $ip_n + 1;	####################

		}# for
	}
	#　Cleaning delivers table
	if($$common{bulk}){
		&save::del_delivers(
			$$common{id},
			$$common{his_no}
		);
	}
	return(1,"メールの送信が完了しました。\n");
}

# Immediate delivery
sub imme{
	my $fd = $F->Vars;
	# Set setting data
	my $stg = &get::setting_data();
	my $dd  = &get::delivery();
	# Set mail contents
	my %md = (
		id					=>	$$fd{id},
		sort_no			=>	undef,
		html				=>	$$fd{html},
		lang				=>	$$fd{lang},	# 1.60
		os					=>	$$fd{os},		# 1.81
		nl2br				=>	$$fd{nl2br},
		auto_sbj			=>	$$fd{auto_sbj},
		sbj_cont			=>	$$fd{sbj_cont},
		define_header		=>	$$fd{define_header},
		define_header_no	=>	$$fd{define_header_no},
		header				=>	$$fd{header},
		body				=>	$$fd{body},
		define_footer		=>	$$fd{define_footer},
		define_footer_no	=>	$$fd{define_footer_no},
		footer				=>	$$fd{footer},
		cs					=>	$$fd{cs},
		excl_cs			=>	$$fd{excl_cs},
		filter				=>	$$fd{filter},
		filter_cont		=>	$$fd{filter_cont},
		excl_word			=>	$$fd{excl_word}
	);
	my $md = &proc::make_cont(\%md);
	# 1.84 ##################################
	if($$md{body} eq ''){ return(0, "本文のコンテンツデータが見つかりません。即時配信を中止します。\n"); };
	#########################################
	my $tot_body = $$md{header}
		? ($$md{footer}	? $$md{header}."\n".$$md{body}."\n".$$md{footer}
							: $$md{header}."\n".$$md{body} )
		
		: ($$md{footer}	? $$md{body}."\n".$$md{footer}
							: $$md{body} );
	
	# Process bounce mail;
	my $pb_log;
#	$pb_log = &proc::bounce($stg) if !$config::oem;
	# Set users
#	my $ud = &get::user_data(
#					$$md{id},
#					$$md{filter},
#					$$md{filter_cont}
#				);
#	my $un = &get::user_nos(
#		$$md{id},
#		$$md{filter},
#		$$md{filter_cont}
#	);
	my $un = &get::user_nos(
		$$fd{id},
		$$fd{filter},
		$$fd{filter_cont}
	);

#print "Content-type: text/plain\n\n";
#map {print $$_{no}."\n";} @$un;
#exit;

	my $un_el = @$un;
	# Set users content
	if($un_el == 0){
		&show::error("配信可能な読者がいませんでした。",$EC.__LINE__);
	}
	else{
#=pod
		FORK: {
			my $pid = "";
			if( $pid = fork ) {
				# Remove extra data
				&save::del_extra();
				&show::imme_done($pb_log,$un_el);
				close(STDOUT);
				close(STDERR);
				close(STDIN);
				wait;
			}
			elsif(defined $pid) {
				close(STDOUT);
				close(STDERR);
				close(STDIN);
				&db::child_open();
#=cut
				my $his_no = &get::his_maxno($$fd{id}) + 1;
				# Save history first
				&save::history_first(
					$$fd{id},
					$fd,
					$his_no,
					0,	# Story NO (Extra -> 0)
					0	# Delivery type (immediate -> 0)	
				);
				&save::action_log(
					$$fd{id},
					$his_no,
					0,
					$pb_log
				) if $pb_log;
				my %common = (
					id		=> $$fd{id},
					from	=> &proc::set_mail_from($stg,$$md{lang}),	# 1.60
					rep		=> $$stg{reply_add},
					env		=> $$stg{envelope_add},
					his_no	=> $his_no,
					bulk	=> 1
				);
				# Convert Image
				my $save_subject = '';
				my $save_body = '';
				my $post_body = '';
				my $attach = '';
				if($$md{html}){
					if($$md{nl2br}){
						$tot_body  =~ s/\r\n|\r|\n/<br \/>\n/g;
						$$md{body} =~ s/\r\n|\r|\n/<br \/>\n/g;
					}
					my $wwwdir = &get::wwwdir($$md{id});
					$save_subject = &proc::conv_pictgram_image(0,$$md{subject},$wwwdir);
					# 1.71 #######################
					#$save_body = &proc::conv_image($tot_body,$wwwdir);
					my $pc_body = &proc::conv_image($tot_body,$wwwdir);
					#$save_body = &proc::conv_pictgram_image(0,$save_body,$wwwdir);
					$save_body = &proc::conv_pictgram_image(0,$pc_body,$wwwdir);
					##############################
					$post_body = &proc::conv_image($$md{body},$wwwdir);
					$post_body = &proc::conv_pictgram_image(0,$post_body,$wwwdir);
					#if($$md{html} == 1){	# For PC
					#	$tot_body = $save_body;
					#}
					#elsif($$md{html} == 2){	# For Mobile
					#	($tot_body,$attach) = &proc::conv_image_for_mobile($tot_body);
					#	require './lib/mobile.pl';
					#}
					# 1.71  ##############################################
					require './lib/mobile.pl';
					if($$md{html} >= 2){	# For mobile
						($tot_body,$attach) = &proc::conv_image_for_mobile($tot_body);
					}
					else{	# For PC
						($tot_body,$attach) = ($pc_body, {});
					}
					######################################################
				}
				else{
					$save_body    = $tot_body;
					$save_subject = $$md{subject};
					$post_body    = $$md{body};
				}
				# Set delivers table
				&save::delivers(
					$$fd{id},
					$his_no,
					$un
				);
				&save::action_log(
					$$fd{id},
					$his_no,
					0,
					"配信予定読者テーブルセット完了・・・"
				);
				# Save url
				if($$md{cs} == 1){
				#	# Convert URL
				#	$tot_body = &save::convert_url(
				#		$$fd{id},
				#		$tot_body,
				#		$$md{excl_cs},
				#		$$stg{cs_path},
				#		$his_no,
				#		$$fd{html},
				#		0	# is not restart-> 0  1.80
				#	);
				}
				# Set each maildata
				my $mob_doms  = &get::mobile_domain();
				my @user_info = &item::user_info($$fd{id});
				my $free_list = &get::free_form_list($$fd{id});

				# Save history second
				&save::history_second(
					$$fd{id},
					$his_no,
					$save_subject,
					$save_body,		# URL not converted body
					$un_el
				);
				# Send mail to users
				&save::action_log(
					$$fd{id},
					$his_no,
					0,
					"号外記事No.".$$md{sort_no}."の配信対象読者(".$un_el."名)に配信を開始しました。"
				);
				$tot_body =~ s/\r\n|\r|\n/\n/g;
				$tot_body = &proc::insert_break_utf8($$md{html},$tot_body,200);	# 1.70
				my($res,$msg) = &start::sendmail(
					$dd,
					\%common,
					undef,		# $ud,
					\@user_info,
					$md,
					$stg,
					$tot_body,
					$mob_doms,	
					$attach,
					$free_list,
					0	# $d_type 1.73～
				);
				&save::action_log(
					$$fd{id},
					$his_no,
					0,
					$msg
				);
				if(!$res){
					&save::action_log(
						$$fd{id},
						$his_no,
						0,
						"※メールの送信に失敗しました。"
					);
					&save::del_delivers(
						$$fd{id},
						$his_no
					);
					&save::action_log(
						$$fd{id},
						$his_no,
						0,
						"※配信予定読者デーブルからデータを削除しました。"
					);
				}
				# Save history last
				my $comp = $res ? 1 : 2;
				&save::history_last(
					$$fd{id},
					$his_no,
					$comp
				);
				# Remove old history and clicks data
				if($$stg{data_period} ne '' && $$stg{data_period} != 0){
					&save::del_olddata(
						$$fd{id},
						$$stg{data_period}
					);
				}
				&save::action_log(
					$$fd{id},
					$his_no,
					0,
					"※古い履歴データ等をを削除しました。"
				);
				# Post weblogs
				&start::post_weblog(
					$stg,
					$dd,
					$md,
					$post_body,
					$his_no,
					0			# delivery type (imme -> 0)
				);
				# Send report to admin
				&start::report(
					$stg,
					$dd,
					$his_no
				);
#=pod
			}
			elsif ( $! =~ /No more process/) {
				# Case too many processes
				sleep 5;
				redo FORK;
			}
			else {
				&show::error("
					<p>forkがサポートされていません。</p>
					<p>サーバ管理者にお問い合わせください。</p>
				");   
			}
		} # End Of FORK
#=cut
	}
}

sub return_mail{
	my(
		$ud,
		$stg,
		$msg_sbj,$msg_cont,$lang,	# &get::doi_msg_cont(,2)
		$dd	
	) = @_;
	my %md = (
		id			=> $$stg{id},
		sbj_cont	=> $msg_sbj,		# 1.66
		body		=> $msg_cont,
		html		=> 0,
		lang		=> $lang
	);
	my $md = &proc::make_cont(\%md);	# 1.66
	$ud = &get::one_user_data($$stg{id},$$ud{no}) if $$ud{no};
	my @ud = ($ud);
	my @user_info = &item::user_info($$stg{id});
	my $free_list = &get::free_form_list($$stg{id});
	my %common = (
		id		=> $$stg{id},	# 1.65 ～
		from	=> &proc::set_mail_from($stg,$lang),
		rep		=> $$stg{reply_add},
		env		=> $$stg{envelope_add},
		his_no	=> 0,		# 1.65 ～
		bulk	=> undef
	);
	$$md{body} =~ s/\r\n|\r|\n/\n/g;
	# Insert line-break witin certain characters (1.70)###################
	$$md{body} = &proc::insert_break_utf8($$md{html},$$md{body},200);
	##########################################################################
	my($res,$msg) = &start::sendmail(
		$dd,
		\%common,
		\@ud,
		\@user_info,
		$md,
		$stg,
		$$md{body},	# $tot_body
		undef,			# $mob_doms	
		undef,			# $attach
		$free_list,
		undef			# $d_type
	);
}


1;

