###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package tbl;
use strict;

sub conf{
	my %tbl = (
		'system' => {
			'period'	=> 'init',
			'column'	=> '
				no              INT           AUTO_INCREMENT PRIMARY KEY,
				s_m_path        VARCHAR(36),
				email           VARCHAR(255),
				smtp_given      TINYINT,
				smtp_server     VARCHAR(255),
				smtp_port       INT,
				smtp_auth       TINYINT,
				smtp_user       VARCHAR(255),
				smtp_pass       VARCHAR(255),
				smtp_prot       TINYINT,
				smtp_check      TINYINT       DEFAULT 1, -- 1.83
				logout_sec      INT           DEFAULT 1800,
				domain_docomo   VARCHAR(255)  DEFAULT \'docomo.ne.jp\',
				domain_ezweb    VARCHAR(255)  DEFAULT \'ezweb.ne.jp\',
				domain_softbank VARCHAR(255)  DEFAULT \'softbank.ne.jp\nt.vodafone.ne.jp\nd.vodafone.ne.jp\nh.vodafone.ne.jp\nc.vodafone.ne.jp\nr.vodafone.ne.jp\nk.vodafone.ne.jp\nn.vodafone.ne.jp\ns.vodafone.ne.jp\nq.vodafone.ne.jp\ndisney.ne.jp\ni.softbank.jp\',
				use_static      TINYINT       DEFAULT 0,
				use_editor      TINYINT       DEFAULT 1,
				ext_delimiter   VARCHAR(1)    DEFAULT \'+\',
				use_option_ssl  TINYINT       DEFAULT NULL -- 1.84
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'author' => {
			'period'	=> 'init',
			'column'	=> '
				no				INT          NOT NULL AUTO_INCREMENT PRIMARY KEY,
				super_user		TINYINT,
				login_id		VARCHAR(255),
				login_pass		VARCHAR(255),
				pass_phrase	VARCHAR(255),
				can_mk_ms		TINYINT	,
				can_mk_am		TINYINT	,
				can_mk_sm		TINYINT	,
				can_mk_inv    TINYINT	,
				can_edit_ms	TINYINT	,
				can_edit_am	TINYINT	,
				can_edit_sm	TINYINT	,
				can_edit_inv  TINYINT	,
				can_show_users    TINYINT  DEFAULT 1, -- 1.77
				can_operate_users TINYINT,
				can_vup		TINYINT	,
				can_other		TINYINT	,
				email			VARCHAR(255),
				entry			DATETIME,
				maked_by      VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'session' => {
			'period'	=> 'init',
			'column'	=> '
				sid       VARCHAR(255) NOT NULL PRIMARY KEY,
				login_id  VARCHAR(255),
				start     INT,
				token     VARCHAR(16) DEFAULT NULL
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'setting' => {
			'period'	=> 'init',
			'column'	=> '
				no              INT          NOT NULL AUTO_INCREMENT PRIMARY KEY,
				id              VARCHAR(8)   NOT NULL UNIQUE,
				type_num        TINYINT      NOT NULL,
				entry           DATE         NOT NULL,
				cs_path         VARCHAR(255),
				regist_path     VARCHAR(255),
				del_path        VARCHAR(255),
				bcn_path        VARCHAR(255),
				lmtd_path       VARCHAR(255),
				mag_name        VARCHAR(255),
				memo            VARCHAR(255),
				from_add        VARCHAR(255),
				reply_add       VARCHAR(255),
				envelope_add    VARCHAR(255),
				pop_host        VARCHAR(255),
				pop_user        VARCHAR(255),
				pop_pwd         VARCHAR(255),
				pop_ssl         TINYINT  DEFAULT 0,
				Host_not_exists     INT  DEFAULT 1,
				Connection_timeout  INT  DEFAULT 3,
				Account_not_exists  INT  DEFAULT 1,
				Mailbox_unavailable INT  DEFAULT 3,
				Server_error        INT  DEFAULT 3,
				Authen_error        INT  DEFAULT 3,
				Auto_return         INT  DEFAULT 1,
				Other               INT  DEFAULT 3,
				treat_err           INT  DEFAULT 2,
				from_name       VARCHAR(255),
				regi_msg        TINYINT      DEFAULT 1,
				regi_msg_sbj    VARCHAR(255),
				regi_msg_cont   TEXT,
				regi_msg_lang   TINYINT      DEFAULT 0,
				ulk_msg         TINYINT      DEFAULT 1,
				ulk_msg_sbj     VARCHAR(255),
				ulk_msg_cont    TEXT,
				ulk_msg_lang    TINYINT      DEFAULT 0,
				mdf_msg         TINYINT      DEFAULT 1,
				mdf_msg_sbj     VARCHAR(255),
				mdf_msg_cont    TEXT,
				mdf_msg_lang    TINYINT      DEFAULT 0,
				double_optin    TINYINT      DEFAULT 0,
				doi_msg_sbj     VARCHAR(255),
				doi_msg_cont    TEXT,
				doi_msg_lang    TINYINT      DEFAULT 0,
				double_optin2   TINYINT      DEFAULT 0,
				doi2_msg_sbj    VARCHAR(255),
				doi2_msg_cont   TEXT,
				doi2_msg_lang   TINYINT      DEFAULT 0,
				treat_doi       TINYINT      DEFAULT 1,
				unlink          TINYINT      DEFAULT 1,
				unlink_alert    TINYINT      DEFAULT 1,
				treat_ulk       TINYINT      DEFAULT 2,
				black           TINYINT      DEFAULT 1,
				admin_repo      TINYINT      DEFAULT 0,
				repo_inc_users  TINYINT      DEFAULT 0,
				repo_inc_body   TINYINT      DEFAULT 0,
				admin_repo_reg  TINYINT      DEFAULT 0,
				admin_repo_rm   TINYINT      DEFAULT 0,
				admin_add       VARCHAR(255),
				sim_entry       TINYINT      DEFAULT 0,
				sim_entry_mags  VARCHAR(255),
				regi_fini_url1  VARCHAR(255),
				regi_fini_url2  VARCHAR(255),
				ulk_fini_url1   VARCHAR(255),
				ulk_fini_url2   VARCHAR(255),
				data_period     INT          DEFAULT 90,
				auto_regi       TINYINT      DEFAULT 0,
				last_auto_regi  DATE         NOT NULL,
				auto_regi_time  TIME         NOT NULL,
				auto_regi_sites VARCHAR(255),
				fir_points1     INT          DEFAULT 10 NOT NULL,
				fir_points2     INT          DEFAULT 25 NOT NULL,
				add_points      INT          DEFAULT 5  NOT NULL,
				add_1time       TINYINT      DEFAULT 1,
				post_blog       TINYINT      DEFAULT 0,
				post_add        VARCHAR(255),
				return_day1     TINYINT      DEFAULT 1,
				show_img_plt    TINYINT      DEFAULT 0,
				karame_permit   TINYINT      DEFAULT 1,
				karame_add      VARCHAR(255),
				karame_add2     VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
		'updatehis' => {
			'period'	=> 'init',
			'column'	=> '
				no           INT          AUTO_INCREMENT PRIMARY KEY,
				entry        DATETIME,
				vup_file     VARCHAR(255),
				version      VARCHAR(30),
				release_date DATE,
				other        TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'delivery' => {
			'period'	=> 'init',
			'column'	=> '
				no            INT          AUTO_INCREMENT PRIMARY KEY,
				id            VARCHAR(8)   NOT NULL UNIQUE,
				smtp_given    TINYINT      DEFAULT 0,
				smtp_server   VARCHAR(255),
				smtp_port     INT          DEFAULT 25,
				smtp_auth     TINYINT      DEFAULT 0,
				smtp_user     VARCHAR(255),
				smtp_pass     VARCHAR(255),
				smtp_prot     TINYINT      DEFAULT 0,
				smtp_envelope TINYINT      DEFAULT 0, -- 2015-10-22
				smtp_check    TINYINT      DEFAULT 1,
				mass          INT          NOT NULL DEFAULT 100,
				intervals     INT          NOT NULL DEFAULT 1,
				switch_proc   TINYINT      DEFAULT 0,
				switch_time   INT          DEFAULT 10
				
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
		'definehead' => {
			'period'	=> 'init',
			'column'	=> '
				no      INT AUTO_INCREMENT PRIMARY KEY,
				html    TINYINT      DEFAULT 0,
				nl2br   TINYINT      DEFAULT 0,
				title   VARCHAR(255),
				content TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'definefoot' => {
			'period'	=> 'init',
			'column'	=> '
				no      INT AUTO_INCREMENT PRIMARY KEY,
				html    TINYINT      DEFAULT 0,
				nl2br   TINYINT      DEFAULT 0,
				title   VARCHAR(255),
				content TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'attri' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				name        VARCHAR(255),
				memo        VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'actionlog' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8),
				type        TINYINT,
				his_no      INT,
				rec_time    DATETIME,
				log         TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'originaltag' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				insert_str  VARCHAR(255),
				content     TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		'regform' => {
			'period'	=> 'init',
			'column'	=> '
				no         INT AUTO_INCREMENT PRIMARY KEY,
				id         VARCHAR(8) NOT NULL,
				modify     TINYINT DEFAULT 0,
				permit     TINYINT DEFAULT 1, -- 1.78
				charset    VARCHAR(16) DEFAULT \'utf8\',
				alert      TINYINT DEFAULT 1,
				email_cfm    TINYINT DEFAULT 0, -- 1.79
				email_cfm_e  TINYINT DEFAULT 0, -- 1.79
				email_new    TINYINT DEFAULT 1,
				email_new_e  TINYINT DEFAULT 1,
				name       TINYINT DEFAULT 1,
				name_e     TINYINT DEFAULT 1,
				name_splt  TINYINT DEFAULT 0,
				sex        TINYINT DEFAULT 0,
				sex_e      TINYINT DEFAULT 0,
				birth      TINYINT DEFAULT 0,
				birth_e    TINYINT DEFAULT 0,
				postal     TINYINT DEFAULT 0,
				postal_e   TINYINT DEFAULT 0,
				live_1     TINYINT DEFAULT 0,
				live_1_e   TINYINT DEFAULT 0,
				live_2     TINYINT DEFAULT 0,
				live_2_e   TINYINT DEFAULT 0,
				phone      TINYINT DEFAULT 0,
				phone_e    TINYINT DEFAULT 0,
				marr       TINYINT DEFAULT 0,
				marr_e     TINYINT DEFAULT 0,
				child      TINYINT DEFAULT 0,
				child_e    TINYINT DEFAULT 0,
				house      TINYINT DEFAULT 0,
				house_e    TINYINT DEFAULT 0,
				pet        TINYINT DEFAULT 0,
				pet_e      TINYINT DEFAULT 0,
				pet_kind   TINYINT DEFAULT 0,
				pet_kind_e TINYINT DEFAULT 0,
				interest   TINYINT DEFAULT 0,
				interest_e TINYINT DEFAULT 0,
				uid        TINYINT DEFAULT 0,
				uid_e      TINYINT DEFAULT 0,
				upwd       TINYINT DEFAULT 0,
				upwd_e     TINYINT DEFAULT 0,
				job        TINYINT DEFAULT 0,
				job_e      TINYINT DEFAULT 0,
				sports     TINYINT DEFAULT 0,
				sports_e   TINYINT DEFAULT 0,
				trouble    TINYINT DEFAULT 0,
				trouble_e  TINYINT DEFAULT 0,
				udevice    TINYINT DEFAULT 0, -- 1.81
				udevice_e  TINYINT DEFAULT 0, -- 1.81
				tarea      TINYINT DEFAULT 0,
				tarea_e    TINYINT DEFAULT 0,
				tarea_exp  VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
		'backnumber' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8) NOT NULL UNIQUE,
				rel         TINYINT DEFAULT 1,
				rel_period  INT     DEFAULT 0
				-- temp_type   TINYINT DEFAULT 0,
				-- temp_cont   TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},

		'default' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8) NOT NULL, -- UNIQUE,
				device      TINYINT  DEFAULT 1,
				form_reg    TEXT,
				form_mdf    TEXT,
				error       TEXT,
				regi_fini   TEXT,
				regi_alert  TEXT,
				ulk_fini    TEXT,
				ulk_alert   TEXT,
				mdf_fini    TEXT,
				mdf_alert   TEXT,
				p_r_fini    TEXT,
				form_t_r    TEXT,
				bcn         TEXT,
				induce_kara_reg    TEXT, -- 1.81
				induce_kara_rm     TEXT, -- 1.81
				flw_form_reg   TINYINT NOT NULL DEFAULT 1,
				flw_form_mdf   TINYINT NOT NULL DEFAULT 1,
				flw_error      TINYINT NOT NULL DEFAULT 1,
				flw_regi_fini  TINYINT NOT NULL DEFAULT 1,
				flw_regi_alert TINYINT NOT NULL DEFAULT 1,
				flw_ulk_fini   TINYINT NOT NULL DEFAULT 1,
				flw_ulk_alert  TINYINT NOT NULL DEFAULT 1,
				flw_mdf_fini   TINYINT NOT NULL DEFAULT 1,
				flw_mdf_alert  TINYINT NOT NULL DEFAULT 1,
				flw_p_r_fini   TINYINT NOT NULL DEFAULT 1,
				flw_form_t_r   TINYINT NOT NULL DEFAULT 1,
				flw_bcn        TINYINT NOT NULL DEFAULT 1,
				flw_induce_kara_reg   TINYINT NOT NULL DEFAULT 0, -- 1.81
				flw_induce_kara_rm    TINYINT NOT NULL DEFAULT 0  -- 1.81
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},

		'unknown' => {
			'period'	=> 'init',
			'column'	=> '
				no           INT AUTO_INCREMENT PRIMARY KEY,
				id           VARCHAR(8) NOT NULL,
				entry        DATETIME,
				unknown_type TINYINT,
				source       TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			'
		},

		'erradd' => {
			'period'	=> 'init',
			'column'	=> '
				no           INT AUTO_INCREMENT PRIMARY KEY,
				id           VARCHAR(8),
				his_no       INT,
				diag         VARCHAR(255),
				email        VARCHAR(255),
				INDEX id(id),
				INDEX his_no(his_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			'
		},

		# Relating to Free Form ############
		'freeform' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8) NOT NULL,
				form_name   VARCHAR(255) NOT NULL,
				description TEXT,
				form_type   INT NOT NULL,
				active      TINYINT NOT NULL DEFAULT 0,
				active_m    TINYINT NOT NULL DEFAULT 0,
				active_tr   TINYINT NOT NULL DEFAULT 0,
				essen       TINYINT DEFAULT 0,
				essen_m     TINYINT DEFAULT 0,
				essen_tr    TINYINT DEFAULT 0
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
			# form type	0: text
			#				1: password
			#				2: radio
			#				3: checkbox
			#				4: selectbox
			#				5: textarea
			# essen	0: any
			#			1: required
			# purpose	1: regist form
			#			2: modify form
			#			3: questionnaire(Enquete)	-> future

		'freeparts' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				form_no     INT NOT NULL,
				form_type   INT NOT NULL,
				parts_name  VARCHAR(255),
				def_value   TEXT,
				default_on  INT NOT NULL DEFAULT 0,
				ta_rows     VARCHAR(255),
				ta_cols     VARCHAR(255),
				maxlength   VARCHAR(255),
				y_start        INT DEFAULT -30,
				y_end          INT DEFAULT 30,
				def_date_type  INT DEFAULT 0,
				def_date       DATE
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
			# Parts type	0: text
			#				1: password
			#				2: radio
			#				3: checkbox
			#				4: selectbox
			#				5: textarea
			#				6: DATE
			# Checked		0: off
			#				1: on
			# def_date_type	0: no
			#					1: today
			#					2: given date
		'freeusersinfo' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8) NOT NULL,
				user_no     INT NOT NULL,
				form_no     INT NOT NULL,
				form_type   INT NOT NULL,
				parts_cont  TEXT,
				INDEX id(id),
				INDEX user_no(user_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},
		
		'limited' => {
			'period'	=> 'init',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				id          VARCHAR(8) NOT NULL,
				name        VARCHAR(255),
				limit_type  INT NOT NULL,
				limit_date  DATE,
				limit_days  INT,
				show_type   INT,
				page_url    VARCHAR(255),
				page_source TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
			# limit type	0: Fixed date
			#				1: Less than designated days from today
			#				2: Less than designated days from entrydate
			# show type	0: Get url's contents
			#				1: View source

		'delivers' => {
			'period'	=> 'init',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				id               VARCHAR(8)   NOT NULL,
				his_no           INT,
				user_no          INT,
				temp_email       VARCHAR(255),
				temp_name        VARCHAR(255),
				INDEX id(id),
				INDEX his_no(his_no),
				INDEX user_no(user_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'delivered' => {
			'period'	=> 'init',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				id               VARCHAR(8)   NOT NULL,
				his_no           INT,
				user_no          INT,
				temp_email       VARCHAR(255),
				temp_name        VARCHAR(255),
				INDEX id(id),
				INDEX his_no(his_no),
				INDEX user_no(user_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'migration' => {
			'period'	=> 'init',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				id               VARCHAR(8)   NOT NULL UNIQUE,
				migration_mode   TINYINT      NOT NULL DEFAULT 0,
				destination_id   VARCHAR(8)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
		# migration mode	: 0 Wait for new stories created.
		#					: 1 Auto migration. (Only delete from source user list)
		#					: 2 Auto migration. (With registing to source black list)

		'cshis' => {
			'period'	=> 'init',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				id               VARCHAR(8)   NOT NULL,
				user_no          INT          NOT NULL,
				cs_no            INT          NOT NULL,
				INDEX id(id),
				INDEX user_no(user_no),
				INDEX cs_no(cs_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'bodytpl' => {	# 1.63
			'period'	=> 'init',
			'column'	=> '
				no      INT          AUTO_INCREMENT PRIMARY KEY,
				html    TINYINT      DEFAULT 0,
				nl2br   TINYINT      DEFAULT 0,
				title   VARCHAR(255),
				content TEXT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'smtp' => {	# 1.64
			'period'	=> 'init',
			'column'	=> '
				no             INT            AUTO_INCREMENT PRIMARY KEY,
				name           VARCHAR(255),
				smtp_server    VARCHAR(255),
				smtp_port      INT            DEFAULT 25,
				smtp_auth      TINYINT        DEFAULT 0,
				smtp_user      VARCHAR(255),
				smtp_pass      VARCHAR(255),
				smtp_prot      TINYINT        DEFAULT 0,
				smtp_envelope  TINYINT        DEFAULT 0, -- 2015-10-22
				smtp_check     TINYINT        DEFAULT 1,
				smtp_check_id  VARCHAR(8)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'formorder' => {	# 1.74
			'period'	=> 'init',
			'column'	=> '
				no               INT            AUTO_INCREMENT PRIMARY KEY,
				id               VARCHAR(8)     NOT NULL,
				type             TINYINT        NOT NULL       DEFAULT 0,
				modify           TINYINT        DEFAULT 0,
				fixed_form_name  VARCHAR(16)    NOT NULL,
				free_form_no     INT            NOT NULL,
				disp_order       INT UNSIGNED   NOT NULL
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},
		# 		type	: 0 fixed form.
		#				: 1 free form

		'accounts' => {	# 1.78 ～
			'period'	=> 'init',
			'column'	=> '
				no         INT AUTO_INCREMENT PRIMARY KEY,
				id         VARCHAR(8)     NOT NULL,
				asp_no     INT            NOT NULL,
				type       TINYINT,
				name       VARCHAR(255),
				insert_str VARCHAR(255),
				login_id   VARCHAR(255),
				login_pass VARCHAR(255),
				aff_id     VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},

		'oshis' => {	# 1.81
			'period'	=> 'init',
			'column'	=> '
				no         INT          AUTO_INCREMENT PRIMARY KEY,
				id         VARCHAR(8)   NOT NULL,
				user_no    INT          NOT NULL,
				his_no     INT          NOT NULL,
				INDEX user_no(user_no),
				INDEX his_no(his_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'cphis' => {	# 1.85
			'period'	=> 'init',
			'column'	=> '
				no         INT          AUTO_INCREMENT PRIMARY KEY,
				rec_time   DATETIME,
				login_id   VARCHAR(255) NOT NULL,
				ip         VARCHAR(255),
				user_agent VARCHAR(255),
				log        VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 0		# 1.85
		},

		'benefits' => {	# 1.85
			'period'	=> 'init',
			'column'	=> '
				no                  INT           AUTO_INCREMENT PRIMARY KEY,
				id                  VARCHAR(8)    NOT NULL,
				name                VARCHAR(255),
				exp                 TEXT,
				needed              INT,
				strage              VARCHAR(255),
				dl_count            INT,
				bene_sim_entry      TINYINT,
				bene_sim_entry_mags VARCHAR(255),
				entry               DATE
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'allow_copy' => 1		# 1.85
		},

	##########################################################

		#'accounts' => {
		#	'period'	=> 'cre_id',
		#	'column'	=> '
		#		no         INT AUTO_INCREMENT PRIMARY KEY,
		#		type       INT,
		#		name       VARCHAR(255),
		#		insert_str VARCHAR(255),
		#		login_id   VARCHAR(255),
		#		login_pass VARCHAR(255),
		#		aff_id     VARCHAR(255)
		#	',
		#	'option'	=> '
		#		ENGINE = MyISAM DEFAULT CHARSET = utf8
		#	',
		#	'type'		=> '(1)(2)(3)(4)'
		#},
		'user' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no          INT AUTO_INCREMENT PRIMARY KEY,
				active      TINYINT DEFAULT 1,
				name        VARCHAR(255),
				email       VARCHAR(255) NOT NULL UNIQUE,
				sex				TINYINT,
				birth			DATE,
				postal			VARCHAR(8),
				live_1			TINYINT,
				live_2			VARCHAR(255),
				phone			VARCHAR(16),
				job				TINYINT,
				marr			TINYINT,
				child			TINYINT,
				house			TINYINT,
				interest		VARCHAR(255),
				pet				TINYINT,
				pet_kind		VARCHAR(255),
				sports			VARCHAR(255),
				trouble		VARCHAR(255),
				uid				VARCHAR(255),
				upwd			VARCHAR(255),
				udevice	 TINYINT   DEFAULT 0, -- 1.81
				entry       DATE,
				regist_mode TINYINT DEFAULT 1,
				regist_from VARCHAR(16) DEFAULT \'0\',
				clicks      INT DEFAULT 0,
				points      INT DEFAULT 0,
				opens       INT DEFAULT 0, -- 1.81
				no_crypt    VARCHAR(255),
				next_story  INT DEFAULT 1,
				attri_1     INT DEFAULT 0,
				attri_2     INT DEFAULT 0,
				attri_3     INT DEFAULT 0,
				attri_4     INT DEFAULT 0,
				attri_5     INT DEFAULT 0,
				attri_6     INT DEFAULT 0,
				attri_7     INT DEFAULT 0,
				attri_8     INT DEFAULT 0,
				attri_9     INT DEFAULT 0,
				Host_not_exists     INT  DEFAULT 0,
				Connection_timeout  INT  DEFAULT 0,
				Account_not_exists  INT  DEFAULT 0,
				Mailbox_unavailable INT  DEFAULT 0,
				Server_error        INT  DEFAULT 0,
				Authen_error        INT  DEFAULT 0,
				Auto_return         INT  DEFAULT 0,
				Other               INT  DEFAULT 0,
				INDEX entry(entry),
				INDEX no_crypt(no_crypt),
				INDEX next_story(next_story)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)(3)',
			'allow_copy' => 0		# 1.85
		},
		'story' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				sort_no          INT,
				operate          TINYINT      NOT NULL DEFAULT 0,
				html             TINYINT      DEFAULT 0,
				lang             TINYINT      DEFAULT 0,
				nl2br            TINYINT      DEFAULT 0,
				os               TINYINT      DEFAULT 0, -- 1.81
				auto_sbj         TINYINT      DEFAULT 0,
				sbj_cont         VARCHAR(255),
				last_deliv       DATE,
				day_interval     INT,
				deliv_date_y     VARCHAR(8),
				deliv_date_yg    VARCHAR(5),
				deliv_date_m     VARCHAR(8),
				deliv_date_mg    TINYINT,
				deliv_aday       VARCHAR(7),
				deliv_time       TIME,
				define_header    TINYINT      DEFAULT 0,
				define_header_no INT,
				header           TEXT,
				body             TEXT,
				define_footer    TINYINT      DEFAULT 0,
				define_footer_no INT,
				footer           TEXT,
				cs               TINYINT      DEFAULT 0,
				excl_cs          VARCHAR(255),
				filter           TINYINT      DEFAULT 0,
				filter_cont      TEXT,
				excl_word        VARCHAR(255)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)',
			'allow_copy' => 1		# 1.85
		},
		'extra' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no               INT          AUTO_INCREMENT PRIMARY KEY,
				sort_no          INT,
				html             TINYINT      DEFAULT 0,
				lang             TINYINT      DEFAULT 0,
				nl2br            TINYINT      DEFAULT 0,
				os               TINYINT      DEFAULT 0, -- 1.81
				auto_sbj         TINYINT      DEFAULT 0,
				sbj_cont         VARCHAR(255),
				reserve_day      DATE,
				reserve_time     TIME,
				define_header    TINYINT      DEFAULT 0,
				define_header_no INT,
				header           TEXT,
				body             TEXT,
				define_footer    TINYINT      DEFAULT 0,
				define_footer_no INT,
				footer           TEXT,
				cs               TINYINT      DEFAULT 0,
				excl_cs          VARCHAR(255),
				filter           TINYINT      DEFAULT 0,
				filter_cont      TEXT,
				excl_word        VARCHAR(255),
				locked_pid       INT          DEFAULT 0,
				draft            TINYINT      DEFAULT 0
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)(3)',
			'allow_copy' => 0		# 1.85
		},
		'individual' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no        INT			AUTO_INCREMENT PRIMARY KEY,
				entry     DATETIME,
				html      TINYINT      DEFAULT 0,
				subject   VARCHAR(255),
				body      TEXT,
				users     INT
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(4)',
			'allow_copy' => 0		# 1.85
		},
		'cs' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no         INT          AUTO_INCREMENT PRIMARY KEY,
				redirect   VARCHAR(255) NOT NULL,
				tot_clicks INT          DEFAULT 0,
				c0         INT          DEFAULT 0,
				c1         INT          DEFAULT 0,
				c2         INT          DEFAULT 0,
				c3         INT          DEFAULT 0,
				c4         INT          DEFAULT 0,
				c5         INT          DEFAULT 0,
				c6         INT          DEFAULT 0,
				c7         INT          DEFAULT 0,
				c8         INT          DEFAULT 0,
				c9         INT          DEFAULT 0,
				c10        INT          DEFAULT 0,
				c11        INT          DEFAULT 0,
				c12        INT          DEFAULT 0,
				c13        INT          DEFAULT 0,
				c14        INT          DEFAULT 0,
				c15        INT          DEFAULT 0,
				c16        INT          DEFAULT 0,
				c17        INT          DEFAULT 0,
				c18        INT          DEFAULT 0,
				c19        INT          DEFAULT 0,
				c20        INT          DEFAULT 0,
				c21        INT          DEFAULT 0,
				c22        INT          DEFAULT 0,
				c23        INT          DEFAULT 0,
				his_no     INT,
				tgt_no     INT,
				entry      DATE,
				INDEX tot_clicks(tot_clicks),
				INDEX his_no(his_no)
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)(3)(4)',
			'allow_copy' => 0		# 1.85
		},
		'black' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no    INT          AUTO_INCREMENT PRIMARY KEY,
				email VARCHAR(255) NOT NULL UNIQUE,
				entry DATE
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)(3)',
			'allow_copy' => 0		# 1.85
		},

		'his' => {
			'period'	=> 'cre_id',
			'column'	=> '
				no                  INT   AUTO_INCREMENT PRIMARY KEY,
				story_no            INT   NOT NULL,
				d_type              INT,
				html                TINYINT   DEFAULT 0,
				lang                TINYINT   DEFAULT 0,
				nl2br               TINYINT   DEFAULT 0,
				os                  TINYINT   DEFAULT 0, -- 1.81
				deliv_day           DATE,
				deliv_aday          INT,
				deliv_time          TIME,
				subject             VARCHAR(1023),	-- save sbj
				body                TEXT,			-- save body
				auto_sbj            TINYINT      DEFAULT 0,
				sbj_cont            VARCHAR(255),
				define_header       TINYINT      DEFAULT 0,
				define_header_no    INT,
				header              TEXT,
				o_body              TEXT,
				define_footer       TINYINT      DEFAULT 0,
				define_footer_no    INT,
				footer              TEXT,
				cs                  TINYINT      DEFAULT 0,
				excl_cs             TEXT,
				filter              TINYINT      DEFAULT 0,
				filter_cont         TEXT,
				excl_word           VARCHAR(255),
				users               INT,
				done_users          INT,
				time_required       TIME,
				complete            TINYINT,
				pid                 INT,
				total_error         INT          DEFAULT 0,
				Host_not_exists     INT          DEFAULT 0,
				Connection_timeout  INT          DEFAULT 0,
				Account_not_exists  INT          DEFAULT 0,
				Mailbox_unavailable INT          DEFAULT 0,
				Server_error        INT          DEFAULT 0,
				Authen_error        INT          DEFAULT 0,
				Auto_return         INT          DEFAULT 0,
				Other               INT          DEFAULT 0,
				unlink              INT          DEFAULT 0,
				idms                TINYINT      DEFAULT 0,
				continue_uxpctd     TINYINT      DEFAULT 0, -- 1.80
				tot_open            INT          DEFAULT 0  -- 1.81
			',
			'option'	=> '
				ENGINE = MyISAM DEFAULT CHARSET = utf8
			',
			'type'       => '(1)(2)(3)',
			'allow_copy' => 0		# 1.85
		}

		#'benefits' => {
		#	'period'	=> 'cre_id',
		#	'column'	=> '
		#		no                  INT   AUTO_INCREMENT PRIMARY KEY,
		#		name                VARCHAR(255),
		#		exp                 TEXT,
		#		needed              INT,
		#		strage              VARCHAR(255),
		#		dl_count            INT,
		#		bene_sim_entry      TINYINT,
		#		bene_sim_entry_mags VARCHAR(255),
		#		entry               DATE
		#	',
		#	'option'	=> '
		#		ENGINE = MyISAM DEFAULT CHARSET = utf8
		#	',
		#	'type'       => '(1)(2)(3)',
		#	'allow_copy' => 1		# 1.85
		#}
	);
	return \%tbl;
}

1;


