###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Inc. owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package ver;

use strict;

our $release = '2016-04-05';
our $version = '0.96';
our $changes = <<CHGS;
・[脆弱性対応:JPCERT#58345231]SQLインジェクション対策を実施
・1クリック再登録処理時、一部のパラメタが正常に処理されない場合がある不具合を修正
CHGS
our @req = (
	# lib
	['lib/action_1.pl'	,'con'	,'rof'	,''],
	['lib/action_2.pl'	,'con'	,'rof'	,''],
	['lib/action_3.pl'	,'con'	,'rof'	,''],
	['lib/asp.pl'			,'con'	,'rof'	,''],
	['lib/auto.pl'		,'con'	,'rof'	,''],
	['lib/check.pl'		,'con'	,'rof'	,''],
	['lib/cp.pl'			,'con'	,'rof'	,''],
	['lib/db.pl'			,'con'	,'rof'	,''],
	['lib/get.pl'			,'con'	,'rof'	,''],
	['lib/item.pl'		,'con'	,'rof'	,''],
	['lib/mobile.pl'		,'con'	,'rof'	,''],
	['lib/proc.pl'		,'con'	,'rof'	,''],
	['lib/save.pl'		,'con'	,'rof'	,''],
	['lib/show.pl'		,'con'	,'rof'	,''],
	['lib/start.pl'		,'con'	,'rof'	,''],
	['lib/switch.pl'		,'con'	,'rof'	,''],
	['lib/tbl.pl'			,'con'	,'rof'	,''],
	['lib/ver.pl'			,'con'	,'rof'	,''],
	['lib/default.pl'		,'con'	,'rof'	,''],
	['lib/idms.pl'		,'con'	,'rof'	,''],	# 1.56～ For OEM
	['lib/ajax.pl'		,'con'	,'rof'	,''],	# 1.62～
	['lib/db_common.pl'	,'con'	,'rof'	,''],	# Urgent correction
	# current exe file
	['index.cgi'			,'con'	,'exe'	,''],
	['action.cgi'			,'con'	,'exe'	,''],
	['form_if.cgi'		,'con'	,'exe'	,''],
	['install.cgi'		,'con'	,'exe'	,''],
	['dlc.cgi'				,'con'	,'exe'	,''],
	['karame.cgi'			,'con'	,'exe'	,''],
	['defchk.cgi'			,'con'	,'exe'	,''],
	['lmtdchk.cgi'		,'con'	,'exe'	,''],	# 1.52~
	['proc_bounce.cgi'	,'con'	,'exe'	,''],	# 1.57~ For OEM
	['qr.cgi'				,'con'	,'exe'	,''],	# 1.78~
	['os.cgi'				,'con'	,'exe'	,''],	# 1.81~
	['command.sh'			,'con'	,'sh'	,''],	# 1.84~
	# current lib file
	['config.cgi'			,'con'	,'rof'	,''],
	['def_config.cgi'		,'con'	,'rof'	,''],
	['.htaccess'			,'con'	,'rof'	,''],
	['preview_html.html'	,'con'	,'rof'	,''],	# 1.68～
	['dnschk.html'		,'con'	,'rof'	,''],	# 1.84～
	['backup/.htaccess'	,'con'	,'rof'	,''],	# 1.83～
	# current exe file variable name
#['sample1.cgi'		,'var'	,'exe'	,$config::def_sample1,	'サンプルプログラムファイルその１',	'def_sample1'	],	# develop
#['sample2.cgi'		,'var'	,'exe'	,$config::def_sample2,	'サンプルプログラムファイルその２',	'def_sample2'	],	# develop
	['reg.cgi'			,'var'	,'exe'	,$config::def_reg,	'読者登録,登録解除処理用プログラムファイル',	'def_reg'	],
	['rm.cgi'			,'var'	,'exe'	,$config::def_rm,		'読者登録解除処理用プログラムファイル',			'def_rm'	],
	['cs.cgi'			,'var'	,'exe'	,$config::def_cs,		'短縮URL処理用プログラムファイル',				'def_cs'	],
	['bcn.cgi'			,'var'	,'exe'	,$config::def_bcn,	'バックナンバー閲覧用プログラムファイル',		'def_bcn'	],
	['lmtd.cgi'		,'var'	,'exe'	,$config::def_lmtd,	'期間限定ページ出力用プログラムファイル',		'def_lmtd'	]	# Ver 1.52~
);

our @REQ = (
	['Digest::MD5',	0,	1,	'暗号化を行うCrypt::CBCモジュールなどが動作するのに必要です。'		],
	['CGI',			0,	1,	'パラメータの受け渡し等に必須です。' 								],
	['CGI::Cookie',	0,	1,	'セッション管理等に必須です。'										],
	['DBI',			0,	1,	'データベースドライバと連携するために必要です。'					],
	['DBD::mysql',	0,	1,	'MySQLデータベースと連携するために必要です。'						],
	['Scalar::Util',	0,	1,	'テンプレートエンジン（HTML::Template）が動作するのに必要です。'	]
   );
our @OPT = (
	['Archive::Zip',				0,	0,	'データベースのバックアップ＆リストア、及びシステムのワンクリックバージョンアップを行うために必要です。' ],
	['LWP::UserAgent',			0,	0,	'記事の自動取得、自動代理登録、システムのワンクリックバージョンアップ、期間限定ページ（URL指定）の作成を行うために必要です。' ],
	['HTTP::Request::Common',	0,	0,	'記事の自動取得、自動代理登録、システムのワンクリックバージョンアップ、期間限定ページ（URL指定）の作成を行うために必要です。' ],
	['HTTP::Cookies',				0,	0,	'記事の自動取得、自動代理登録、期間限定ページ（URL指定）の作成を行うために必要です。' ],
	['IO::Socket::SSL',			0,	0,	'エラーメール処理時やSMTPサーバを指定してのメール送信時、SSLでPOP/SMTPに接続する場合に必要です。' ],
	['Authen::SASL',				0,	0,	'SMTPサーバを指定してのメール送信時、SMTP認証を行う場合に必要です。' ],
	['Net::SSLeay',				0,	0,	'SSL通信を利用するオプションスクリプト（Infotop.pmなど）を用いて記事の自動取得を行う場合、SSLの期間限定ページ（URL指定）を作成する場合に必要です。ただしCrypt::SSLeayモジュールがインストールされていれば必要ありません。' ],
	['Crypt::SSLeay',				0,	0,	'SSL通信を利用するオプションスクリプト（Infotop.pmなど）を用いて記事の自動取得を行う場合、SSLの期間限定ページ（URL指定）を作成する場合に必要です。ただしNet::SSLeayモジュールがインストールされていれば必要ありません。' ],
	['GD',							0,	0,	'QRコードなどの画像出力に必要です' ]

	);

1;
