#!/usr/bin/perl
###########################################################################
# This file is a copyrighted work is protected by copyright law.
# Igreks Communications owns the copyrights in this.
# Copying or modification of the code of this file is prohibited.
# Copyright owner, developer and seller is not responsible for
# any problems caused by copying or modification of the user.
###########################################################################
package main;

use strict;
use lib qw(./asp_opt ./ext_lib);
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use Unicode::Japanese;
require "./config.cgi";
require "./lib/get.pl";
require "./lib/check.pl";
require "./lib/proc.pl";
require "./lib/show.pl";
require "./lib/cp.pl";
require "./lib/db.pl";
require "./lib/start.pl";
require "./lib/auto.pl";
require "./lib/asp.pl";
require "./lib/item.pl";
require "./lib/default.pl";

$| = 1;
my $F = CGI->new();
my $pd = $F->Vars;
&db::open();

if( !$$pd{m} || !$$pd{u} ){
	&show::err_msg("
		<p>パラメータ情報に不備があります。</p>\n
		<p>WEB管理者までお問い合わせください。</p>\n
	");	
}
# Get setting data
my $stg = &get::setting_data();
my $dd  = &get::delivery();
if(!$stg){
	&show::err_msg("
		<p>メールマガジンが存在しないか、すでに廃刊されています。</p>
		<p>詳しくは発行者までお問い合わせください。</p>
	");
}
# Check user table
# 1.86 #####
#&db::query("SELECT *	FROM `ms_user_$$pd{m}` WHERE no_crypt='$$pd{u}' AND active = 1");
&db::query(
	"SELECT * FROM `ms\_user\_$$pd{m}`
	 WHERE no_crypt = ? AND active = 1",
	[ {value => $$pd{u}} ]
);
############
my $ud = $db::sth->fetchrow_hashref();
if(!$ud){
	if($$stg{ulk_fini_url2}){
		print "Location: $$stg{ulk_fini_url2}\n\n";
		exit;
	}
	else{
		&show::err_msg("メールアドレスが登録されていないか、すでに配信解除済みです。");
	}
}
# Unlink Alert
if(!$$pd{exe_unlink} && $$stg{unlink_alert}){
	my $ulk_exe_btn = <<FORM;
		<form action='\[__DEL_PATH__\]' method='post'>
			<input type='submit' name='exe_unlink' value=' O K ' class='btn' />
			<input type='hidden' name='m' value='$$pd{m}' />
			<input type='hidden' name='u' value='$$pd{u}' />
			<input type='hidden' name='h' value='$$pd{h}' />
		</form>
FORM
	&show::rm_Alert(
		$$ud{email},
		$ulk_exe_btn
	);
}
# Send mail unlink completed
if($$stg{ulk_msg} == 1){
	undef $$stg{unlink};
	&start::return_mail(
		$ud,
		$stg,	
		&get::ulk_msg_cont(),
		$dd	
	);
}
# Report to admin
$$pd{mode} = 'one_clk';
&start::report_reg_rm($stg,$dd,$ud,$pd);

# Set hidden parameters of Re-Entry
my $hidden_free = '';
# 1.86 ###
#&db::query("
#	SELECT * FROM `ms_freeusersinfo`
#	WHERE id = '$$pd{m}' AND user_no = $$ud{no}
#");
&db::query(
	"SELECT * FROM `ms\_freeusersinfo`
	 WHERE id = ? AND user_no = ?",
	[
		{value => $$pd{m} },
		{value => $$ud{no}}
	]
);
##########
while(my $href = $db::sth->fetchrow_hashref()){
	$hidden_free .= "<input type='hidden' name='free_$$href{form_no}_$$href{form_type}' value='$$href{parts_cont}' />\n";
}

if($$stg{treat_ulk} == 1){
	# Drop user
	# 1.86 ######
	#&db::query("
	#	DELETE		`ms_user_$$pd{m}`,`ms_freeusersinfo`
	#	FROM		`ms_user_$$pd{m}`
	#	LEFT JOIN	`ms_freeusersinfo`
	#	/**********************************************************************/
	#	-- ON		`ms_user_$$pd{m}`.no  = `ms_freeusersinfo`.user_no
	#	ON			`ms_user_$$pd{m}`.no  = `ms_freeusersinfo`.user_no AND
	#				`ms_freeusersinfo`.id = '$$pd{m}'
	#	/**********************************************************************/
	#	WHERE		`ms_user_$$pd{m}`.no_crypt = '$$pd{u}'
	#");
	&db::query(
		"DELETE     `ms\_user\_$$pd{m}`, `ms\_freeusersinfo`
		 FROM		`ms\_user\_$$pd{m}`
		 LEFT JOIN	`ms\_freeusersinfo`
		 ON         `ms\_user\_$$pd{m}`.no = `ms\_freeusersinfo`.user_no AND
		            `ms\_freeusersinfo`.id = ?
		 WHERE      `ms_user_$$pd{m}`.no_crypt = ?",
		[
			{value => $$pd{m}},
			{value => $$pd{u}}
		]
	);
	#############
	if($$stg{black} == 1){
		# Entry blacklist
		# 1.68 #####
		#&db::query("
		#	INSERT IGNORE INTO `ms_black_$$pd{m}` (
		#		no,
		#		email,
		#		entry
		#	)
		#	VALUES(
		#		'',
		#		'$$ud{email}',
		#		CURRENT_DATE()
		#	)
		#");
		&db::query(
			"INSERT IGNORE INTO `ms\_black\_$$pd{m}` (
				no, email, entry
			) VALUES (
				'', ?, CURRENT_DATE()
			)",
			[ {value => $$ud{email}} ]
		);
		###########
	}
}
else{
	# Stop
	# 1.86 #####
	#&db::query("
	#	UPDATE `ms_user_$$pd{m}` SET active = 0
	#	WHERE email = '$$ud{email}'
	#");
	&db::query(
		"UPDATE `ms\_user\_$$pd{m}`
		 SET   active = 0
		 WHERE email = ?",
		[ {value => $$ud{email}} ]
	);
	############
}
# Set history data
if($$pd{'h'}){
	# 1.86 #####
	#&db::query("
	#	UPDATE	`ms_his_$$pd{m}`
	#	SET		unlink = unlink + 1 
	#	WHERE	no = $$pd{h}
	#");
	&db::query(
		"UPDATE `ms\_his\_$$pd{m}`
		 SET     unlink = unlink + 1 
		 WHERE   no = ?",
		[ {value => $$pd{h}} ]
	);
	############
}
####### Show result
if($$stg{ulk_fini_url1}){
	print "Location: $$stg{ulk_fini_url1}\n\n";
}
else{
	my $form_again = <<EOM;
		<form action='\[__REGIST_PATH__\]' method='post' />
			<input type='submit' name='' value='購読を再開する' class='btn' />
			<input type='hidden' name='mode' value='1' />
			<input type='hidden' name='id' value='$$pd{m}' />
			<input type='hidden' name='again' value='1' />
			<input type='hidden' name='charset' value='utf8' />
EOM
	foreach(keys %$ud){
		$$ud{$_} = &proc::conv_html_ref_2($$ud{$_});	############## 1.67
		$form_again .= "<input type='hidden' name='$_' value='$$ud{$_}' />\n";
	}
	$form_again .= $hidden_free."</form>\n";
	&show::rm_OKmsg(
		$$ud{email},
		$form_again
	);
}
&db::close();
exit;
1;

