<!-- show notice start -->
<TMPL_IF NAME='notice_msg'>
	<script type='text/javascript'>var notice_msg = new Array(<TMPL_VAR NAME='notice_msg'>);</script>
	<script type='text/javascript' src='./js/notice_msg.js'></script>
</TMPL_IF>
<!-- show notice end -->
<script type='text/javascript'>
$(function(){
	// Change size of QR-code
	$('div#main input#qr_size').click(function(){
		var qr_img = $('div#main img#qr_img.' + $(this).attr('name'));
		var size = $(this).val();
		$(qr_img).each(function(){
			$(this).attr('src', $(this).attr('src').replace(/qr_size=[0-9]+/gi, 'qr_size=' + size));
		});
	});
});
</script>
<div class='<TMPL_VAR NAME='$switch::cap_main'>'>
	<ul class='cap_main'>
		<li class='top'><a href='?mode=ch_type&type=<TMPL_VAR NAME='$$fd{type}'>'><TMPL_VAR NAME='$type'>の設定</a></li>
		<li class='sub'><a href='?mode=show_state&id=<TMPL_VAR NAME='$$fd{id}'>&type=<TMPL_VAR NAME='$$fd{type}'>'><TMPL_VAR NAME='$$fd{id}'></a></li>
		<li class='sub'>空メール用リンク取得</li>
	</ul>
</div>

<form action='' method='post'>
<TMPL_UNLESS NAME='$config::oem'>
	<div class='desc'>
		空メール機能を利用するには、あらかじめメールサーバのエイリアス設定（パイプ設定）が必要です。<br />
		共用のレンタルサーバ等では、これをサポートしていない場合があります。事前にサーバ管理者までお問い合わせください。<br />
	</div>
</TMPL_UNLESS>
	<table class='nor'>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='30%'>利用の許可</td>
			<td class='cont'>
				<label>
					<input type='checkbox' name='karame_permit' value='1' <TMPL_VAR NAME='karame_permit_1'> />
					空メールでの登録・解除を許可する
				</label>
			</td>
			<td><a id='help' name='karame_permit'></a></td>
		</tr>
<TMPL_UNLESS NAME='$config::oem'>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>'>
				登録用の空メール送信先アドレス
			</td>
			<td class='cont'>
				<input type='text' class='<TMPL_VAR NAME='$switch::txt'>' name='karame_add' value='<TMPL_VAR NAME='$$stg{karame_add}'>' />
			</td>
			<td><a id='help' name='karame_add'></a></td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>'>
				解除用の空メール送信先アドレス
			</td>
			<td class='cont'>
				<input type='text' class='<TMPL_VAR NAME='$switch::txt'>' name='karame_add2' value='<TMPL_VAR NAME='$$stg{karame_add2}'>' />
			</td>
			<td><a id='help' name='karame_add2'></a></td>
		</tr>
</TMPL_UNLESS>
	</table>
	<div class='btn'>
		<input type='submit' class='<TMPL_VAR NAME='$switch::btn'>' name='save_karame_setting' value='保　存' />
	</div>
	<input type='hidden' name='id' value='<TMPL_VAR NAME='$$fd{id}'>' />
	<input type='hidden' name='type' value='<TMPL_VAR NAME='$$fd{type}'>' />
</form>

<TMPL_UNLESS NAME='$config::oem'>
	<div class='desc'>
		メールサーバのエイリアス設定ファイル（/etc/aliases など）を編集できる場合、以下のテキストをエイリアス設定ファイルに追加してください。<br />
		エイリアス設定ファイルの場所は、各サーバによって異なりますので事前にサーバ管理者に確認してください。<br />
		サーバのroot権限等が無く、エイリアス設定ファイルを編集できない場合は、以下の手順を参考にして設定してください。<br />
		<br />
		あらかじめ、登録用空メールの送信先アドレスと解除用空メール送信先アドレスを作成しておきます。
		仮に、登録用空メール送信先を「karame_reg@example.com」、解除用空メール送信先を「karame_rm@example.com」とします。<br />
		<br />
		■メールサーバがqmailの場合<br />
		<ol>
			<li>「.qmail」という名前のファイルを新規に作成する</li>
			<li>ファイル内に下記の登録用コマンドの「:」以降の文字列（"|cd /***/; karame.cgi reg"）を記述し保存する。</li>
			<li>解除用の「.qmail」ファイルも同様に作成し保存する。</li>
			<li>「karame_reg」のホームディレクトリの直下または「karame_reg」専用のメールディレクトリ直下に、2.のファイルをアップロードする。</li>
			<li>解除用のファイルも同様にアップロードする。</li>
		</ol>
		■メールサーバがpostfix,sendmail,eximなどの場合<br />
		<ol>
			<li>「.forward」という名前のファイルを新規に作成する</li>
			<li>ファイル内に下記の登録用コマンドの「:」以降の文字列（"|cd /***/; karame.cgi reg"）を記述し保存する。</li>
			<li>解除用の「.forward」ファイルも同様に作成し保存する。</li>
			<li>「karame_reg」のホームディレクトリの直下または「karame_reg」専用のメールディレクトリ直下に、2.のファイルをアップロードする。</li>
			<li>解除用のファイルも同様にアップロードする。</li>
		</ol>
		ご使用のサーバによっては、プログラムファイルへの転送処理を禁止している場合があります。また、上記の「.qmail」「.forward」というファイル名は一般的な名称で、サーバによってはこれらの転送用ファイルの名前が指定されている場合もあります。<br />
		詳しくはサーバ管理者までお問い合わせください。<br />
	</div>
	<table class='nor'>
		<tr>
			<td align='center' colspan='2'><b>エイリアス設定用コマンド（例）</b></td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<input type='text' class='<TMPL_VAR NAME='$switch::txt'>' name='' value='<TMPL_VAR NAME='$acc1'>:	"|cd <TMPL_VAR NAME='$ab_dir'>; ./karame.cgi reg"' />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<input type='text' class='<TMPL_VAR NAME='$switch::txt'>' name='' value='<TMPL_VAR NAME='$acc2'>:	"|cd <TMPL_VAR NAME='$ab_dir'>; ./karame.cgi rm"' />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='2'>&nbsp;</td></tr>
	</table>

	<div class='<TMPL_VAR NAME='$switch::cap_sub'>'>
		<ul class='cap_main'>
			<li class='top'>拡張アドレスが利用できる場合</li>
		<ul>
	</div>
	<div class='annotation'>
		ご利用中のサーバで「karame_reg+abc@example.com」や「karame_reg+xyz@example.com」などを1つのメールアドレス「karame_reg@example.com」で受信できる場合、拡張アドレスの利用が可能です。拡張アドレスの利用可否については、サーバ管理者までお問い合わせください。<br />
		拡張アドレスのデリミタ（区切り文字）は<a href='?mode=show_sys_info&type=0.9'>環境設定</a>から変更が可能です。
	</div>
</TMPL_UNLESS>

	<table class='nor'>
		<tr>
			<td align='center' colspan='3'><span id='mailto_code_ext'><b>mailtoリンクのHTMLコード</b></span></td>
			<td width='16'><a id='help' name='mailto_code_ext'></a></td>
		</tr>
		<tr>
		<TMPL_UNLESS NAME='$config::oem'>
		<tr>
			<td colspan='4'>
				エイリアス設定完了後、以下のコードをコピーしてWEB上のメーラーを起動させたい場所に貼り付けてください。
			</td>
		</tr>
		</TMPL_UNLESS>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont' colspan='3'>
				<TMPL_IF NAME='$$stg{karame_add}'>
<!--
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_link_ext'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※件名にはお名前を指定することができます。&lt;br /&gt;
※お名前を入力する場合は、姓と名はスペースで区切ってください。&lt;br /&gt;
※宛先は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
-->
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_add_ext'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※件名にはお名前を指定することができます。&lt;br /&gt;
※お名前を入力する場合は、姓と名はスペースで区切ってください。&lt;br /&gt;
※宛先は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='3'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
<!--
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_link2_ext'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※宛先は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
-->
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_add2_ext'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※宛先は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='4'>&nbsp;</td></tr>
		<tr>
			<td align='center' colspan='3'><span id='mailto_preview_ext'><b>mailtoリンクのプレビュー</b></span></td>
			<td width='16'><a id='help' name='mailto_preview_ext'></a></td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont' colspan='3'>
				<TMPL_IF NAME='$$stg{karame_add}'>
<!--
					<a href='mailto:<TMPL_VAR NAME='$karame_link_ext'>'>こちら</a>から空メールを送信してください。<br />			
-->
					<a href='mailto:<TMPL_VAR NAME='$karame_add_ext'>'>こちら</a>から空メールを送信してください。<br />			
					※件名にはお名前を指定することができます。<br />
					※お名前を入力する場合は、姓と名はスペースで区切ってください。<br />
					※宛先は変更せずにそのまま送信してください。<br />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='3'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
<!--
					<a href='mailto:<TMPL_VAR NAME='$karame_link2_ext'>'>こちら</a>から空メールを送信してください。<br />			
-->
					<a href='mailto:<TMPL_VAR NAME='$karame_add2_ext'>'>こちら</a>から空メールを送信してください。<br />			
					※宛先は変更せずにそのまま送信してください。<br />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='4'>&nbsp;</td></tr>
		<tr>
			<td colspan='4'>
				※aタグに囲まれた部分や、説明部分などはご自身の環境にあわせて書き換えてください。
			</td>
		</tr>
		<tr><td colspan='4'>&nbsp;</td></tr>
	</table>

	<table class='nor'>
		<tr>
			<td align='center' colspan='4'><span id='induce_ext'><b>空メール送信ページのQRコード</b></span></td>
			<td width='16'><a id='help' name='induce_ext'></a></td>
		</tr>

		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='induce_ext' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='induce_ext' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='induce_ext' value='4' /> 大</label>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='induce_ext' src='./qr.cgi?qr_str=<TMPL_VAR NAME='induce_path_ext'>&qr_size=2' />
						<TMPL_ELSE>
							※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>
					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext4'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='induce_ext' src='./qr.cgi?qr_str=<TMPL_VAR NAME='induce_path2_ext'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>
					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='5'>&nbsp;</td></tr>

		<tr>
			<td align='center' colspan='4'><span id='link_ext'><b>mailtoリンクのQRコード</b></span></td>
			<td width='16'><a id='help' name='link_ext'></a></td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='link_ext' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='link_ext' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='link_ext' value='4' /> 大</label>
			</td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext3'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='link_ext' src='./qr.cgi?qr_str=mailto%3a<TMPL_VAR NAME='$karame_add_ext'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext4'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='link_ext' src='./qr.cgi?qr_str=mailto%3a<TMPL_VAR NAME='$karame_add2_ext'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>
					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='5'>&nbsp;</td></tr>
		<tr>
			<td align='center' colspan='4'><span id='mailer_ext'><b>メーラ直接起動用QRコード</b></span></td>
			<td width='16'><a id='help' name='mailer_ext'></a></td>
		</tr>
		<tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='mailer_ext' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='mailer_ext' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='mailer_ext' value='4' /> 大</label>
			</td>
		</tr>
		<!-- Size change button -->
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用<br />（docomo）</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext1'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<!-- For docomo -->
							<img id='qr_img' class='mailer_ext' src='./qr.cgi?qr_str=MATMSG%3aTO%3a<TMPL_VAR NAME='$karame_add_ext'>%3b%3b&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用<br />（docomo）</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext2'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<!-- For docomo -->
							<img id='qr_img' class='mailer_ext' src='./qr.cgi?qr_str=MATMSG%3aTO%3a<TMPL_VAR NAME='$karame_add2_ext'>%3b%3b&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用<br />（au,softbank）</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext1'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<!-- For au,softbank -->
							<img id='qr_img' class='mailer_ext' src='./qr.cgi?qr_str=MAILTO%3a<TMPL_VAR NAME='$karame_add_ext'>%%NL%%&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用<br />（au,softbank）</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext2'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<!-- For au,softbank -->
							<img id='qr_img' class='mailer_ext' src='./qr.cgi?qr_str=MAILTO%3a<TMPL_VAR NAME='$karame_add2_ext'>%%NL%%&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='5'>&nbsp;</td></tr>
		<tr>
			<td colspan='5'>用途に応じて、上記のリンク・QRコードをご利用ください。QRコードは右クリック→「名前をつけて画像を保存」してご利用ください。</td>
		</tr>
		<tr>
			<td colspan='5'>メーラ直接起動用のQRコードは、各キャリア定める仕様で作成されています。スマートフォンなどの場合で正常に読み取りができない場合は、各キャリアが定めるメーラ起動コードを正常に認識できるアプリを利用するか、mailtoリンクまたはmailtoリンクのQRコードをご利用下さい。</td>
		</tr>
		<tr><td colspan='5'>&nbsp;</td></tr>
	</table>

<TMPL_UNLESS NAME='$config::oem'>
	<div class='<TMPL_VAR NAME='$switch::cap_sub'>'>
		<ul class='cap_main'>
			<li class='top'>拡張アドレスが利用できない場合</li>
		<ul>
	</div>
	<div class='annotation'>
		拡張アドレスが利用できない場合、空メールの本文にID情報を追加することで登録/解除先の判別が可能です。
	</div>
	<table class='nor'>
		<tr>
			<td align='center' colspan='2'><span id='mailto_code'><b>mailtoリンクのHTMLコード</b></span></td>
			<td width='16'><a id='help' name='mailto_code'></a></td>
		</tr>
		<tr>
		<tr>
			<td colspan='3'>
				エイリアス設定完了後、以下のコードをコピーしてWEB上のメーラーを起動させたい場所に貼り付けてください。
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add}'>
<!--
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_link_noext'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※件名にはお名前を指定することができます。&lt;br /&gt;
※お名前を入力する場合は、姓と名はスペースで区切ってください。&lt;br /&gt;
※宛先、本文は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
-->
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_add'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※件名にはお名前を指定することができます。&lt;br /&gt;
※お名前を入力する場合は、姓と名はスペースで区切ってください。&lt;br /&gt;
※宛先、本文は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
<!--
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_link2_noext'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※宛先、件名、本文は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
-->
					<textarea class='<TMPL_VAR NAME='$switch::ta'>' rows='5'>&lt;a href='mailto:<TMPL_VAR NAME='$karame_add2'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'&gt;こちら&lt;/a&gt;から空メールを送信してください。&lt;br /&gt;			
※宛先、件名、本文は変更せずにそのまま送信してください。&lt;br /&gt;</textarea>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='3'>&nbsp;</td></tr>

		<tr>
			<td align='center' colspan='2'><span id='mailto_preview'><b>mailtoリンクのプレビュー</b></span></td>
			<td width='16'><a id='help' name='mailto_preview'></a></td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add}'>
<!--
					<a href='mailto:<TMPL_VAR NAME='$karame_link_noext'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'>こちら</a>から空メールを送信してください。<br />			
-->
					<a href='mailto:<TMPL_VAR NAME='$karame_add'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'>こちら</a>から空メールを送信してください。<br />			
					※件名にはお名前を指定することができます。<br />
					※お名前を入力する場合は、姓と名はスペースで区切ってください。<br />
					※宛先、本文は変更せずにそのまま送信してください。<br />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
<!--
					<a href='mailto:<TMPL_VAR NAME='$karame_link2_noext'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'>こちら</a>から空メールを送信してください。<br />
-->
					<a href='mailto:<TMPL_VAR NAME='$karame_add2'>?body=ms_mid:<TMPL_VAR NAME='$$fd{id}'>'>こちら</a>から空メールを送信してください。<br />
					※宛先、件名、本文は変更せずにそのまま送信してください。<br />
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='3'>&nbsp;</td></tr>
		<tr>
			<td colspan='3'>
				※aタグに囲まれた部分や、説明部分などはご自身の環境にあわせて書き換えてください。<br />
				※「?body='●●'」の●●部分を編集する場合で日本語を利用する場合は、URLエンコードを行ったものを張り付けます。<br />
				※URLエンコードを行う際、文字コードはDocomo・auの場合はシフトJIS、Softbankの場合はUTF8にする必要があります。<br />
			</td>
		</tr>
		<tr><td colspan='3'>&nbsp;</td></tr>
	</table>

	<table class='nor'>
		<tr>
			<td align='center' colspan='4'><span id='induce'><b>空メール送信ページのQRコード</b></span></td>
			<td width='16'><a id='help' name='induce'></a></td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='induce' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='induce' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='induce' value='4' /> 大</label>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='induce' src='./qr.cgi?qr_str=<TMPL_VAR NAME='induce_path'>&qr_size=2' />
						<TMPL_ELSE>
							※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>
					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr_ext4'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='induce' src='./qr.cgi?qr_str=<TMPL_VAR NAME='induce_path2'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>
					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='4'>&nbsp;</td></tr>

		<tr>
			<td align='center' colspan='4'><span id='link'><b>mailtoリンクのQRコード</b></span></td>
			<td width='16'><a id='help' name='link'></a></td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='link' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='link' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='link' value='4' /> 大</label>
			</td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr3'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='link' src='./qr.cgi?qr_str=mailto%3a<TMPL_VAR NAME='$karame_add'>%3fbody%3dms_mid%3a<TMPL_VAR NAME='$$fd{id}'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr4'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='link' src='./qr.cgi?qr_str=mailto%3a<TMPL_VAR NAME='$karame_add2'>%3fbody%3dms_mid%3a<TMPL_VAR NAME='$$fd{id}'>&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='4'>&nbsp;</td></tr>
		<tr>
			<td align='center' colspan='4'><span id='mailer'><b>メーラ直接起動用QRコード</b></span></td>
			<td width='16'><a id='help' name='mailer'></a></td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>サイズ</td>
			<td class='cont' colspan='4'>
				<label><input type='radio' id='qr_size' name='mailer' value='2' checked /> 小</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='mailer' value='3' /> 中</label>&nbsp;&nbsp;&nbsp;&nbsp;
				<label><input type='radio' id='qr_size' name='mailer' value='4' /> 大</label>
			</td>
		</tr>
		<!-- Size change button -->
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用<br />(docomo)</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr1'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='mailer' src='./qr.cgi?qr_str=MATMSG%3aTO%3a<TMPL_VAR NAME='$karame_add'>%3bSUB%3a%3bBODY%3ams_mid%3a<TMPL_VAR NAME='$$fd{id}'>%3b%3b&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用<br />(docomo)</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr2'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='mailer' src='./qr.cgi?qr_str=MATMSG%3aTO%3a<TMPL_VAR NAME='$karame_add2'>%3bSUB%3a%3bBODY%3ams_mid%3a<TMPL_VAR NAME='$$fd{id}'>%3b%3b&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>登録用<br />(au,softbank)</td>
			<td class='cont'>
				<TMPL_IF NAME='$$stg{karame_add}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr1'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='mailer' src='./qr.cgi?qr_str=MAILTO%3a<TMPL_VAR NAME='$karame_add'>%%NL%%BODY%3ams_mid%3a<TMPL_VAR NAME='$$fd{id}'>%%NL%%SUBJECT%3a%%NL%%&qr_size=2' />

						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						登録用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
			<td class='<TMPL_VAR NAME='$switch::th'>' width='100'>解除用<br />(au,softbank)</td>
			<td class='cont' colspan='2'>
				<TMPL_IF NAME='$$stg{karame_add2}'>
					<TMPL_IF NAME='&check::gd_mod()'>
<!--
						<TMPL_VAR NAME='$qr2'>
-->
						<TMPL_IF NAME='&check::gd_support()'>
							<img id='qr_img' class='mailer' src='./qr.cgi?qr_str=MAILTO%3a<TMPL_VAR NAME='$karame_add2'>%%NL%%BODY%3ams_mid%3a<TMPL_VAR NAME='$$fd{id}'>%%NL%%SUBJECT%3a%%NL%%&qr_size=2' />
						<TMPL_ELSE>
※ご利用中のGDライブラリがgif/png/jpeg形式をサポートしていません。
						</TMPL_IF>

					<TMPL_ELSE>
						※サーバにGDモジュールがインストールされていないためQRコードを表示できません。
					</TMPL_IF>
				<TMPL_ELSE>
					<span style='color:#ff0000;'>
						解除用空メールの送信先アドレスが設定されていません。<br />
						上記フォームに空メール送信先アドレスを入力し、「保存」ボタンをクリックしてください
					</span>
				</TMPL_IF>
			</td>
		</tr>
		<tr><td colspan='5'>&nbsp;</td></tr>
		<tr>
			<td colspan='5'>用途に応じて、上記のリンク・QRコードをご利用ください。QRコードは右クリック→「名前をつけて画像を保存」してご利用ください。</td>
		</tr>
		<tr>
			<td colspan='5'>メーラ直接起動用のQRコードは、各キャリア定める仕様で作成されています。スマートフォンなどの場合で正常に読み取りができない場合は、各キャリアが定めるメーラ起動コードを正常に認識できるアプリを利用するか、mailtoリンクまたはmailtoリンクのQRコードをご利用下さい。</td>
		</tr>
	</table>
</TMPL_UNLESS>

